#!/bin/sh
#
# file tst06.sh 
# (test job dependencies)
#
#      Diogene87
#	Copyright (C) 2003,2004,2005 - Dominique Parisot
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this software; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
# Boston, MA 02111-1307 USA
#


if [ "$srcdir" = "" ]; then srcdir="."; fi
. $srcdir/functions.sh
checkNoDaemon

echo "test job dependencies"

startDio87d || exit 1
#dio87d -N -C ./data/dio87d.conf >/tmp/rap &
#sleep 1


######################################## a task witout jobs
echo "Test a task without jobs"
memx1=`dio87c -- memory`
dio87c -- ra r1 || exit 1
dio87c -- rta r1 t1 || exit 1
dio87c -- rtoa r1 t1 add always || exit 1
dio87c -- rtst r1 t1 localhost || exit 1

dio87c -- rp r1 "$dayDate" d1 >/dev/null || exit 1
waitretry 5 "dio87c -- xti d1 t1 | grep State | awk '{print \$2}'" "terminated"
if [ $? -ne 0 ] ; then
	echo "Task isn't terminated."; exit 1
fi
dio87c -- rk r1 || exit 1
dio87c -- srk r1 || exit 1
dio87c -- xdk d1 || exit 1
dio87c -- ldk d1 || exit 1
waitMessageSending
memx2=`dio87c -- memory`
if [ $memx2 -ne $memx1 ] ; then 
	echo "memory delta different for dio87d $memx1 -> $memx2"; exit 1
fi

######################################## a task with a job 
echo "Test a task with a job"
memx1=`dio87c -- memory`
dio87c -- ra r1 || exit 1
dio87c -- rta r1 t1 || exit 1
dio87c -- rtoa r1 t1 add always || exit 1
dio87c -- rtst r1 t1 localhost || exit 1
dio87c -- rja r1 t1 j1 || exit 1
dio87c -- rjsp r1 t1 j1 "$JOBPATH/job1.sh"

dio87c -- rp r1 "$dayDate" d1 >/dev/null || exit 1
waitretry 6 "dio87c -- xji d1 t1 j1 | grep State | awk '{print \$2}'" "terminated"
if [ $? -ne 0 ]; then
	echo "Job isn't terminated."; exit 1
fi
if [ "`dio87c -- xti d1 t1 | grep State | awk '{print $2}'`" != "terminated" ]; then
	echo "Task isn't terminated."; exit 1
fi
if [ "`dio87c -- xji d1 t1 j1 | grep \"Exit code\"| awk '{print $3}'`" != "0" ]; then
	echo "Exit code is not good."; exit 1
fi
if [ "`dio87c -- qxjc localhost batch`" != "0" ]; then
	echo "Number of running job in queue is not zero !"; exit 1
fi
dio87c -- rk r1 || exit 1
dio87c -- srk r1 || exit 1
dio87c -- xdk d1 || exit 1
dio87c -- ldk d1 || exit 1
waitMessageSending
memx2=`dio87c -- memory`
if [ $memx2 -ne $memx1 ] ; then 
	echo "memory delta different for dio87d $memx1 -> $memx2"; exit 1
fi
######################################## a task with an aborted job
echo "Test a task with an aborted job"
memx1=`dio87c -- memory`
dio87c -- ra r1 || exit 1
dio87c -- rta r1 t1 || exit 1
dio87c -- rtoa r1 t1 add always || exit 1
dio87c -- rtst r1 t1 localhost || exit 1
dio87c -- rja r1 t1 j1 || exit 1
dio87c -- rjsp r1 t1 j1 "$JOBPATH/job3.sh"

dio87c -- rp r1 "$dayDate" d1 >/dev/null || exit 1
waitretry 5 "dio87c -- xji d1 t1 j1 | grep State | awk '{print \$2}'" "aborted"
if [ $? -ne 0 ] ; then
	echo "Job isn't aborted."; exit 1
fi
if [ "`dio87c -- xti d1 t1 | grep State | awk '{print $2}'`" != "aborted" ]; then
	echo "Task isn't aborted."; exit 1
fi
if [ "`dio87c -- xji d1 t1 j1 | grep \"Exit code\"| awk '{print $3}'`" != "22" ]; then
	echo "Exit code is not good."; exit 1
fi
if [ "`dio87c -- qxjc localhost batch`" != "0" ]; then
	echo "Number of running job in queue is not zero !"; exit 1
fi
dio87c -- rk r1 || exit 1
dio87c -- srk r1 || exit 1
dio87c -- xdk d1 || exit 1
dio87c -- ldk d1 || exit 1
waitMessageSending
memx2=`dio87c -- memory`
if [ $memx2 -ne $memx1 ] ; then 
	echo "memory delta different for dio87d $memx1 -> $memx2"; exit 1
fi

######################################## a task with two jobs
echo "Test a task with two jobs"
memx1=`dio87c -- memory`
dio87c -- ra r1 || exit 1
dio87c -- rta r1 t1 || exit 1
dio87c -- rtoa r1 t1 add always || exit 1
dio87c -- rtst r1 t1 localhost || exit 1
dio87c -- rja r1 t1 j1 || exit 1
dio87c -- rjsp r1 t1 j1 "$JOBPATH/job1.sh"
dio87c -- rja r1 t1 j2 || exit 1
dio87c -- rjsp r1 t1 j2 "$JOBPATH/job2.sh"

dio87c -- rp r1 "$dayDate" d1 >/dev/null || exit 1
waitretry 8 "dio87c -- xji d1 t1 j1 | grep State | awk '{print \$2}'" "terminated"
if [ $? -ne 0 ]; then 
	echo "Job1 isn't terminated." ; exit 1
fi
waitretry 5 "dio87c -- xji d1 t1 j2 | grep State | awk '{print \$2}'" "terminated"
if [ $? -ne 0 ]; then 
	echo "Job2 isn't terminated." ; exit 1
fi
if [ "`dio87c -- xti d1 t1 | grep State | awk '{print $2}'`" != "terminated" ]; then
	echo "Task isn't terminated."; exit 1
fi
if [ "`dio87c -- qxjc localhost batch`" != "0" ]; then
	echo "Number of running job in queue is not zero !"; exit 1
fi
dio87c -- rk r1 || exit 1
dio87c -- srk r1 || exit 1
dio87c -- xdk d1 || exit 1
dio87c -- ldk d1 || exit 1

waitMessageSending
memx2=`dio87c -- memory`
if [ $memx2 -ne $memx1 ] ; then 
	echo "memory delta different for dio87d $memx1 -> $memx2"; exit 1
fi

######################################## a task with dependence (always)
echo "Test job dependence (type always with normal termination)"
memx1=`dio87c -- memory`
dio87c -- ra r1 || exit 1
dio87c -- rta r1 t1 || exit 1
dio87c -- rtoa r1 t1 add always || exit 1
dio87c -- rtst r1 t1 localhost || exit 1
dio87c -- rja r1 t1 j1 || exit 1
dio87c -- rjsp r1 t1 j1 "$JOBPATH/job1.sh"
dio87c -- rja r1 t1 j2 || exit 1
dio87c -- rjsp r1 t1 j2 "$JOBPATH/job2.sh"
dio87c -- rjda r1 t1 j1 j2 always || exit 1

dio87c -- rp r1 "$dayDate" d1 >/dev/null || exit 1
waitretry 5 "dio87c -- xji d1 t1 j1 | grep State | awk '{print \$2}'" "terminated" 
if [ $? -ne 0 ] ; then 
	echo "Job1 isn't terminated." ; exit 1
fi
waitretry 5 "dio87c -- xji d1 t1 j2 | grep State | awk '{print \$2}'" "terminated"
if [ $? -ne 0 ] ; then 
	echo "Job2 isn't terminated." ; exit 1
fi
if [ "`dio87c -- xti d1 t1 | grep State | awk '{print $2}'`" != "terminated" ]; then
	echo "Task isn't terminated."; exit 1
fi
if [ "`dio87c -- qxjc localhost batch`" != "0" ]; then
	echo "Number of running job in queue is not zero !"; exit 1
fi
dio87c -- rk r1 || exit 1
dio87c -- srk r1 || exit 1
dio87c -- xdk d1 || exit 1
dio87c -- ldk d1 || exit 1
waitMessageSending
memx2=`dio87c -- memory`
if [ $memx2 -ne $memx1 ] ; then 
	echo "memory delta different for dio87d $memx1 -> $memx2"; exit 1
fi

######################################## a task with dependence (always)
echo "Test job dependence (type always with abort)"
memx1=`dio87c -- memory`
dio87c -- ra r1 || exit 1
dio87c -- rta r1 t1 || exit 1
dio87c -- rtoa r1 t1 add always || exit 1
dio87c -- rtst r1 t1 localhost || exit 1
dio87c -- rja r1 t1 j1 || exit 1
dio87c -- rjsp r1 t1 j1 "$JOBPATH/job3.sh"
dio87c -- rja r1 t1 j2 || exit 1
dio87c -- rjsp r1 t1 j2 "$JOBPATH/job2.sh"
dio87c -- rjda r1 t1 j1 j2 always || exit 1

dio87c -- rp r1 "$dayDate" d1 >/dev/null || exit 1
waitretry 5 "dio87c -- xji d1 t1 j1 | grep State | awk '{print \$2}'" "aborted" 
if [ $? -ne 0 ] ; then 
	echo "Job1 isn't aborted." ; exit 1
fi
waitretry 5 "dio87c -- xji d1 t1 j2 | grep State | awk '{print \$2}'" "terminated"
if [ $? -ne 0 ] ; then 
	echo "Job2 isn't terminated." ; exit 1
fi
if [ "`dio87c -- xti d1 t1 | grep State | awk '{print $2}'`" != "aborted" ]; then
	echo "Task isn't aborted."; exit 1
fi
if [ "`dio87c -- qxjc localhost batch`" != "0" ]; then
	echo "Number of running job in queue is not zero !"; exit 1
fi
dio87c -- rk r1 || exit 1
dio87c -- srk r1 || exit 1
dio87c -- xdk d1 || exit 1
dio87c -- ldk d1 || exit 1
waitMessageSending
memx2=`dio87c -- memory`
if [ $memx2 -ne $memx1 ] ; then 
	echo "memory delta different for dio87d $memx1 -> $memx2"; exit 1
fi

######################################## a task with dependence (onsuccess)
echo "Test job dependence (type onsuccess with normal termination)"
memx1=`dio87c -- memory`
dio87c -- ra r1 || exit 1
dio87c -- rta r1 t1 || exit 1
dio87c -- rtoa r1 t1 add always || exit 1
dio87c -- rtst r1 t1 localhost || exit 1
dio87c -- rja r1 t1 j1 || exit 1
dio87c -- rjsp r1 t1 j1 "$JOBPATH/job1.sh"
dio87c -- rja r1 t1 j2 || exit 1
dio87c -- rjsp r1 t1 j2 "$JOBPATH/job2.sh"
dio87c -- rjda r1 t1 j1 j2 onsuccess || exit 1

dio87c -- rp r1 "$dayDate" d1 >/dev/null || exit 1
waitretry 5 "dio87c -- xji d1 t1 j1 | grep State | awk '{print \$2}'" "terminated"
if [ $? -ne 0 ] ; then 
	echo "Job1 isn't terminated." ; exit 1
fi
waitretry 5 "dio87c -- xji d1 t1 j2 | grep State | awk '{print \$2}'" "terminated"
if [ $? -ne 0 ] ; then 
	echo "Job2 isn't terminated." ; exit 1
fi
if [ "`dio87c -- xti d1 t1 | grep State | awk '{print $2}'`" != "terminated" ]; then
	echo "Task isn't terminated."; exit 1
fi
if [ "`dio87c -- qxjc localhost batch`" != "0" ]; then
	echo "Number of running job in queue is not zero !"; exit 1
fi
dio87c -- rk r1 || exit 1
dio87c -- srk r1 || exit 1
dio87c -- xdk d1 || exit 1
dio87c -- ldk d1 || exit 1
waitMessageSending
memx2=`dio87c -- memory`
if [ $memx2 -ne $memx1 ] ; then 
	echo "memory delta different for dio87d $memx1 -> $memx2"; exit 1
fi

######################################## a task with dependence (onsuccess)
echo "Test job dependence (type onsuccess with abort)"
memx1=`dio87c -- memory`
dio87c -- ra r1 || exit 1
dio87c -- rta r1 t1 || exit 1
dio87c -- rtoa r1 t1 add always || exit 1
dio87c -- rtst r1 t1 localhost || exit 1
dio87c -- rja r1 t1 j1 || exit 1
dio87c -- rjsp r1 t1 j1 "$JOBPATH/job3.sh"
dio87c -- rja r1 t1 j2 || exit 1
dio87c -- rjsp r1 t1 j2 "$JOBPATH/job2.sh"
dio87c -- rjda r1 t1 j1 j2 onsuccess || exit 1

dio87c -- rp r1 "$dayDate" d1 >/dev/null || exit 1
waitretry 5 "dio87c -- xji d1 t1 j1 | grep State | awk '{print \$2}'" "aborted"
if [ $? -ne 0 ] ; then 
	echo "Job1 isn't aborted." ; exit 1
fi
waitretry 5 "dio87c -- xji d1 t1 j2 | grep State | awk '{print \$2}'" "canceled"
if [ $? -ne 0 ] ; then 
	echo "Job2 isn't canceled." ; exit 1
fi
if [ "`dio87c -- xti d1 t1 | grep State | awk '{print $2}'`" != "aborted" ]; then
	echo "Task isn't aborted."; exit 1
fi
if [ "`dio87c -- qxjc localhost batch`" != "0" ]; then
	echo "Number of running job in queue is not zero !"; exit 1
fi
dio87c -- rk r1 || exit 1
dio87c -- srk r1 || exit 1
dio87c -- xdk d1 || exit 1
dio87c -- ldk d1 || exit 1
waitMessageSending
memx2=`dio87c -- memory`
if [ $memx2 -ne $memx1 ] ; then 
	echo "memory delta different for dio87d $memx1 -> $memx2"; exit 1
fi

######################################## a task with dependence (onerror)
echo "Test job dependence (type onerror with normal termination)"
memx1=`dio87c -- memory`
dio87c -- ra r1 || exit 1
dio87c -- rta r1 t1 || exit 1
dio87c -- rtoa r1 t1 add always || exit 1
dio87c -- rtst r1 t1 localhost || exit 1
dio87c -- rja r1 t1 j1 || exit 1
dio87c -- rjsp r1 t1 j1 "$JOBPATH/job1.sh"
dio87c -- rja r1 t1 j2 || exit 1
dio87c -- rjsp r1 t1 j2 "$JOBPATH/job2.sh"
dio87c -- rjda r1 t1 j1 j2 onerror || exit 1

dio87c -- rp r1 "$dayDate" d1 >/dev/null || exit 1
waitretry 5 "dio87c -- xji d1 t1 j1 | grep State | awk '{print \$2}'" "terminated"
if [ $? -ne 0 ] ; then 
	echo "Job1 isn't terminated." ; exit 1
fi
waitretry 5 "dio87c -- xji d1 t1 j2 | grep State | awk '{print \$2}'" "canceled"
if [ $? -ne 0 ] ; then 
	echo "Job2 isn't canceled." ; exit 1
fi
if [ "`dio87c -- xti d1 t1 | grep State | awk '{print $2}'`" != "terminated" ]; then
	echo "Task isn't terminated."; exit 1
fi
if [ "`dio87c -- qxjc localhost batch`" != "0" ]; then
	echo "Number of running job in queue is not zero !"; exit 1
fi
dio87c -- rk r1 || exit 1
dio87c -- srk r1 || exit 1
dio87c -- xdk d1 || exit 1
dio87c -- ldk d1 || exit 1
waitMessageSending
memx2=`dio87c -- memory`
if [ $memx2 -ne $memx1 ] ; then 
	echo "memory delta different for dio87d $memx1 -> $memx2"; exit 1
fi

######################################## a task with dependence (onerror)
echo "Test job dependence (type onerror with abort)"
memx1=`dio87c -- memory`
dio87c -- ra r1 || exit 1
dio87c -- rta r1 t1 || exit 1
dio87c -- rtoa r1 t1 add always || exit 1
dio87c -- rtst r1 t1 localhost || exit 1
dio87c -- rja r1 t1 j1 || exit 1
dio87c -- rjsp r1 t1 j1 "$JOBPATH/job3.sh"
dio87c -- rja r1 t1 j2 || exit 1
dio87c -- rjsp r1 t1 j2 "$JOBPATH/job2.sh"
dio87c -- rjda r1 t1 j1 j2 onerror || exit 1

dio87c -- rp r1 "$dayDate" d1 >/dev/null || exit 1
waitretry 5 "dio87c -- xji d1 t1 j1 | grep State | awk '{print \$2}'" "aborted"
if [ $? -ne 0 ] ; then 
	echo "Job1 isn't aborted." ; exit 1
fi
waitretry 5 "dio87c -- xji d1 t1 j2 | grep State | awk '{print \$2}'" "terminated"
if [ $? -ne 0 ] ; then 
	echo "Job2 isn't terminated." ; exit 1
fi
if [ "`dio87c -- xti d1 t1 | grep State | awk '{print $2}'`" != "aborted" ]; then
	echo "Task isn't aborted."; exit 1
fi
if [ "`dio87c -- qxjc localhost batch`" != "0" ]; then
	echo "Number of running job in queue is not zero !"; exit 1
fi
dio87c -- rk r1 || exit 1
dio87c -- srk r1 || exit 1
dio87c -- xdk d1 || exit 1
dio87c -- ldk d1 || exit 1
waitMessageSending
memx2=`dio87c -- memory`
if [ $memx2 -ne $memx1 ] ; then 
	echo "memory delta different for dio87d $memx1 -> $memx2"; exit 1
fi

stopDio87d || exit 1
