#!/bin/sh
#
# file tst09.sh 
# (test task dependencies)
#
#      Diogene87
#	Copyright (C) 2003,2004,2005 - Dominique Parisot
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this software; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
# Boston, MA 02111-1307 USA
#

if [ "$srcdir" = "" ]; then srcdir="."; fi
. $srcdir/functions.sh
checkNoDaemon

echo "test task dependencies"

startDio87d || exit 1


######################################## test two tasks
echo "Test two tasks" 
memx1=`dio87c -- memory`
dio87c -- ra r1 || exit 1
# first task
dio87c -- rta r1 t1 || exit 1
dio87c -- rtoa r1 t1 add always || exit 1
dio87c -- rtst r1 t1 localhost || exit 1
dio87c -- rja r1 t1 j1 || exit 1
dio87c -- rjsp r1 t1 j1 "$JOBPATH/job6.sh"
# second task
dio87c -- rta r1 t2 || exit 1
dio87c -- rtoa r1 t2 add always || exit 1
dio87c -- rja r1 t2 j1 || exit 1
dio87c -- rjsp r1 t2 j1 "$JOBPATH/job6.sh"
dio87c -- ese true || exit 1
dio87c -- rp r1 "$dayDate" d1 >/dev/null || exit 1
sleep 3
waitretry 9 "dio87c -- xjl -sS! d1 t1 | grep j1" "j1!terminated"
if [ $? -ne 0 ] ; then
echo "The job of first task isn't terminated."; exit 1
fi
if [ "`dio87c -- xtl -sS! d1 | grep t1`" != "t1!terminated" ]; then
echo "First task isn't terminated."; exit 1
fi
waitretry 5 "dio87c -- xjl -sS! d1 t2 | grep j1" "j1!terminated" 
if [ $? -ne 0 ]; then
echo "The job of the second task isn't terminated."; exit 1
fi
if [ "`dio87c -- xtl -sS! d1 | grep t2`" != "t2!terminated" ]; then
echo "Second task isn't terminated."; exit 1
fi
dio87c -- rk r1 || exit 1
dio87c -- srk r1 || exit 1
dio87c -- xdk d1 || exit 1
dio87c -- ldk d1 || exit 1
waitMessageSending
memx2=`dio87c -- memory`
if [ $memx2 -ne $memx1 ] ; then 
echo "memory delta different for dio87d $memx1 -> $memx2"; exit 1
fi

######################################## test task dependence (always+norm.term)
echo "Test task dependence (type always with normal termination)" 
memx1=`dio87c -- memory`
dio87c -- ra r1 || exit 1
# first task
dio87c -- rta r1 t1 || exit 1
dio87c -- rtoa r1 t1 add always || exit 1
dio87c -- rja r1 t1 j1 || exit 1
dio87c -- rjsp r1 t1 j1 "$JOBPATH/job1.sh"
dio87c -- rtca r1 t1 manual "OK"
# second task
dio87c -- rta r1 t2 || exit 1
dio87c -- rtoa r1 t2 add always || exit 1
dio87c -- rja r1 t2 j1 || exit 1
dio87c -- rjsp r1 t2 j1 "$JOBPATH/job1.sh"
# task dep
dio87c -- rtda r1 t1 t2 always || exit 1
dio87c -- ese true || exit 1
dio87c -- rp r1 "$dayDate" d1 >/dev/null || exit 1
waitretry 5 "dio87c -- xtl -sS! d1 | grep t1" "t1!wait_for_condition"
if [ $? -ne 0 ]; then
	echo "First task isn't waiting for condition."; exit 1
fi
if [ "`dio87c -- xtl -sS! d1 | grep t2`" != "t2!wait_for_dep" ]; then
	echo "Second task isn't waiting for dependence."; exit 1
fi
dio87c -- xtcv d1 t1 manual "OK" 
waitretry 9 "dio87c -- xjl -sS! d1 t1 | grep j1" "j1!terminated"
if [ $? -ne 0 ]; then
	echo "The job of first task isn't terminated."; exit 1
fi
if [ "`dio87c -- xtl -sS! d1 | grep t1`" != "t1!terminated" ]; then
	echo "First task isn't terminated."; exit 1
fi
waitretry 5 "dio87c -- xtdl -sS! d1" "t1!t2!validated"
if [ $? -ne 0 ]; then
	echo "Task dependence isn't validated."; exit 1
fi
waitretry 9 "dio87c -- xjl -sS! d1 t2 | grep j1" "j1!terminated" 
if [ $? -ne 0 ]; then
	echo "The job of the second task isn't terminated."; exit 1
fi
if [ "`dio87c -- xtl -sS! d1 | grep t2`" != "t2!terminated" ]; then
	echo "Second task isn't terminated."; exit 1
fi
dio87c -- rk r1 || exit 1
dio87c -- srk r1 || exit 1
dio87c -- xdk d1 || exit 1
dio87c -- ldk d1 || exit 1
waitMessageSending
memx2=`dio87c -- memory`
if [ $memx2 -ne $memx1 ] ; then 
	echo "memory delta different for dio87d $memx1 -> $memx2"; exit 1
fi
######################################## test task dependence (always+abort)
echo "Test task dependence (type always with abort)" 
memx1=`dio87c -- memory`
dio87c -- ra r1 || exit 1
# first task
dio87c -- rta r1 t1 || exit 1
dio87c -- rtoa r1 t1 add always || exit 1
dio87c -- rja r1 t1 j1 || exit 1
dio87c -- rjsp r1 t1 j1 "$JOBPATH/job3.sh"
# second task
dio87c -- rta r1 t2 || exit 1
dio87c -- rtoa r1 t2 add always || exit 1
dio87c -- rja r1 t2 j1 || exit 1
dio87c -- rjsp r1 t2 j1 "$JOBPATH/job1.sh"
# task dep
dio87c -- rtda r1 t1 t2 always || exit 1
dio87c -- ese true || exit 1
dio87c -- rp r1 "$dayDate" d1 >/dev/null || exit 1
waitretry 5 "dio87c -- xtl -sS! d1 | grep t1" "t1!aborted" 
if [ $? -ne 0 ]; then
	echo "First task isn't aborted."; exit 1
fi
waitretry 5 "dio87c -- xtdl -sS! d1" "t1!t2!validated"
if [ $? -ne 0 ]; then
	echo "Task dependence isn't validated."; exit 1
fi
waitretry 9 "dio87c -- xtl -sS! d1 | grep t2" "t2!terminated" 
if [ $? -ne 0 ]; then
	echo "Second task isn't terminated."; exit 1
fi
dio87c -- rk r1 || exit 1
dio87c -- srk r1 || exit 1
dio87c -- xdk d1 || exit 1
dio87c -- ldk d1 || exit 1
waitMessageSending
memx2=`dio87c -- memory`
if [ $memx2 -ne $memx1 ] ; then 
	echo "memory delta different for dio87d $memx1 -> $memx2"; exit 1
fi

######################################## test dependence onsuccess 
echo "Test task dependence (onsuccess with normal termination)" 
memx1=`dio87c -- memory`
dio87c -- ra r1 || exit 1
# first task
dio87c -- rta r1 t1 || exit 1
dio87c -- rtoa r1 t1 add always || exit 1
dio87c -- rja r1 t1 j1 || exit 1
dio87c -- rjsp r1 t1 j1 "$JOBPATH/job1.sh"
dio87c -- rtca r1 t1 manual "OK"
# second task
dio87c -- rta r1 t2 || exit 1
dio87c -- rtoa r1 t2 add always || exit 1
dio87c -- rja r1 t2 j1 || exit 1
dio87c -- rjsp r1 t2 j1 "$JOBPATH/job1.sh"
# task dep
dio87c -- rtda r1 t1 t2 onsuccess || exit 1
dio87c -- ese true || exit 1
dio87c -- rp r1 "$dayDate" d1 >/dev/null || exit 1
waitretry 5 "dio87c -- xtl -sS! d1 | grep t1" "t1!wait_for_condition" 
if [ $? -ne 0 ]; then
	echo "First task isn't waiting for condition."; exit 1
fi
if [ "`dio87c -- xtl -sS! d1 | grep t2`" != "t2!wait_for_dep" ]; then
	echo "Second task isn't waiting for dependence."; exit 1
fi
dio87c -- xtcv d1 t1 manual "OK" 
waitretry 9 "dio87c -- xjl -sS! d1 t1 | grep j1" "j1!terminated"
if [ $? -ne 0 ]; then
	echo "The job of first task isn't terminated."; exit 1
fi
if [ "`dio87c -- xtl -sS! d1 | grep t1`" != "t1!terminated" ]; then
	echo "First task isn't terminated."; exit 1
fi
waitretry 5 "dio87c -- xtdl -sS! d1" "t1!t2!validated"
if [ $? -ne 0 ]; then
	echo "Task dependence isn't validated."; exit 1
fi
waitretry 9 "dio87c -- xjl -sS! d1 t2 | grep j1" "j1!terminated"
if [ $? -ne 0 ]; then
	echo "The job of the second task isn't terminated."; exit 1
fi
if [ "`dio87c -- xtl -sS! d1 | grep t2`" != "t2!terminated" ]; then
	echo "Second task isn't terminated."; exit 1
fi
dio87c -- rk r1 || exit 1
dio87c -- srk r1 || exit 1
dio87c -- xdk d1 || exit 1
dio87c -- ldk d1 || exit 1
waitMessageSending
memx2=`dio87c -- memory`
if [ $memx2 -ne $memx1 ] ; then 
	echo "memory delta different for dio87d $memx1 -> $memx2"; exit 1
fi


######################################## test task dependence (onsuccess+abort)
echo "Test task dependence (type onsuccess with abort)" 
memx1=`dio87c -- memory`
dio87c -- ra r1 || exit 1
# first task
dio87c -- rta r1 t1 || exit 1
dio87c -- rtoa r1 t1 add always || exit 1
dio87c -- rja r1 t1 j1 || exit 1
dio87c -- rjsp r1 t1 j1 "$JOBPATH/job3.sh"
# second task
dio87c -- rta r1 t2 || exit 1
dio87c -- rtoa r1 t2 add always || exit 1
dio87c -- rja r1 t2 j1 || exit 1
dio87c -- rjsp r1 t2 j1 "$JOBPATH/job1.sh"
# task dep
dio87c -- rtda r1 t1 t2 onsuccess || exit 1
dio87c -- ese true || exit 1
dio87c -- rp r1 "$dayDate" d1 >/dev/null || exit 1
waitretry 5 "dio87c -- xtl -sS! d1 | grep t1" "t1!aborted"
if [ $? -ne 0 ] ; then
	echo "First task isn't aborted."; exit 1
fi
waitretry 5 "dio87c -- xtdl -sS! d1" "t1!t2!canceled"
if [ $? -ne 0 ] ; then
	echo "Task dependence isn't canceled."; exit 1
fi
waitretry 5 "dio87c -- xtl -sS! d1 | grep t2" "t2!canceled"
if [ $? -ne 0 ] ; then
	echo "Second task isn't canceled."; exit 1
fi
dio87c -- rk r1 || exit 1
dio87c -- srk r1 || exit 1
dio87c -- xdk d1 || exit 1
dio87c -- ldk d1 || exit 1
waitMessageSending
memx2=`dio87c -- memory`
if [ $memx2 -ne $memx1 ] ; then 
	echo "memory delta different for dio87d $memx1 -> $memx2"; exit 1
fi


######################################## test dependence onerror
echo "Test task dependence (onerror with normal termination)" 
memx1=`dio87c -- memory`
dio87c -- ra r1 || exit 1
# first task
dio87c -- rta r1 t1 || exit 1
dio87c -- rtoa r1 t1 add always || exit 1
dio87c -- rja r1 t1 j1 || exit 1
dio87c -- rjsp r1 t1 j1 "$JOBPATH/job1.sh"
dio87c -- rtca r1 t1 manual "OK"
# second task
dio87c -- rta r1 t2 || exit 1
dio87c -- rtoa r1 t2 add always || exit 1
dio87c -- rja r1 t2 j1 || exit 1
dio87c -- rjsp r1 t2 j1 "$JOBPATH/job1.sh"
# task dep
dio87c -- rtda r1 t1 t2 onerror || exit 1
dio87c -- ese true || exit 1
dio87c -- rp r1 "$dayDate" d1 >/dev/null || exit 1
waitretry 5 "dio87c -- xtl -sS! d1 | grep t1" "t1!wait_for_condition"
if [ $? -ne 0 ]; then
	echo "First task isn't waiting for condition."; exit 1
fi
if [ "`dio87c -- xtl -sS! d1 | grep t2`" != "t2!wait_for_dep" ]; then
	echo "Second task isn't waiting for dependence."; exit 1
fi
dio87c -- xtcv d1 t1 manual "OK" 
waitretry 6 "dio87c -- xjl -sS! d1 t1 | grep j1" "j1!terminated"
if [ $? -ne 0 ]; then
	echo "The job of first task isn't terminated."; exit 1
fi
if [ "`dio87c -- xtl -sS! d1 | grep t1`" != "t1!terminated" ]; then
	echo "First task isn't terminated."; exit 1
fi
waitretry 5 "dio87c -- xtdl -sS! d1" "t1!t2!canceled" 
if [ $? -ne 0 ]; then
	echo "Task dependence isn't canceled."; exit 1
fi
if [ "`dio87c -- xtl -sS! d1 | grep t2`" != "t2!canceled" ]; then
	echo "Second task isn't canceled."; exit 1
fi
dio87c -- rk r1 || exit 1
dio87c -- srk r1 || exit 1
dio87c -- xdk d1 || exit 1
dio87c -- ldk d1 || exit 1
waitMessageSending
memx2=`dio87c -- memory`
if [ $memx2 -ne $memx1 ] ; then 
	echo "memory delta different for dio87d $memx1 -> $memx2"; exit 1
fi


######################################## test dependence onerror
echo "Test task dependence (onerror with aborted termination)" 
memx1=`dio87c -- memory`
dio87c -- ra r1 || exit 1
# first task
dio87c -- rta r1 t1 || exit 1
dio87c -- rtoa r1 t1 add always || exit 1
dio87c -- rja r1 t1 j1 || exit 1
dio87c -- rjsp r1 t1 j1 "$JOBPATH/job3.sh"
dio87c -- rtca r1 t1 manual "OK"
# second task
dio87c -- rta r1 t2 || exit 1
dio87c -- rtoa r1 t2 add always || exit 1
dio87c -- rja r1 t2 j1 || exit 1
dio87c -- rjsp r1 t2 j1 "$JOBPATH/job1.sh"
# task dep
dio87c -- rtda r1 t1 t2 onerror || exit 1
dio87c -- ese true || exit 1
dio87c -- rp r1 "$dayDate" d1 >/dev/null || exit 1
waitretry 5 "dio87c -- xtl -sS! d1 | grep t1" "t1!wait_for_condition"
if [ $? -ne 0 ]; then
	echo "First task isn't waiting for condition."; exit 1
fi
if [ "`dio87c -- xtl -sS! d1 | grep t2`" != "t2!wait_for_dep" ]; then
	echo "Second task isn't waiting for dependence."; exit 1
fi
dio87c -- xtcv d1 t1 manual "OK"
waitretry 5 "dio87c -- xjl -sS! d1 t1 | grep j1" "j1!aborted" 
if [ $? -ne 0 ]; then
	echo "The job of first task isn't terminated."; exit 1
fi
if [ "`dio87c -- xtl -sS! d1 | grep t1`" != "t1!aborted" ]; then
	echo "First task isn't aborted."; exit 1
fi
waitretry 5 "dio87c -- xtdl -sS! d1" "t1!t2!validated" 
if [ $? -ne 0 ]; then
	echo "Task dependence isn't validated."; exit 1
fi
waitretry 5 "dio87c -- xjl -sS! d1 t2 | grep j1" "j1!terminated" 
if [ $? -ne 0 ]; then
	echo "The job of the second task isn't terminated."; exit 1
fi
if [ "`dio87c -- xtl -sS! d1 | grep t2`" != "t2!terminated" ]; then
	echo "Second task isn't terminated."; exit 1
fi
dio87c -- rk r1 || exit 1
dio87c -- srk r1 || exit 1
dio87c -- xdk d1 || exit 1
dio87c -- ldk d1 || exit 1
waitMessageSending
memx2=`dio87c -- memory`
if [ $memx2 -ne $memx1 ] ; then 
	echo "memory delta different for dio87d $memx1 -> $memx2"; exit 1
fi


stopDio87d || exit 1
