#!/bin/sh
#
# file tst10.sh 
# (test enabled property, onErrorContinue property for job and task)
#
#      Diogene87
#	Copyright (C) 2003,2004,2005 - Dominique Parisot
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this software; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
# Boston, MA 02111-1307 USA
#

if [ "$srcdir" = "" ]; then srcdir="."; fi
. $srcdir/functions.sh
checkNoDaemon

echo "test enabled property, onErrorContinue property" 

startDio87d || exit 1

######################################## task enabled property 
echo "Test Task enabled property" 
memx1=`dio87c -- memory`
dio87c -- ra r1 || exit 1

dio87c -- rta r1 t1 || exit 1
dio87c -- rtoa r1 t1 add always || exit 1
dio87c -- rtst r1 t1 localhost || exit 1
dio87c -- rja r1 t1 j1 || exit 1
dio87c -- rjsp r1 t1 j1 "$JOBPATH/job1.sh"

dio87c -- rta r1 t2 || exit 1
dio87c -- rtoa r1 t2 add always || exit 1
dio87c -- rtst r1 t2 localhost || exit 1
dio87c -- rja r1 t2 j1 || exit 1
dio87c -- rjsp r1 t2 j1 "$JOBPATH/job1.sh"

dio87c -- rta r1 t3 || exit 1
dio87c -- rtoa r1 t3 add always || exit 1
dio87c -- rja r1 t3 j1 || exit 1
dio87c -- rjsp r1 t3 j1 "$JOBPATH/job1.sh"

dio87c -- rtda r1 t1 t2 || exit 1
dio87c -- rtda r1 t2 t3 || exit 1

dio87c -- ese true || exit 1
dio87c -- rp -d r1 "$dayDate" d1 >/dev/null || exit 1
sleep 1
dio87c -- xtse d1 t2 false || exit 1
if [ $? -ne 0 ]; then echo "Can't disabled task."; exit 1; fi
dio87c -- xdse d1 true || exit 1
waitretry 9 "dio87c -- xtl -sS! d1 | grep t1" "t1!terminated"
if [ $? -ne 0 ]; then
	echo "The first task isn't terminated."; exit 1
fi
if [ "`dio87c -- xtl -sS! d1 | grep t2`" != "t2!wait_enabled" ]; then
	echo "The second task isn't waiting enabled."; exit 1
fi
if [ "`dio87c -- xtl -sS! d1 | grep t3`" != "t3!wait_for_dep" ]; then
	echo "The third task isn't waiting for dependence."; exit 1
fi
dio87c -- xtse d1 t2 true 
if [ $? -ne 0 ]; then echo "Can't enabled task."; exit 1; fi
waitretry 9 "dio87c -- xtl -sS! d1 | grep t1" "t1!terminated"
if [ $? -ne 0 ]; then
	echo "The first task isn't terminated."; exit 1
fi
waitretry 9 "dio87c -- xtl -sS! d1 | grep t2" "t2!terminated" 
if [ $? -ne 0 ]; then
	echo "The second task isn't terminated."; exit 1
fi
waitretry 9 "dio87c -- xtl -sS! d1 | grep t3" "t3!terminated"
if [ $? -ne 0 ]; then
	echo "The third task isn't terminated."; exit 1
fi
dio87c -- rk r1 || exit 1
dio87c -- srk r1 || exit 1
dio87c -- xdk d1 || exit 1
dio87c -- ldk d1 || exit 1
waitMessageSending
memx2=`dio87c -- memory`
if [ $memx2 -ne $memx1 ] ; then 
	echo "memory delta different for dio87d $memx1 -> $memx2"; exit 1
fi


######################################## job enabled property 
echo "Test Job enabled property" 
memx1=`dio87c -- memory`
dio87c -- ra r1 || exit 1
dio87c -- rta r1 t1 || exit 1
dio87c -- rtoa r1 t1 add always || exit 1

dio87c -- rja r1 t1 j1 || exit 1
dio87c -- rjsp r1 t1 j1 "$JOBPATH/job1.sh"
dio87c -- rja r1 t1 j2 || exit 1
dio87c -- rjsp r1 t1 j2 "$JOBPATH/job1.sh"
dio87c -- rja r1 t1 j3 || exit 1
dio87c -- rjsp r1 t1 j3 "$JOBPATH/job1.sh"

dio87c -- rjda r1 t1 j1 j2 || exit 1
dio87c -- rjda r1 t1 j2 j3 || exit 1

dio87c -- ese true || exit 1
dio87c -- rp -d r1 "$dayDate" d1 >/dev/null || exit 1
sleep 1
dio87c -- xjse d1 t1 j2 false 
if [ $? -ne 0 ]; then echo "Can't disabled job."; exit 1; fi
dio87c -- xdse d1 true || exit 1
waitretry 5 "dio87c -- xjl -sS! d1 t1 | grep j1" "j1!terminated"
if [ $? -ne 0 ]; then
	echo "The first job isn't terminated."; exit 1
fi
if [ "`dio87c -- xjl -sS! d1 t1 | grep j2`" != "j2!wait_enabled" ]; then
	echo "The second job isn't waiting enabled."; exit 1
fi
if [ "`dio87c -- xjl -sS! d1 t1 | grep j3`" != "j3!wait_for_dep" ]; then
	echo "The third job isn't waiting for dependence."; exit 1
fi
if [ "`dio87c -- xtl -sS! d1 | grep t1`" != "t1!running" ]; then
	echo "The task isn't running."; exit 1
fi
dio87c -- xjse d1 t1 j2 true 
if [ $? -ne 0 ]; then echo "Can't enabled job."; exit 1; fi
waitretry 5 "dio87c -- xjl -sS! d1 t1 | grep j2" "j2!terminated" 
if [ $? -ne 0 ]; then
	echo "The second job isn't terminated."; exit 1
fi
waitretry 5 "dio87c -- xjl -sS! d1 t1 | grep j3" "j3!terminated" 
if [ $? -ne 0 ]; then
	echo "The third job isn't terminated."; exit 1
fi
if [ "`dio87c -- xtl -sS! d1 | grep t1`" != "t1!terminated" ]; then
	echo "The task isn't terminated."; exit 1
fi

dio87c -- rk r1 || exit 1
dio87c -- srk r1 || exit 1
dio87c -- xdk d1 || exit 1
dio87c -- ldk d1 || exit 1

waitMessageSending
memx2=`dio87c -- memory`
if [ $memx2 -ne $memx1 ] ; then 
	echo "memory delta different for dio87d $memx1 -> $memx2"; exit 1
fi

######################################## job onerrorcontinue=false with abort
echo "Test Job with OnErrorContinue=false with abort" 
memx1=`dio87c -- memory`

dio87c -- ra r1 || exit 1

dio87c -- rta r1 t1 || exit 1
dio87c -- rtoa r1 t1 add always || exit 1

dio87c -- rja r1 t1 j1 || exit 1
dio87c -- rjsp r1 t1 j1 "$JOBPATH/job3.sh"
dio87c -- rjsoec r1 t1 j1 false || exit 1

dio87c -- rja r1 t1 j2 || exit 1
dio87c -- rjsp r1 t1 j2 "$JOBPATH/job2.sh"

dio87c -- rjda r1 t1 j1 j2 onsuccess

dio87c -- ese true || exit 1
dio87c -- rp r1 "$dayDate" d1 >/dev/null || exit 1

waitretry 9 "dio87c -- xjl -sS! d1 t1 | grep j1" "j1!abort_stopped"
if [ $? -ne 0 ]; then
	echo "The first job isn't abort_stopped."; exit 1
fi
if [ "`dio87c -- xjdl -sS! d1 t1`" != "j1!j2!waiting" ]; then
	echo "The job dependence isn't waiting."; exit 1
fi
if [ "`dio87c -- xjl -sS! d1 t1 | grep j2`" != "j2!wait_for_dep" ]; then
	echo "The second job isn't waiting for dep."; exit 1
fi
if [ "`dio87c -- xtl -sS! d1 | grep t1`" != "t1!running" ]; then
	echo "The task isn't running."; exit 1
fi

dio87c -- rk r1 || exit 1
dio87c -- srk r1 || exit 1
dio87c -- xdk d1 || exit 1
dio87c -- ldk d1 || exit 1

waitMessageSending
memx2=`dio87c -- memory`
if [ $memx2 -ne $memx1 ] ; then 
	echo "memory delta different for dio87d $memx1 -> $memx2"; exit 1
fi


######################################## job onerrorcontinue=false with no abort
echo "Test Job with OnErrorContinue=false with normal termination " 
memx1=`dio87c -- memory`

dio87c -- ra r1 || exit 1
dio87c -- rta r1 t1 || exit 1
dio87c -- rtoa r1 t1 add always || exit 1

dio87c -- rja r1 t1 j1 || exit 1
dio87c -- rjsp r1 t1 j1 "$JOBPATH/job1.sh"
dio87c -- rjsoec r1 t1 j1 false || exit 1

dio87c -- rja r1 t1 j2 || exit 1
dio87c -- rjsp r1 t1 j2 "$JOBPATH/job2.sh"

dio87c -- rjda r1 t1 j1 j2 onsuccess

dio87c -- ese true || exit 1
dio87c -- rp r1 "$dayDate" d1 >/dev/null || exit 1

waitretry 5 "dio87c -- xjl -sS! d1 t1 | grep j1" "j1!terminated"
if [ $? -ne 0 ]; then
	echo "The first job isn't terminated."; exit 1
fi
if [ "`dio87c -- xjdl -sS! d1 t1`" != "j1!j2!validated" ]; then
	echo "The job dependence isn't validated."; exit 1
fi
waitretry 5 "dio87c -- xjl -sS! d1 t1 | grep j2" "j2!terminated"
if [ $? -ne 0 ]; then
	echo "The second job isn't terminated."; exit 1
fi
if [ "`dio87c -- xtl -sS! d1 | grep t1`" != "t1!terminated" ]; then
	echo "The task isn't terminated."; exit 1
fi

dio87c -- rk r1 || exit 1
dio87c -- srk r1 || exit 1
dio87c -- xdk d1 || exit 1
dio87c -- ldk d1 || exit 1

waitMessageSending
memx2=`dio87c -- memory`
if [ $memx2 -ne $memx1 ] ; then 
	echo "memory delta different for dio87d $memx1 -> $memx2"; exit 1
fi


######################################## job onerrorcontinue=true with abort 
echo "Test Job with OnErrorContinue=true with abort" 
memx1=`dio87c -- memory`

dio87c -- ra r1 || exit 1
# first task
dio87c -- rta r1 t1 || exit 1
dio87c -- rtoa r1 t1 add always || exit 1

dio87c -- rja r1 t1 j1 || exit 1
dio87c -- rjsp r1 t1 j1 "$JOBPATH/job3.sh"
dio87c -- rjsoec r1 t1 j1 true || exit 1

dio87c -- rja r1 t1 j2 || exit 1
dio87c -- rjsp r1 t1 j2 "$JOBPATH/job2.sh"

dio87c -- rjda r1 t1 j1 j2 onsuccess

dio87c -- ese true || exit 1
dio87c -- rp r1 "$dayDate" d1 >/dev/null || exit 1

waitretry 5 "dio87c -- xjl -sS! d1 t1 | grep j1" "j1!aborted"
if [ $? -ne 0 ]; then
	echo "The first job isn't aborted."; exit 1
fi
if [ "`dio87c -- xjdl -sS! d1 t1`" != "j1!j2!canceled" ]; then
	echo "The job dependence isn't canceled."; exit 1
fi
if [ "`dio87c -- xjl -sS! d1 t1 | grep j2`" != "j2!canceled" ]; then
	echo "The second job isn't canceled."; exit 1
fi
if [ "`dio87c -- xtl -sS! d1 | grep t1`" != "t1!aborted" ]; then
	echo "The task isn't aborted."; exit 1
fi

dio87c -- rk r1 || exit 1
dio87c -- srk r1 || exit 1
dio87c -- xdk d1 || exit 1
dio87c -- ldk d1 || exit 1

waitMessageSending
memx2=`dio87c -- memory`
if [ $memx2 -ne $memx1 ] ; then 
	echo "memory delta different for dio87d $memx1 -> $memx2"; exit 1
fi

######################################## job onerrorcontinue=true without abort 
echo "Test Job with OnErrorContinue=true with normal termination" 
memx1=`dio87c -- memory`

dio87c -- ra r1 || exit 1
# first task
dio87c -- rta r1 t1 || exit 1
dio87c -- rtoa r1 t1 add always || exit 1

dio87c -- rja r1 t1 j1 || exit 1
dio87c -- rjsp r1 t1 j1 "$JOBPATH/job1.sh"
dio87c -- rjsoec r1 t1 j1 true || exit 1

dio87c -- rja r1 t1 j2 || exit 1
dio87c -- rjsp r1 t1 j2 "$JOBPATH/job2.sh"

dio87c -- rjda r1 t1 j1 j2 onsuccess

dio87c -- ese true || exit 1
dio87c -- rp r1 "$dayDate" d1 >/dev/null || exit 1

waitretry 9 "dio87c -- xjl -sS! d1 t1 | grep j1" "j1!terminated"
if [ $? -ne 0 ]; then
	echo "The first job isn't terminated."; exit 1
fi
if [ "`dio87c -- xjdl -sS! d1 t1`" != "j1!j2!validated" ]; then
	echo "The job dependence isn't validated."; exit 1
fi
waitretry 9 "dio87c -- xjl -sS! d1 t1 | grep j2" "j2!terminated" 
if [ $? -ne 0 ]; then
	echo "The second job isn't terminated."; exit 1
fi
if [ "`dio87c -- xtl -sS! d1 | grep t1`" != "t1!terminated" ]; then
	echo "The task isn't terminated."; exit 1
fi

dio87c -- rk r1 || exit 1
dio87c -- srk r1 || exit 1
dio87c -- xdk d1 || exit 1
dio87c -- ldk d1 || exit 1

waitMessageSending
memx2=`dio87c -- memory`
if [ $memx2 -ne $memx1 ] ; then 
	echo "memory delta different for dio87d $memx1 -> $memx2"; exit 1
fi

######################################## abort with manual restart 
echo "Test Job abort with manual restart" 
memx1=`dio87c -- memory`

TMPFILE="$DATAPATH/dg87fic$$"
if [ -f $TMPFILE ] ; then
	"File '$TMPFILE' already exists"; exit 1
fi
dio87c -- ra r1 || exit 1
# first task
dio87c -- rta r1 t1 || exit 1
dio87c -- rtoa r1 t1 add always || exit 1

dio87c -- rja r1 t1 j1 || exit 1
dio87c -- rjsp r1 t1 j1 "$JOBPATH/job7.sh"
dio87c -- rjsa r1 t1 j1 "$TMPFILE"
dio87c -- rjsoec r1 t1 j1 false || exit 1

dio87c -- rja r1 t1 j2 || exit 1
dio87c -- rjsp r1 t1 j2 "$JOBPATH/job2.sh" || exit 1

dio87c -- rjda r1 t1 j1 j2 onsuccess || exit 1

dio87c -- ese true || exit 1
dio87c -- rp r1 "$dayDate" d1 >/dev/null || exit 1

echo "  Start job with abort"
waitretry 5 "dio87c -- xjl -sS! d1 t1 | grep j1" "j1!abort_stopped" 
if [ $? -ne 0 ]; then
	echo "The first job isn't abort_stopped."; exit 1
fi
if [ "`dio87c -- xjdl -sS! d1 t1`" != "j1!j2!waiting" ]; then
	echo "The job dependence isn't waiting."; exit 1
fi
if [ "`dio87c -- xjl -sS! d1 t1 | grep j2`" != "j2!wait_for_dep" ]; then
	echo "The second job isn't waiting for dep."; exit 1
fi
if [ "`dio87c -- xtl -sS! d1 | grep t1`" != "t1!running" ]; then
	echo "The task isn't running."; exit 1
fi

echo "  Restart job after correction"
# create the file
touch $TMPFILE
if [ $? != 0 ] ; then
	echo "Can't create file $TMPFILE". exit 1
fi
# restart job
dio87c -- xju d1 t1 j1 ready_to_run
if [ $? -ne 0 ] ; then
	echo "Can't restart job"; exit 1
fi
waitretry 5 "dio87c -- xjl -sS! d1 t1 | grep j1" "j1!terminated"
if [ $? -ne 0 ] ; then
	echo "The first job isn't terminated."; rm $TMPFILE; exit 1
fi
if [ "`dio87c -- xjdl -sS! d1 t1`" != "j1!j2!validated" ]; then
	echo "The job dependence isn't validated."; rm $TMPFILE; exit 1
fi
waitretry 5 "dio87c -- xjl -sS! d1 t1 | grep j2" "j2!terminated"
if [ $? -ne 0 ] ; then
	echo "The second job isn't terminated."; rm $TMPFILE; exit 1
fi
if [ "`dio87c -- xtl -sS! d1 | grep t1`" != "t1!terminated" ]; then
	echo "The task isn't terminated."; rm $TMPFILE; exit 1
fi

rm $TMPFILE || exit 1

dio87c -- rk r1 || exit 1
dio87c -- srk r1 || exit 1
dio87c -- xdk d1 || exit 1
dio87c -- ldk d1 || exit 1

waitMessageSending
memx2=`dio87c -- memory`
if [ $memx2 -ne $memx1 ] ; then 
	echo "memory delta different for dio87d $memx1 -> $memx2"; exit 1
fi

######################################## job abort with manual cancel 
echo "Test Job abort with manual cancel" 
memx1=`dio87c -- memory`

dio87c -- ra r1 || exit 1
# first task
dio87c -- rta r1 t1 || exit 1
dio87c -- rtoa r1 t1 add always || exit 1

dio87c -- rja r1 t1 j1 || exit 1
dio87c -- rjsp r1 t1 j1 "$JOBPATH/job3.sh"
dio87c -- rjsoec r1 t1 j1 false || exit 1

dio87c -- rja r1 t1 j2 || exit 1
dio87c -- rjsp r1 t1 j2 "$JOBPATH/job2.sh" || exit 1

dio87c -- rjda r1 t1 j1 j2 onsuccess || exit 1

dio87c -- ese true || exit 1
dio87c -- rp r1 "$dayDate" d1 >/dev/null || exit 1

echo "  Start job with abort"
waitretry 5 "dio87c -- xjl -sS! d1 t1 | grep j1" "j1!abort_stopped"
if [ $? -ne 0 ] ; then
	echo "The first job isn't abort_stopped."; exit 1
fi
if [ "`dio87c -- xjdl -sS! d1 t1`" != "j1!j2!waiting" ]; then
	echo "The job dependence isn't waiting."; exit 1
fi
if [ "`dio87c -- xjl -sS! d1 t1 | grep j2`" != "j2!wait_for_dep" ]; then
	echo "The second job isn't waiting for dep."; exit 1
fi
if [ "`dio87c -- xtl -sS! d1 | grep t1`" != "t1!running" ]; then
	echo "The task isn't running."; exit 1
fi

echo "  Cancel job"
# cancel job 
dio87c -- xju d1 t1 j1 canceled
if [ $? -ne 0 ] ; then
	echo "Can't cancel job"; exit 1
fi

waitretry 5 "dio87c -- xjl -sS! d1 t1 | grep j1" "j1!canceled"
if [ $? -ne 0 ] ; then
	echo "The first job isn't canceled."; exit 1
fi
if [ "`dio87c -- xjdl -sS! d1 t1`" != "j1!j2!canceled" ]; then
	echo "The job dependence isn't canceled.";  exit 1
fi
if [ "`dio87c -- xjl -sS! d1 t1 | grep j2`" != "j2!canceled" ]; then
	echo "The second job isn't canceled.";  exit 1
fi
if [ "`dio87c -- xtl -sS! d1 | grep t1`" != "t1!terminated" ]; then
	echo "The task isn't terminated.";  exit 1
fi

dio87c -- rk r1 || exit 1
dio87c -- srk r1 || exit 1
dio87c -- xdk d1 || exit 1
dio87c -- ldk d1 || exit 1

waitMessageSending
memx2=`dio87c -- memory`
if [ $memx2 -ne $memx1 ] ; then 
	echo "memory delta different for dio87d $memx1 -> $memx2"; exit 1
fi

######################################## abort with manual validation 
echo "Test Job abort with manual validation" 
memx1=`dio87c -- memory`

dio87c -- ra r1 || exit 1
dio87c -- rta r1 t1 || exit 1
dio87c -- rtoa r1 t1 add always || exit 1

dio87c -- rja r1 t1 j1 || exit 1
dio87c -- rjsp r1 t1 j1 "$JOBPATH/job3.sh"
dio87c -- rjsoec r1 t1 j1 false || exit 1

dio87c -- rja r1 t1 j2 || exit 1
dio87c -- rjsp r1 t1 j2 "$JOBPATH/job2.sh" || exit 1

dio87c -- rjda r1 t1 j1 j2 onsuccess || exit 1

dio87c -- ese true || exit 1
dio87c -- rp r1 "$dayDate" d1 >/dev/null || exit 1

echo "  Start job with abort"
waitretry 5 "dio87c -- xjl -sS! d1 t1 | grep j1" "j1!abort_stopped"
if [ $? -ne 0 ] ; then
	echo "The first job isn't abort_stopped."; exit 1
fi
if [ "`dio87c -- xjdl -sS! d1 t1`" != "j1!j2!waiting" ]; then
	echo "The job dependence isn't waiting."; exit 1
fi
if [ "`dio87c -- xjl -sS! d1 t1 | grep j2`" != "j2!wait_for_dep" ]; then
	echo "The second job isn't waiting for dep."; exit 1
fi
if [ "`dio87c -- xtl -sS! d1 | grep t1`" != "t1!running" ]; then
	echo "The task isn't running."; exit 1
fi

echo "  validate job termination"
dio87c -- xju d1 t1 j1 terminated 
if [ $? -ne 0 ] ; then
	echo "Can't terminate job"; exit 1
fi

waitretry 5 "dio87c -- xjl -sS! d1 t1 | grep j1" "j1!terminated"
if [ $? -ne 0 ] ; then
	echo "The first job isn't terminated.";  exit 1
fi
if [ "`dio87c -- xjdl -sS! d1 t1`" != "j1!j2!validated" ]; then
	echo "The job dependence isn't validated.";  exit 1
fi
waitretry 5 "dio87c -- xjl -sS! d1 t1 | grep j2" "j2!terminated"
if [ $? -ne 0 ] ; then
	echo "The second job isn't terminated.";  exit 1
fi
if [ "`dio87c -- xtl -sS! d1 | grep t1`" != "t1!terminated" ]; then
	echo "The task isn't terminated.";  exit 1
fi

dio87c -- rk r1 || exit 1
dio87c -- srk r1 || exit 1
dio87c -- xdk d1 || exit 1
dio87c -- ldk d1 || exit 1

waitMessageSending
memx2=`dio87c -- memory`
if [ $memx2 -ne $memx1 ] ; then 
	echo "memory delta different for dio87d $memx1 -> $memx2"; exit 1
fi

######################################## abort with manual abort validation 
echo "Test Job abort with manual abort validation" 
memx1=`dio87c -- memory`

dio87c -- ra r1 || exit 1
dio87c -- rta r1 t1 || exit 1
dio87c -- rtoa r1 t1 add always || exit 1

dio87c -- rja r1 t1 j1 || exit 1
dio87c -- rjsp r1 t1 j1 "$JOBPATH/job3.sh"
dio87c -- rjsoec r1 t1 j1 false || exit 1

dio87c -- rja r1 t1 j2 || exit 1
dio87c -- rjsp r1 t1 j2 "$JOBPATH/job2.sh" || exit 1

dio87c -- rjda r1 t1 j1 j2 onsuccess || exit 1

dio87c -- ese true || exit 1
dio87c -- rp r1 "$dayDate" d1 >/dev/null || exit 1

echo "  Start job with abort"
waitretry 5 "dio87c -- xjl -sS! d1 t1 | grep j1" "j1!abort_stopped"
if [ $? -ne 0 ] ; then
	echo "The first job isn't abort_stopped."; exit 1
fi
if [ "`dio87c -- xjdl -sS! d1 t1`" != "j1!j2!waiting" ]; then
	echo "The job dependence isn't waiting."; exit 1
fi
if [ "`dio87c -- xjl -sS! d1 t1 | grep j2`" != "j2!wait_for_dep" ]; then
	echo "The second job isn't waiting for dep."; exit 1
fi
if [ "`dio87c -- xtl -sS! d1 | grep t1`" != "t1!running" ]; then
	echo "The task isn't running."; exit 1
fi

echo "  validate job abort"
dio87c -- xju d1 t1 j1 aborted 0
if [ $? -ne 0 ] ; then
	echo "Can't validate job abort"; exit 1
fi

waitretry 5 "dio87c -- xjl -sS! d1 t1 | grep j1" "j1!aborted"
if [ $? -ne 0 ] ; then
	echo "The first job isn't aborted."; exit 1
fi
if [ "`dio87c -- xjdl -sS! d1 t1`" != "j1!j2!canceled" ]; then
	echo "The job dependence isn't canceled."; exit 1
fi
if [ "`dio87c -- xjl -sS! d1 t1 | grep j2`" != "j2!canceled" ]; then
	echo "The second job isn't canceled."; exit 1
fi
if [ "`dio87c -- xtl -sS! d1 | grep t1`" != "t1!aborted" ]; then
	echo "The task isn't aborted."; exit 1
fi

dio87c -- rk r1 || exit 1
dio87c -- srk r1 || exit 1
dio87c -- xdk d1 || exit 1
dio87c -- ldk d1 || exit 1

waitMessageSending
memx2=`dio87c -- memory`
if [ $memx2 -ne $memx1 ] ; then 
	echo "memory delta different for dio87d $memx1 -> $memx2"; exit 1
fi

######################################## task onerrorcontinue=false with abort
echo "Test task with OnErrorContinue=false and abort" 
memx1=`dio87c -- memory`

dio87c -- ra r1 || exit 1

# first task
dio87c -- rta r1 t1 || exit 1
dio87c -- rtoa r1 t1 add always || exit 1
dio87c -- rja r1 t1 j1 || exit 1
dio87c -- rjsp r1 t1 j1 "$JOBPATH/job3.sh"
dio87c -- rtsoec r1 t1 false || exit 1

# second task
dio87c -- rta r1 t2 || exit 1
dio87c -- rtoa r1 t2 add always || exit 1
dio87c -- rja r1 t1 j2 || exit 1
dio87c -- rjsp r1 t1 j2 "$JOBPATH/job1.sh"

dio87c -- rtda r1 t1 t2 onsuccess

dio87c -- ese true || exit 1
dio87c -- rp r1 "$dayDate" d1 >/dev/null || exit 1

waitretry 9 "dio87c -- xtl -sS! d1 | grep t1" "t1!abort_stopped"
if [ $? -ne 0 ] ; then
	echo "The first task isn't abort_stopped."; exit 1
fi
if [ "`dio87c -- xtdl -sS! d1 `" != "t1!t2!waiting" ]; then
	echo "The task dependence isn't waiting."; exit 1
fi
if [ "`dio87c -- xtl -sS! d1 | grep t2`" != "t2!wait_for_dep" ]; then
	echo "The second task isn't waiting for dep."; exit 1
fi

dio87c -- rk r1 || exit 1
dio87c -- srk r1 || exit 1
dio87c -- xdk d1 || exit 1
dio87c -- ldk d1 || exit 1

waitMessageSending
memx2=`dio87c -- memory`
if [ $memx2 -ne $memx1 ] ; then 
	echo "memory delta different for dio87d $memx1 -> $memx2"; exit 1
fi

####################################### task onerrorcontinue=false with no abort
echo "Test task with OnErrorContinue=false and no abort" 
memx1=`dio87c -- memory`

dio87c -- ra r1 || exit 1

# first task
dio87c -- rta r1 t1 || exit 1
dio87c -- rtoa r1 t1 add always || exit 1
dio87c -- rja r1 t1 j1 || exit 1
dio87c -- rjsp r1 t1 j1 "$JOBPATH/job1.sh"
dio87c -- rtsoec r1 t1 false || exit 1

# second task
dio87c -- rta r1 t2 || exit 1
dio87c -- rtoa r1 t2 add always || exit 1
dio87c -- rja r1 t1 j2 || exit 1
dio87c -- rjsp r1 t1 j2 "$JOBPATH/job1.sh"

dio87c -- rtda r1 t1 t2 onsuccess

dio87c -- ese true || exit 1
dio87c -- rp r1 "$dayDate" d1 >/dev/null || exit 1

waitretry 9 "dio87c -- xtl -sS! d1 | grep t1" "t1!terminated"
if [ $? -ne 0 ] ; then
	echo "The first task isn't terminated."; exit 1
fi
if [ "`dio87c -- xtdl -sS! d1 `" != "t1!t2!validated" ]; then
	echo "The task dependence isn't validated."; exit 1
fi
if [ "`dio87c -- xtl -sS! d1 | grep t2`" != "t2!terminated" ]; then
	echo "The second task isn't terminated."; exit 1
fi

dio87c -- rk r1 || exit 1
dio87c -- srk r1 || exit 1
dio87c -- xdk d1 || exit 1
dio87c -- ldk d1 || exit 1

waitMessageSending
memx2=`dio87c -- memory`
if [ $memx2 -ne $memx1 ] ; then 
	echo "memory delta different for dio87d $memx1 -> $memx2"; exit 1
fi

######################################## task onerrorcontinue=true with abort
echo "Test task with OnErrorContinue=true and abort" 
memx1=`dio87c -- memory`

dio87c -- ra r1 || exit 1

# first task
dio87c -- rta r1 t1 || exit 1
dio87c -- rtoa r1 t1 add always || exit 1
dio87c -- rja r1 t1 j1 || exit 1
dio87c -- rjsp r1 t1 j1 "$JOBPATH/job3.sh"
dio87c -- rtsoec r1 t1 true || exit 1

# second task
dio87c -- rta r1 t2 || exit 1
dio87c -- rtoa r1 t2 add always || exit 1
dio87c -- rja r1 t1 j2 || exit 1
dio87c -- rjsp r1 t1 j2 "$JOBPATH/job1.sh"

dio87c -- rtda r1 t1 t2 onsuccess

dio87c -- ese true || exit 1
dio87c -- rp r1 "$dayDate" d1 >/dev/null || exit 1

waitretry 9 "dio87c -- xtl -sS! d1 | grep t1" "t1!aborted" 
if [ $? -ne 0 ] ; then
	echo "The first task isn't aborted."; exit 1
fi
if [ "`dio87c -- xtdl -sS! d1 `" != "t1!t2!canceled" ]; then
	echo "The task dependence isn't canceled."; exit 1
fi
if [ "`dio87c -- xtl -sS! d1 | grep t2`" != "t2!canceled" ]; then
	echo "The second task isn't canceled."; exit 1
fi

dio87c -- rk r1 || exit 1
dio87c -- srk r1 || exit 1
dio87c -- xdk d1 || exit 1
dio87c -- ldk d1 || exit 1

waitMessageSending
memx2=`dio87c -- memory`
if [ $memx2 -ne $memx1 ] ; then 
	echo "memory delta different for dio87d $memx1 -> $memx2"; exit 1
fi

######################################## task onerrorcontinue=true with no abort
echo "Test task with OnErrorContinue=true and no abort" 
memx1=`dio87c -- memory`

dio87c -- ra r1 || exit 1

# first task
dio87c -- rta r1 t1 || exit 1
dio87c -- rtoa r1 t1 add always || exit 1
dio87c -- rja r1 t1 j1 || exit 1
dio87c -- rjsp r1 t1 j1 "$JOBPATH/job1.sh"
dio87c -- rtsoec r1 t1 true || exit 1

# second task
dio87c -- rta r1 t2 || exit 1
dio87c -- rtoa r1 t2 add always || exit 1
dio87c -- rja r1 t1 j2 || exit 1
dio87c -- rjsp r1 t1 j2 "$JOBPATH/job1.sh"

dio87c -- rtda r1 t1 t2 onsuccess

dio87c -- ese true || exit 1
dio87c -- rp r1 "$dayDate" d1 >/dev/null || exit 1

waitretry 9 "dio87c -- xtl -sS! d1 | grep t1" "t1!terminated" 
if [ $? -ne 0 ] ; then
	echo "The first task isn't terminated."; exit 1
fi
if [ "`dio87c -- xtdl -sS! d1 `" != "t1!t2!validated" ]; then
	echo "The task dependence isn't validated."; exit 1
fi
if [ "`dio87c -- xtl -sS! d1 | grep t2`" != "t2!terminated" ]; then
	echo "The second task isn't terminated."; exit 1
fi

dio87c -- rk r1 || exit 1
dio87c -- srk r1 || exit 1
dio87c -- xdk d1 || exit 1
dio87c -- ldk d1 || exit 1

waitMessageSending
memx2=`dio87c -- memory`
if [ $memx2 -ne $memx1 ] ; then 
	echo "memory delta different for dio87d $memx1 -> $memx2"; exit 1
fi

######################################## task abort with manual restart 
echo "Test task abort with manual restart" 
memx1=`dio87c -- memory`

TMPFILE="$DATAPATH/dg87fic$$"
if [ -f $TMPFILE ] ; then
	"File '$TMPFILE' already exists"; exit 1
fi
dio87c -- ra r1 || exit 1

# first task
dio87c -- rta r1 t1 || exit 1
dio87c -- rtoa r1 t1 add always || exit 1
dio87c -- rja r1 t1 j1 || exit 1
dio87c -- rjsp r1 t1 j1 "$JOBPATH/job7.sh"
dio87c -- rjsa r1 t1 j1 "$TMPFILE"
dio87c -- rtsoec r1 t1 false || exit 1

# second task
dio87c -- rta r1 t2 || exit 1
dio87c -- rtoa r1 t2 add always || exit 1
dio87c -- rja r1 t2 j1 || exit 1
dio87c -- rjsp r1 t2 j1 "$JOBPATH/job1.sh"

dio87c -- rtda r1 t1 t2 onsuccess || exit 1

dio87c -- ese true || exit 1
dio87c -- rp r1 "$dayDate" d1 >/dev/null || exit 1

echo "  Start job with abort"
waitretry 9 "dio87c -- xjl -sS! d1 t1 | grep j1" "j1!aborted" 
if [ $? -ne 0 ] ; then
	echo "The job isn't aborted."; exit 1
fi
if [ "`dio87c -- xtl -sS! d1 | grep t1`" != "t1!abort_stopped" ]; then
	echo "The first task isn't abort stopped."; exit 1
fi
if [ "`dio87c -- xtdl -sS! d1 `" != "t1!t2!waiting" ]; then
	echo "The task dependence isn't waiting."; exit 1
fi
if [ "`dio87c -- xtl -sS! d1 | grep t2`" != "t2!wait_for_dep" ]; then
	echo "The second task isn't waiting for dependence."; exit 1
fi

echo "  Restart job after correction"
# create the file
touch $TMPFILE
if [ $? != 0 ] ; then
	echo "Can't create file $TMPFILE". exit 1
fi

# restart job and task
dio87c -- xju d1 t1 j1 ready_to_run
if [ $? -ne 0 ] ; then
	echo "Can't restart job"; exit 1
fi
dio87c -- xtu d1 t1 running 
if [ $? -ne 0 ] ; then
	echo "Can't restart task"; exit 1
fi

waitretry 9 "dio87c -- xjl -sS! d1 t1 | grep j1" "j1!terminated"
if [ $? -ne 0 ]; then
	echo "The job isn't terminated."; rm $TMPFILE; exit 1
fi
if [ "`dio87c -- xtl -sS! d1 | grep t1`" != "t1!terminated" ]; then
	echo "The first task isn't terminated."; rm $TMPFILE; exit 1
fi
if [ "`dio87c -- xtdl -sS! d1 `" != "t1!t2!validated" ]; then
	echo "The task dependence isn't validated."; rm $TMPFILE; exit 1
fi
waitretry 5 "dio87c -- xtl -sS! d1 | grep t2" "t2!terminated" 
if [ $? -ne 0 ]; then
	echo "The second task isn't terminated."; rm $TMPFILE; exit 1
fi

rm $TMPFILE || exit 1

dio87c -- rk r1 || exit 1
dio87c -- srk r1 || exit 1
dio87c -- xdk d1 || exit 1
dio87c -- ldk d1 || exit 1

waitMessageSending
memx2=`dio87c -- memory`
if [ $memx2 -ne $memx1 ] ; then 
	echo "memory delta different for dio87d $memx1 -> $memx2"; exit 1
fi

######################################## task abort with manual cancel 
echo "Test task abort with manual cancel" 
memx1=`dio87c -- memory`

dio87c -- ra r1 || exit 1

# first task
dio87c -- rta r1 t1 || exit 1
dio87c -- rtoa r1 t1 add always || exit 1
dio87c -- rja r1 t1 j1 || exit 1
dio87c -- rjsp r1 t1 j1 "$JOBPATH/job3.sh"
dio87c -- rjsa r1 t1 j1 "$TMPFILE"
dio87c -- rtsoec r1 t1 false || exit 1

# second task
dio87c -- rta r1 t2 || exit 1
dio87c -- rtoa r1 t2 add always || exit 1
dio87c -- rja r1 t2 j1 || exit 1
dio87c -- rjsp r1 t2 j1 "$JOBPATH/job1.sh"

dio87c -- rtda r1 t1 t2 onsuccess || exit 1

dio87c -- ese true || exit 1
dio87c -- rp r1 "$dayDate" d1 >/dev/null || exit 1

echo "  Start job with abort"
waitretry 9 "dio87c -- xjl -sS! d1 t1 | grep j1" "j1!aborted" 
if [ $? -ne 0 ] ; then
	echo "The job isn't aborted."; exit 1
fi
if [ "`dio87c -- xtl -sS! d1 | grep t1`" != "t1!abort_stopped" ]; then
	echo "The first task isn't abort stopped."; exit 1
fi
if [ "`dio87c -- xtdl -sS! d1 `" != "t1!t2!waiting" ]; then
	echo "The task dependence isn't waiting."; exit 1
fi
if [ "`dio87c -- xtl -sS! d1 | grep t2`" != "t2!wait_for_dep" ]; then
	echo "The second task isn't waiting for dependence."; exit 1
fi


# cancel task 
echo "  Cancel task"
dio87c -- xtu d1 t1 canceled
if [ $? -ne 0 ] ; then
	echo "Can't cancel task"; exit 1
fi

waitretry 9 "dio87c -- xtl -sS! d1 | grep t1" "t1!canceled" 
if [ $? -ne 0 ] ; then
	echo "The first task isn't canceled."; exit 1
fi
if [ "`dio87c -- xtdl -sS! d1 `" != "t1!t2!canceled" ]; then
	echo "The task dependence isn't canceled.";  exit 1
fi
if [ "`dio87c -- xtl -sS! d1 | grep t2`" != "t2!canceled" ]; then
	echo "The second task isn't canceled.";  exit 1
fi

dio87c -- rk r1 || exit 1
dio87c -- srk r1 || exit 1
dio87c -- xdk d1 || exit 1
dio87c -- ldk d1 || exit 1

waitMessageSending
memx2=`dio87c -- memory`
if [ $memx2 -ne $memx1 ] ; then 
	echo "memory delta different for dio87d $memx1 -> $memx2"; exit 1
fi

######################################## task abort with manual validation 
echo "Test task abort with manual validation" 
memx1=`dio87c -- memory`

dio87c -- ra r1 || exit 1

# first task
dio87c -- rta r1 t1 || exit 1
dio87c -- rtoa r1 t1 add always || exit 1
dio87c -- rja r1 t1 j1 || exit 1
dio87c -- rjsp r1 t1 j1 "$JOBPATH/job3.sh"
dio87c -- rjsa r1 t1 j1 "$TMPFILE"
dio87c -- rtsoec r1 t1 false || exit 1

# second task
dio87c -- rta r1 t2 || exit 1
dio87c -- rtoa r1 t2 add always || exit 1
dio87c -- rja r1 t2 j1 || exit 1
dio87c -- rjsp r1 t2 j1 "$JOBPATH/job1.sh"

dio87c -- rtda r1 t1 t2 onsuccess || exit 1

dio87c -- ese true || exit 1
dio87c -- rp r1 "$dayDate" d1 >/dev/null || exit 1

echo "  Start job with abort"
waitretry 9 "dio87c -- xjl -sS! d1 t1 | grep j1" "j1!aborted"
if [ $? -ne 0 ] ; then
	echo "The job isn't aborted."; exit 1
fi
if [ "`dio87c -- xtl -sS! d1 | grep t1`" != "t1!abort_stopped" ]; then
	echo "The first task isn't abort stopped."; exit 1
fi
if [ "`dio87c -- xtdl -sS! d1 `" != "t1!t2!waiting" ]; then
	echo "The task dependence isn't waiting."; exit 1
fi
if [ "`dio87c -- xtl -sS! d1 | grep t2`" != "t2!wait_for_dep" ]; then
	echo "The second task isn't waiting for dependence."; exit 1
fi


# validate task termination 
echo "  Task validation"
dio87c -- xtu d1 t1 terminated 
if [ $? -ne 0 ] ; then
	echo "Can't terminate task"; exit 1
fi

waitretry 9 "dio87c -- xtl -sS! d1 | grep t1" "t1!terminated" 
if [ $? -ne 0 ]; then
	echo "The first task isn't terminated."; exit 1
fi
if [ "`dio87c -- xtdl -sS! d1 `" != "t1!t2!validated" ]; then
	echo "The task dependence isn't validated.";  exit 1
fi
waitretry 9 "dio87c -- xtl -sS! d1 | grep t2" "t2!terminated" 
if [ $? -ne 0 ]; then
	echo "The second task isn't terminated.";  exit 1
fi

dio87c -- rk r1 || exit 1
dio87c -- srk r1 || exit 1
dio87c -- xdk d1 || exit 1
dio87c -- ldk d1 || exit 1

waitMessageSending
memx2=`dio87c -- memory`
if [ $memx2 -ne $memx1 ] ; then 
	echo "memory delta different for dio87d $memx1 -> $memx2"; exit 1
fi


####################################### task abort with manual abort validation 
echo "Test task abort with manual abort validation" 
memx1=`dio87c -- memory`

dio87c -- ra r1 || exit 1

# first task
dio87c -- rta r1 t1 || exit 1
dio87c -- rtoa r1 t1 add always || exit 1
dio87c -- rja r1 t1 j1 || exit 1
dio87c -- rjsp r1 t1 j1 "$JOBPATH/job3.sh"
dio87c -- rjsa r1 t1 j1 "$TMPFILE"
dio87c -- rtsoec r1 t1 false || exit 1

# second task
dio87c -- rta r1 t2 || exit 1
dio87c -- rtoa r1 t2 add always || exit 1
dio87c -- rja r1 t2 j1 || exit 1
dio87c -- rjsp r1 t2 j1 "$JOBPATH/job1.sh"

dio87c -- rtda r1 t1 t2 onsuccess || exit 1

dio87c -- ese true || exit 1
dio87c -- rp r1 "$dayDate" d1 >/dev/null || exit 1

echo "  Start job with abort"
waitretry 9 "dio87c -- xjl -sS! d1 t1 | grep j1" "j1!aborted" 
if [ $? -ne 0 ] ; then
	echo "The job isn't aborted."; exit 1
fi
if [ "`dio87c -- xtl -sS! d1 | grep t1`" != "t1!abort_stopped" ]; then
	echo "The first task isn't abort stopped."; exit 1
fi
if [ "`dio87c -- xtdl -sS! d1 `" != "t1!t2!waiting" ]; then
	echo "The task dependence isn't waiting."; exit 1
fi
if [ "`dio87c -- xtl -sS! d1 | grep t2`" != "t2!wait_for_dep" ]; then
	echo "The second task isn't waiting for dependence."; exit 1
fi

# validate task abort 
echo "  Task abort validation"
dio87c -- xtu d1 t1 aborted 
if [ $? -ne 0 ] ; then
	echo "Can't abort task"; exit 1
fi
sleep 1

waitretry 9 "dio87c -- xtl -sS! d1 | grep t1" "t1!aborted" 
if [ $? -ne 0 ]; then
	echo "The first task isn't aborted."; exit 1
fi
if [ "`dio87c -- xtdl -sS! d1 `" != "t1!t2!canceled" ]; then
	echo "The task dependence isn't canceled.";  exit 1
fi
if [ "`dio87c -- xtl -sS! d1 | grep t2`" != "t2!canceled" ]; then
	echo "The second task isn't canceled.";  exit 1
fi

dio87c -- rk r1 || exit 1
dio87c -- srk r1 || exit 1
dio87c -- xdk d1 || exit 1
dio87c -- ldk d1 || exit 1

waitMessageSending
memx2=`dio87c -- memory`
if [ $memx2 -ne $memx1 ] ; then 
	echo "memory delta different for dio87d $memx1 -> $memx2"; exit 1
fi

stopDio87d || exit 1
