#!/bin/sh
#
# file tst11.sh 
# (test 'ignored' state for job and task)
#
#      Diogene87
#	Copyright (C) 2003,2004,2005 - Dominique Parisot
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this software; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
# Boston, MA 02111-1307 USA
#

if [ "$srcdir" = "" ]; then srcdir="."; fi
. $srcdir/functions.sh
checkNoDaemon

echo "test 'ignored' state for job and task"

startDio87d || exit 1


######################################## job ignored state 
echo "Test Job ignored state" 
memx1=`dio87c -- memory`
dio87c -- ra r1 || exit 1

dio87c -- rta r1 t1 || exit 1
dio87c -- rtoa r1 t1 add always || exit 1
dio87c -- rtst r1 t1 localhost || exit 1
dio87c -- rja r1 t1 j1 || exit 1
dio87c -- rjsp r1 t1 j1 "$JOBPATH/job1.sh"
dio87c -- rja r1 t1 j2 || exit 1
dio87c -- rjsp r1 t1 j2 "$JOBPATH/job1.sh"
dio87c -- rja r1 t1 j3 || exit 1
dio87c -- rjsp r1 t1 j3 "$JOBPATH/job1.sh"
dio87c -- rja r1 t1 j4 || exit 1
dio87c -- rjsp r1 t1 j4 "$JOBPATH/job1.sh"
dio87c -- rja r1 t1 j5 || exit 1
dio87c -- rjsp r1 t1 j5 "$JOBPATH/job1.sh"

dio87c -- rjda r1 t1 j1 j2 always || exit 1
dio87c -- rjda r1 t1 j2 j3 always || exit 1
dio87c -- rjda r1 t1 j2 j4 onsuccess || exit 1
dio87c -- rjda r1 t1 j2 j5 onerror || exit 1

dio87c -- ese true || exit 1
dio87c -- rp -d r1 "$dayDate" d1 >/dev/null || exit 1
sleep 2
dio87c -- xju d1 t1 j2 ignore 
if [ $? -ne 0 ]; then echo "Can't ignore job."; exit 1; fi
if [ "`dio87c -- xjl -sS! d1 t1 | grep j2`" != "j2!ignore" ]; then
	echo "The job isn't in ignore state."; exit 1
fi

dio87c -- xdse d1 true || exit 1
sleep 4
# verify dependencies
waitretry 9 "dio87c -- xjdl -sS! d1 t1 | grep j1" "j1!j2!validated"
if [ $? -ne 0 ]; then
	echo "The dependence j1-j2 isn't validated."; exit 1
fi
waitretry 9 "dio87c -- xjdl -sS! d1 t1 | grep j3" "j2!j3!validated" 
if [ $? -ne 0 ]; then
	echo "The dependence j2-j3 isn't validated."; exit 1
fi
waitretry 9 "dio87c -- xjdl -sS! d1 t1 | grep j4" "j2!j4!validated" 
if [ $? -ne 0 ]; then
	echo "The dependence j2-j4 isn't validated."; exit 1
fi
waitretry 9 "dio87c -- xjdl -sS! d1 t1 | grep j5" "j2!j5!canceled"
if [ $? -ne 0 ]; then
	echo "The dependence j2-j5 isn't canceled."; exit 1
fi

# verify jobs
waitretry 9 "dio87c -- xjl -sS! d1 t1 | grep j1" "j1!terminated" 
if [ $? -ne 0 ]; then
	echo "The first job isn't terminated."; exit 1
fi
waitretry 9 "dio87c -- xjl -sS! d1 t1 | grep j2" "j2!ignored" 
if [ $? -ne 0 ]; then
	echo "The second job isn't ignored."; exit 1
fi
waitretry 9 "dio87c -- xjl -sS! d1 t1 | grep j3" "j3!terminated" 
if [ $? -ne 0 ]; then
	echo "The job (always) isn't terminated."; exit 1
fi
waitretry 9 "dio87c -- xjl -sS! d1 t1 | grep j4" "j4!terminated" 
if [ $? -ne 0 ]; then
	echo "The job (onsuccess) isn't terminated."; exit 1
fi
waitretry 9 "dio87c -- xjl -sS! d1 t1 | grep j5" "j5!canceled" 
if [ $? -ne 0 ]; then
	echo "The job (onerror) isn't terminated."; exit 1
fi
dio87c -- rk r1 || exit 1
dio87c -- srk r1 || exit 1
dio87c -- xdk d1 || exit 1
dio87c -- ldk d1 || exit 1

waitMessageSending
memx2=`dio87c -- memory`
if [ $memx2 -ne $memx1 ] ; then 
	echo "memory delta different for dio87d $memx1 -> $memx2"; exit 1
fi

######################################## task ignored state 
echo "Test Task ignored state" 
memx1=`dio87c -- memory`
dio87c -- ra r1 || exit 1

dio87c -- rta r1 t1 || exit 1
dio87c -- rtoa r1 t1 add always || exit 1
dio87c -- rtst r1 t1 localhost || exit 1
dio87c -- rja r1 t1 j1 || exit 1
dio87c -- rjsp r1 t1 j1 "$JOBPATH/job1.sh"

dio87c -- rta r1 t2 || exit 1
dio87c -- rtoa r1 t2 add always || exit 1
dio87c -- rtst r1 t2 localhost || exit 1
dio87c -- rja r1 t2 j1 || exit 1
dio87c -- rjsp r1 t2 j1 "$JOBPATH/job1.sh"

dio87c -- rta r1 t3 || exit 1
dio87c -- rtoa r1 t3 add always || exit 1
dio87c -- rtst r1 t3 localhost || exit 1
dio87c -- rja r1 t3 j1 || exit 1
dio87c -- rjsp r1 t3 j1 "$JOBPATH/job1.sh"

dio87c -- rta r1 t4 || exit 1
dio87c -- rtoa r1 t4 add always || exit 1
dio87c -- rtst r1 t4 localhost || exit 1
dio87c -- rja r1 t4 j1 || exit 1
dio87c -- rjsp r1 t4 j1 "$JOBPATH/job1.sh"

dio87c -- rta r1 t5 || exit 1
dio87c -- rtoa r1 t5 add always || exit 1
dio87c -- rtst r1 t5 localhost || exit 1
dio87c -- rja r1 t5 j1 || exit 1
dio87c -- rjsp r1 t5 j1 "$JOBPATH/job1.sh"

dio87c -- rtda r1 t1 t2 always || exit 1
dio87c -- rtda r1 t2 t3 always || exit 1
dio87c -- rtda r1 t2 t4 onsuccess || exit 1
dio87c -- rtda r1 t2 t5 onerror || exit 1

dio87c -- ese true || exit 1
dio87c -- rp -d r1 "$dayDate" d1 >/dev/null || exit 1
sleep 2
dio87c -- xtu d1 t2 ignore 
if [ $? -ne 0 ]; then echo "Can't ignore task."; exit 1; fi
if [ "`dio87c -- xtl -sS! d1 | grep t2`" != "t2!ignore" ]; then
	echo "The task isn't in ignore state."; exit 1
fi

dio87c -- xdse d1 true || exit 1
sleep 3

# verify dependencies
waitretry 9 "dio87c -- xtdl -sS! d1 | grep t1" "t1!t2!validated" 
if [ $? -ne 0 ]; then
	echo "The dependence t1-t2 isn't validated."; exit 1
fi
waitretry 9 "dio87c -- xtdl -sS! d1 | grep t3" "t2!t3!validated" 
if [ $? -ne 0 ]; then
	echo "The dependence t2-t3 isn't validated."; exit 1
fi
waitretry 9 "dio87c -- xtdl -sS! d1 | grep t4" "t2!t4!validated" 
if [ $? -ne 0 ]; then
	echo "The dependence t2-t4 isn't validated."; exit 1
fi
waitretry 9 "dio87c -- xtdl -sS! d1 | grep t5" "t2!t5!canceled"
if [ $? -ne 0 ]; then
	echo "The dependence t2-t5 isn't canceled."; exit 1
fi


# verify jobs
waitretry 9 "dio87c -- xtl -sS! d1 | grep t1" "t1!terminated" 
if [ $? -ne 0 ]; then
	echo "The first task isn't terminated."; exit 1
fi
waitretry 9 "dio87c -- xtl -sS! d1 | grep t2" "t2!ignored" 
if [ $? -ne 0 ]; then
	echo "The second task isn't ignored."; exit 1
fi
waitretry 9 "dio87c -- xtl -sS! d1 | grep t3" "t3!terminated" 
if [ $? -ne 0 ]; then
	echo "The task (always) isn't terminated."; exit 1
fi
waitretry 9 "dio87c -- xtl -sS! d1 | grep t4" "t4!terminated" 
if [ $? -ne 0 ]; then
	echo "The task (onsuccess) isn't terminated."; exit 1
fi
waitretry 9 "dio87c -- xtl -sS! d1 | grep t5" "t5!canceled" 
if [ $? -ne 0 ]; then
	echo "The task (onerror) isn't terminated."; exit 1
fi
dio87c -- rk r1 || exit 1
dio87c -- srk r1 || exit 1
dio87c -- xdk d1 || exit 1
dio87c -- ldk d1 || exit 1

waitMessageSending
memx2=`dio87c -- memory`
if [ $memx2 -ne $memx1 ] ; then 
	echo "memory delta different for dio87d $memx1 -> $memx2"; exit 1
fi

stopDio87d || exit 1
