#!/bin/sh
#
# file tst14.sh 
# (test ejm commands)
#
#      Diogene87
#	Copyright (C) 2003,2004,2005 - Dominique Parisot
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this software; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
# Boston, MA 02111-1307 USA
#

if [ "$srcdir" = "" ]; then srcdir="."; fi
. $srcdir/functions.sh
checkNoDaemon

echo "test ejm/etm commands"

startDio87d || exit 1

######################################## 
echo "Test monitor commands" 
memx1=`dio87c -- memory`

# first referential
# j1 -> (j2,j3,j4)
dio87c -- ra r1 || exit 1
dio87c -- rta r1 t1 || exit 1
dio87c -- rtoa r1 t1 add always || exit 1
dio87c -- rtst r1 t1 localhost || exit 1

dio87c -- rja r1 t1 j1 || exit 1
dio87c -- rjsp r1 t1 j1 "$JOBPATH/job4.sh"

dio87c -- rja r1 t1 j2 || exit 1
dio87c -- rjsp r1 t1 j2 "$JOBPATH/job4.sh"
dio87c -- rjda r1 t1 j1 j2 always

dio87c -- rja r1 t1 j3 || exit 1
dio87c -- rjsp r1 t1 j3 "$JOBPATH/job4.sh"
dio87c -- rjda r1 t1 j2 j3 onerror 

dio87c -- rja r1 t1 j4 || exit 1
dio87c -- rjsp r1 t1 j4 "$JOBPATH/job4.sh"
dio87c -- rjda r1 t1 j2 j4 onsuccess

# second referential
# (j1,j2)->j3
# first task
dio87c -- ra r2 || exit 1
dio87c -- rta r2 t1 || exit 1
dio87c -- rtoa r2 t1 add always || exit 1
dio87c -- rtst r2 t1 localhost || exit 1

dio87c -- rja r2 t1 j1 || exit 1
dio87c -- rjsp r2 t1 j1 "$JOBPATH/job4.sh"

dio87c -- rja r2 t1 j2 || exit 1
dio87c -- rjsp r2 t1 j2 "$JOBPATH/job4.sh"

dio87c -- rja r2 t1 j3 || exit 1
dio87c -- rjsp r2 t1 j3 "$JOBPATH/job4.sh"

dio87c -- rjda r2 t1 j1 j3 always 
dio87c -- rjda r2 t1 j2 j3 always

# second task
dio87c -- rta r2 t2 || exit 1
dio87c -- rtoa r2 t2 add always || exit 1
dio87c -- rtst r2 t2 localhost || exit 1

# j1 aborts after 2 seconds
dio87c -- rja r2 t2 j1 || exit 1
dio87c -- rjsp r2 t2 j1 "$JOBPATH/job9.sh"

dio87c -- rja r2 t2 j2 || exit 1
dio87c -- rjsp r2 t2 j2 "$JOBPATH/job4.sh"

dio87c -- rjda r2 t2 j1 j2 always 

dio87c -- rtda r2 t1 t2 always

dio87c -- rp -d r1 "$dayDate" d1 >/dev/null || exit 1
sleep 1
dio87c -- rp -d r2 "$dayDate" d2 >/dev/null || exit 1
sleep 1

# hold first job
dio87c -- xjse d1 t1 j1 false || exit 1
# hold second task
dio87c -- xtse d2 t2 false || exit 1

dio87c -- xdse d1 true || exit 1
dio87c -- xdse d2 true || exit 1

######################################### Step 1 
echo "  step 1"
# verify that d1!t1!j1 is waiting
waitretry 5 "dio87c -- ejm -hS_ | grep \"d1_t1_j1\"" "H_d1_t1_j1_wait_enabled"
if [ $? -ne 0 ]; then 
	echo "Job d1!t1!j1 is not wait_enabled."; exit 1;
fi
# active d1!t1!j1
dio87c -- xjse d1 t1 j1 true || exit 1
# verify that j1 and j2 are running
waitretry 9 "dio87c -- ejm -hrectwS_ | grep \"d2_t1_j1\"" "R_d2_t1_j1_running"
if [ $? -ne 0 ]; then 
	echo "Job d2 t1 j1 is not running."; exit 1;
fi
######################################### Step 2
sleep 2
echo "  step 2"
# verify that j1 and j2 are terminated 
waitretry 9 "dio87c -- ejm -hrectwS_ | grep \"d2_t1_j1\"" "T_d2_t1_j1_terminated"
if [ $? -ne 0 ]; then 
	echo "Job d2 t1 j1 is not terminated."; exit 1;
fi
waitretry 9 "dio87c -- ejm -hrectwS_ | grep \"d2_t1_j2\"" "T_d2_t1_j2_terminated" 
if [ $? -ne 0 ]; then
	echo "Job d2 t1 j2 is not terminated."; exit 1;
fi

######################################### Step 3
sleep 2
echo "  step 3"
waitretry 9 "dio87c -- etm -hrectwS! | grep \"d2!t1\"" "T!d2!t1!terminated"
if [ $? -ne 0 ]; then 
	echo "Task d2!t1 isn't terminated."; exit 1;
fi
waitretry 9 "dio87c -- etm -hrectwS! | grep \"d2!t2\"" "H!d2!t2!wait_enabled" 
if [ $? -ne 0 ] ; then
	echo "Task d2!t2 isn't wait_enabled."; exit 1;
fi
# d2!t2 activation
dio87c -- xtse d2 t2 true || exit 1

######################################### Step 4
sleep 4
echo "  step 4"

# verify that d2!t2!j1 is aborted
waitretry 15 "dio87c -- ejm -hrectwS_ | grep \"d2_t2_j1\"" "E_d2_t2_j1_aborted" 
if [ $? -ne 0 ]; then 
	echo "Job d2 t2 j1 is not aborted."; exit 1;
fi

######################################### Step 5
sleep 2
echo "  step 5"
# verify that d2!t2 is aborted
waitretry 9 "dio87c -- etm -hrectwS_ | grep \"d2_t2\"" "E_d2_t2_aborted" 
if [ $? -ne 0 ]; then 
	echo "Task d2 t2 is not aborted."; exit 1;
fi

dio87c -- rk r1 || exit 1
dio87c -- srk r1 || exit 1
dio87c -- rk r2 || exit 1
dio87c -- srk r2 || exit 1
dio87c -- xdk d1 || exit 1
dio87c -- ldk d1 || exit 1
dio87c -- xdk d2 || exit 1
dio87c -- ldk d2 || exit 1

waitMessageSending
memx2=`dio87c -- memory`
if [ $memx2 -ne $memx1 ] ; then 
	echo "memory delta different for dio87d $memx1 -> $memx2"; exit 1
fi

stopDio87d || exit 1
