#!/bin/sh
#
# file tst19.sh 
# (test dio87d functions rtsr)
#
#      Diogene87
#	Copyright (C) 2003,2004,2005 - Dominique Parisot
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this software; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
# Boston, MA 02111-1307 USA
#


if [ "$srcdir" = "" ]; then srcdir="."; fi
. $srcdir/functions.sh
checkNoDaemon

echo "test dio87d functions rtsr"

startDio87d || exit 1

# dio87d : test 
mem1=`dio87c -- memory`
if [ $? != 0 ] ; then echo "error"; exit 1; fi

dio87c -- ra r1 || exit 1
dio87c -- rta r1 task1 || exit 1
dio87c -- rta r1 task2 || exit 1
dio87c -- rtoa r1 task2 add always || exit 1

################################################## always 
echo "test 'always' operation"
# verify that days are not selected
for d in "01" "02" "03" "04" "05" "06" "07" ; do
	if [ "`dio87c -- rtsr r1 task1 \"2003-12-$d\"`" != "N" ]; then
		echo "day is selected."; exit 1
	fi
done
dio87c -- rtoa r1 task1 add always || exit 1
# verify that all days are selected
for d in "01" "02" "03" "04" "05" "06" "07" ; do
	if [ "`dio87c -- rtsr r1 task1 \"2003-12-$d\"`" != "Y" ]; then
		echo "day is selected."; exit 1
	fi
done
dio87c -- rtok r1 task1 1 || exit 1


################################################## day_of_week 
echo "test 'day_of_week' operation"
# add / remove
echo "  'add' and 'remove' operators"
dio87c -- rtoa r1 task1 add day_of_week 1 || exit 1
dio87c -- rtoa r1 task2 remove day_of_week 1 || exit 1
for d in "01" "02" "03" "04" "05" "06"; do
	if [ "`dio87c -- rtsr r1 task1 \"2003-12-$d\"`" != "N" ]; then
		echo "day is selected (add)."; exit 1
	fi
	if [ "`dio87c -- rtsr r1 task2 \"2003-12-$d\"`" != "Y" ]; then
		echo "day isn't selected (remove)."; exit 1
	fi
done
for d in "12-07" "12-14" "12-21" "12-28"; do
	if [ "`dio87c -- rtsr r1 task1 \"2003-$d\"`" != "Y" ]; then
		echo "day is not selected (add)."; exit 1
	fi
	if [ "`dio87c -- rtsr r1 task2 \"2003-$d\"`" != "N" ]; then
		echo "day isn't not selected (remove)."; exit 1
	fi
done
dio87c -- rtok r1 task1 1 || exit 1
dio87c -- rtok r1 task2 2 || exit 1
dio87c -- rtoa r1 task1 add day_of_week 7 || exit 1
dio87c -- rtoa r1 task2 remove day_of_week 7 || exit 1
for d in "12-06" "12-13" "12-20" "12-27"; do
	if [ "`dio87c -- rtsr r1 task1 \"2003-$d\"`" != "Y" ]; then
		echo "day is not selected."; exit 1
	fi
	if [ "`dio87c -- rtsr r1 task2 \"2003-$d\"`" != "N" ]; then
		echo "day isn't not selected."; exit 1
	fi
done
dio87c -- rtok r1 task1 1 || exit 1
dio87c -- rtok r1 task2 2 || exit 1

# add_from / remove_from
echo "  'add_from' and 'remove_from' operators"
dio87c -- rtoa r1 task1 add_from day_of_week 3 || exit 1
dio87c -- rtoa r1 task2 remove_from day_of_week 3 || exit 1
for d in "12-07" "12-08" "12-14" "12-15"; do
	if [ "`dio87c -- rtsr r1 task1 \"2003-$d\"`" != "N" ]; then
		echo "day is selected. (add)"; exit 1
	fi
	if [ "`dio87c -- rtsr r1 task2 \"2003-$d\"`" != "Y" ]; then
		echo "day isn't selected. (remove)"; exit 1
	fi
done
for d in "12-09" "12-10" "12-11" "12-12" "12-13" "12-16"; do
	if [ "`dio87c -- rtsr r1 task1 \"2003-$d\"`" != "Y" ]; then
		echo "day is not selected (add)."; exit 1
	fi
	if [ "`dio87c -- rtsr r1 task2 \"2003-$d\"`" != "N" ]; then
		echo "day is selected (remove)."; exit 1
	fi
done
dio87c -- rtok r1 task1 1 || exit 1
dio87c -- rtok r1 task2 2 || exit 1

# add_until / remove_until
echo "  'add_until' and 'remove_until' operators"
dio87c -- rtoa r1 task1 add_until day_of_week 3 || exit 1
dio87c -- rtoa r1 task2 remove_until day_of_week 3 || exit 1
for d in "12-07" "12-08" "12-09" "12-14" "12-15" "12-16"; do
	if [ "`dio87c -- rtsr r1 task1 \"2003-$d\"`" != "Y" ]; then
		echo "day is not selected (add)."; exit 1
	fi
	if [ "`dio87c -- rtsr r1 task2 \"2003-$d\"`" != "N" ]; then
		echo "day is selected (remove)."; exit 1
	fi
done
for d in "12-10" "12-11" "12-12" "12-13" "12-17"; do
	if [ "`dio87c -- rtsr r1 task1 \"2003-$d\"`" != "N" ]; then
		echo "day is selected (add)."; exit 1
	fi
	if [ "`dio87c -- rtsr r1 task2 \"2003-$d\"`" != "Y" ]; then
		echo "day isn't selected (remove)."; exit 1
	fi
done
dio87c -- rtok r1 task1 1 || exit 1
dio87c -- rtok r1 task2 2 || exit 1


################################################## day_of_month
echo "test 'day_of_month' operation"
# add / remove
echo "  'add' and 'remove' operators"
dio87c -- rtoa r1 task1 add day_of_month 1 || exit 1
dio87c -- rtoa r1 task2 remove day_of_month 1 || exit 1
for d in "09-01" "10-01" "11-01" "12-01"; do
	if [ "`dio87c -- rtsr r1 task1 \"2003-$d\"`" != "Y" ]; then
		echo "day isn't selected (add)."; exit 1
	fi
	if [ "`dio87c -- rtsr r1 task2 \"2003-$d\"`" != "N" ]; then
		echo "day is selected (remove)."; exit 1
	fi
done
# verify that there's 29 days which are unselected from 2 to 30
if [ "`dio87c -- rtsr r1 task1 \"2003-11-02\" \"2003-11-30\" | grep N |wc -l | awk '{print$1}'`" != "29" ]; then
	echo "days are selected (add)"; exit 1
fi
# verify that there's 29 days which are selected from 2 to 30
if [ "`dio87c -- rtsr r1 task2 \"2003-11-02\" \"2003-11-30\" | grep Y |wc -l | awk '{print$1}'`" != "29" ]; then
	echo "days are not selected (remove)"; exit 1
fi
dio87c -- rtok r1 task1 1 || exit 1
dio87c -- rtok r1 task2 2 || exit 1

# day 31
dio87c -- rtoa r1 task1 add day_of_month 31 || exit 1
if [ "`dio87c -- rtsr r1 task1 \"2003-11-01\" \"2003-11-30\" | grep N |wc -l | awk '{print$1}'`" != "30" ]; then
	echo "days are selected (31)"; exit 1
fi
if [ "`dio87c -- rtsr r1 task1 \"2003-12-01\" \"2003-12-30\" | grep N |wc -l | awk '{print$1}'`" != "30" ]; then
	echo "days are selected (31)"; exit 1
fi
if [ "`dio87c -- rtsr r1 task1 \"2003-12-31\"`" != "Y" ]; then
	echo "day isn't selected (31)"; exit 1
fi
dio87c -- rtok r1 task1 1 || exit 1

# last day of the month
dio87c -- rtoa -- r1 task1 add day_of_month -1 || exit 1
dio87c -- rtoa -- r1 task2 remove day_of_month -1 || exit 1
for d in "09-30" "10-31" "11-30" "12-31" "02-28"; do
	if [ "`dio87c -- rtsr r1 task1 \"2003-$d\"`" != "Y" ]; then
		echo "day $d isn't selected (add)."; exit 1
	fi
	if [ "`dio87c -- rtsr r1 task2 \"2003-$d\"`" != "N" ]; then
		echo "day $d is selected (remove)."; exit 1
	fi
done
# verify that there's 29 days which are unselected from 1 to 29
if [ "`dio87c -- rtsr r1 task1 \"2003-11-01\" \"2003-11-29\" | grep N |wc -l | awk '{print$1}'`" != "29" ]; then
	echo "days are selected (add)"; exit 1
fi
# verify that there's 29 days which are selected from 1 to 29
if [ "`dio87c -- rtsr r1 task2 \"2003-11-01\" \"2003-11-29\" | grep Y |wc -l | awk '{print$1}'`" != "29" ]; then
	echo "days are not selected (remove)"; exit 1
fi
dio87c -- rtok r1 task1 1 || exit 1
dio87c -- rtok r1 task2 2 || exit 1

# day before last day of the month
dio87c -- rtoa -- r1 task1 add day_of_month -2 || exit 1
dio87c -- rtoa -- r1 task2 remove day_of_month -2 || exit 1
for d in "09-29" "10-30" "11-29" "12-30" "02-27"; do
	if [ "`dio87c -- rtsr r1 task1 \"2003-$d\"`" != "Y" ]; then
		echo "day $d isn't selected (-2) (add)."; exit 1
	fi
	if [ "`dio87c -- rtsr r1 task2 \"2003-$d\"`" != "N" ]; then
		echo "day $d is selected (-2) (remove)."; exit 1
	fi
done
# verify that there's 28 days which are unselected from 1 to 28
if [ "`dio87c -- rtsr r1 task1 \"2003-11-01\" \"2003-11-28\" | grep N |wc -l | awk '{print$1}'`" != "28" ]; then
	echo "days are selected (-2) (add)"; exit 1
fi
# verify that there's 28 days which are selected from 1 to 28
if [ "`dio87c -- rtsr r1 task2 \"2003-11-01\" \"2003-11-28\" | grep Y |wc -l | awk '{print$1}'`" != "28" ]; then
	echo "days are not selected (remove)"; exit 1
fi
# verify that last day isn't selected
if [ "`dio87c -- rtsr r1 task1 \"2003-11-30\"`" != "N" ]; then
	echo "last day is selected (-2) (add)."; exit 1
fi
if [ "`dio87c -- rtsr r1 task2 \"2003-11-30\"`" != "Y" ]; then
	echo "last day isn't selected (-2) (add)."; exit 1
fi
dio87c -- rtok r1 task1 1 || exit 1
dio87c -- rtok r1 task2 2 || exit 1

# add_from / remove_from
echo "  'add_from' and 'remove_from' operators"
dio87c -- rtoa r1 task1 add_from day_of_month 14 || exit 1
dio87c -- rtoa r1 task2 remove_from day_of_month 14 || exit 1
# verify that there's 13 days which are unselected from 1 to 13 
if [ "`dio87c -- rtsr r1 task1 \"2003-11-01\" \"2003-11-13\" | grep N |wc -l | awk '{print$1}'`" != "13" ]; then
	echo "days are selected (add)"; exit 1
fi
# verify that there's 14 days which are selected from 1 to 13
if [ "`dio87c -- rtsr r1 task2 \"2003-11-01\" \"2003-11-13\" | grep Y |wc -l | awk '{print$1}'`" != "13" ]; then
	echo "days are not selected (remove)"; exit 1
fi
# verify that there's 17 days which are selected from 14 to 30 
if [ "`dio87c -- rtsr r1 task1 \"2003-11-14\" \"2003-11-30\" | grep Y |wc -l | awk '{print$1}'`" != "17" ]; then
	echo "days are not selected (add)"; exit 1
fi
# verify that there's 17 days which are not selected from 14 to 30 
if [ "`dio87c -- rtsr r1 task2 \"2003-11-14\" \"2003-11-30\" | grep N |wc -l | awk '{print$1}'`" != "17" ]; then
	echo "days are selected (remove)"; exit 1
fi
# verify that there's 18 days which are selected from 14 to 31 
if [ "`dio87c -- rtsr r1 task1 \"2003-12-14\" \"2003-12-31\" | grep Y |wc -l | awk '{print$1}'`" != "18" ]; then
	echo "days are not selected (add)"; exit 1
fi
# verify that there's 18 days which are not selected from 14 to 31 
if [ "`dio87c -- rtsr r1 task2 \"2003-12-14\" \"2003-12-31\" | grep N |wc -l | awk '{print$1}'`" != "18" ]; then
	echo "days are selected (remove)"; exit 1
fi
dio87c -- rtok r1 task1 1 || exit 1
dio87c -- rtok r1 task2 2 || exit 1

# add_until / remove_until
echo "  'add_until' and 'remove_until' operators"
dio87c -- rtoa r1 task1 add_until day_of_month 14 || exit 1
dio87c -- rtoa r1 task2 remove_until day_of_month 14 || exit 1
# verify that there's 14 days which are selected from 1 to 14 
if [ "`dio87c -- rtsr r1 task1 \"2003-11-01\" \"2003-11-14\" | grep Y |wc -l | awk '{print$1}'`" != "14" ]; then
	echo "days are not selected (add)"; exit 1
fi
# verify that there's 14 days which are unselected from 1 to 14
if [ "`dio87c -- rtsr r1 task2 \"2003-11-01\" \"2003-11-14\" | grep N |wc -l | awk '{print$1}'`" != "14" ]; then
	echo "days are selected (remove)"; exit 1
fi
# verify that there's 16 days which are not selected from 15 to 30 
if [ "`dio87c -- rtsr r1 task1 \"2003-11-15\" \"2003-11-30\" | grep N |wc -l | awk '{print$1}'`" != "16" ]; then
	echo "days are selected (add)"; exit 1
fi
# verify that there's 16 days which are selected from 15 to 30 
if [ "`dio87c -- rtsr r1 task2 \"2003-11-15\" \"2003-11-30\" | grep Y |wc -l | awk '{print$1}'`" != "16" ]; then
	echo "days are no selected (remove)"; exit 1
fi
# verify that there's 17 days which are not selected from 15 to 31 
if [ "`dio87c -- rtsr r1 task1 \"2003-12-15\" \"2003-12-31\" | grep N |wc -l | awk '{print$1}'`" != "17" ]; then
	echo "days are selected (add)"; exit 1
fi
# verify that there's 17 days which are selected from 15 to 31 
if [ "`dio87c -- rtsr r1 task2 \"2003-12-15\" \"2003-12-31\" | grep Y |wc -l | awk '{print$1}'`" != "17" ]; then
	echo "days are not selected (remove)"; exit 1
fi
dio87c -- rtok r1 task1 1 || exit 1
dio87c -- rtok r1 task2 2 || exit 1


################################################## day_of_year
echo "test 'day_of_year' operation"
# add / remove
echo "  'add' and 'remove' operators"
dio87c -- rtoa r1 task1 add day_of_year 90 || exit 1
dio87c -- rtoa r1 task2 remove day_of_year 90 || exit 1
# verify that the first 89 days of the year are not selected 
if [ "`dio87c -- rtsr r1 task1 \"2003-01-01\" \"2003-03-30\" | grep N |wc -l | awk '{print$1}'`" != "89" ]; then
	echo "first 89 days are not unselected (add)"; exit 1
fi
# verify that the first 89 days of the year are selected 
if [ "`dio87c -- rtsr r1 task2 \"2003-01-01\" \"2003-03-30\" | grep Y |wc -l | awk '{print$1}'`" != "89" ]; then
	echo "first 89 days are not selected (remove)"; exit 1
fi
# verify that all days after 90 are selected 
if [ "`dio87c -- rtsr r1 task1 \"2003-04-01\" \"2003-12-31\" | grep N |wc -l | awk '{print$1}'`" != "275" ]; then
	echo "all days after 90 are not unselected (add)"; exit 1
fi
# verify that all days after 90 are selected 
if [ "`dio87c -- rtsr r1 task2 \"2003-04-01\" \"2003-12-31\" | grep Y |wc -l | awk '{print$1}'`" != "275" ]; then
	echo "all days after 90 are not selected (remove)"; exit 1
fi
# verify days which are selected
for d in "2003-03-31" "2004-03-30"; do
	if [ "`dio87c -- rtsr r1 task1 \"$d\"`" != "Y" ]; then
		echo "day $d isn't selected (add)."; exit 1
	fi
	if [ "`dio87c -- rtsr r1 task2 \"$d\"`" != "N" ]; then
		echo "day $d is selected (remove)."; exit 1
	fi
done
dio87c -- rtok r1 task1 1 || exit 1
dio87c -- rtok r1 task2 2 || exit 1

# negative value
dio87c -- rtoa -- r1 task1 add day_of_year -5 || exit 1
dio87c -- rtoa -- r1 task2 remove day_of_year -5 || exit 1
# verify that 364 days are unselected in 2003
if [ "`dio87c -- rtsr r1 task1 \"2003-01-01\" \"2003-12-31\" | grep N |wc -l | awk '{print$1}'`" != "364" ]; then
	echo "364 days are not unselected (add)"; exit 1
fi
# verify that 364 days are selected in 2003
if [ "`dio87c -- rtsr r1 task2 \"2003-01-01\" \"2003-12-31\" | grep Y |wc -l | awk '{print$1}'`" != "364" ]; then
	echo "364 days are not selected (remove)"; exit 1
fi
# verify the day witch is selected
if [ "`dio87c -- rtsr r1 task1 \"2003-12-27\"`" != "Y" ]; then
	echo "day $d isn't selected (add)."; exit 1
fi
# verify the day witch is not selected
if [ "`dio87c -- rtsr r1 task2 \"2003-12-27\"`" != "N" ]; then
	echo "day $d isn't unselected (remove)."; exit 1
fi
dio87c -- rtok r1 task1 1 || exit 1
dio87c -- rtok r1 task2 2 || exit 1


# add_from / remove_from
echo "  'add_from' and 'remove_from' operators"
dio87c -- rtoa r1 task1 add_from day_of_year 90 || exit 1
dio87c -- rtoa r1 task2 remove_from day_of_year 90 || exit 1
# verify that the first 89 days of the year are not selected 
if [ "`dio87c -- rtsr r1 task1 \"2003-01-01\" \"2003-03-30\" | grep N |wc -l | awk '{print$1}'`" != "89" ]; then
	echo "first 89 days are not unselected (add)"; exit 1
fi
# verify that the first 89 days of the year are selected 
if [ "`dio87c -- rtsr r1 task2 \"2003-01-01\" \"2003-03-30\" | grep Y |wc -l | awk '{print$1}'`" != "89" ]; then
	echo "first 89 days are not selected (remove)"; exit 1
fi
# verify that all days after 89 are selected 
if [ "`dio87c -- rtsr r1 task1 \"2003-04-01\" \"2003-12-31\" | grep Y |wc -l | awk '{print$1}'`" != "275" ]; then
	echo "all days after 89 are not selected (add)"; exit 1
fi
# verify that all days after 89 are selected 
if [ "`dio87c -- rtsr r1 task2 \"2003-04-01\" \"2003-12-31\" | grep N |wc -l | awk '{print$1}'`" != "275" ]; then
	echo "all days after 89 are not unselected (remove)"; exit 1
fi
dio87c -- rtok r1 task1 1 || exit 1
dio87c -- rtok r1 task2 2 || exit 1

# negative value
dio87c -- rtoa -- r1 task1 add_from day_of_year -5 || exit 1
dio87c -- rtoa -- r1 task2 remove_from day_of_year -5 || exit 1
# verify that the first 360 days of the year are not selected 
if [ "`dio87c -- rtsr r1 task1 \"2003-01-01\" \"2003-12-26\" | grep N |wc -l | awk '{print$1}'`" != "360" ]; then
	echo "first 360 days are not unselected (add)"; exit 1
fi
# verify that the first 360 days of the year are selected 
if [ "`dio87c -- rtsr r1 task2 \"2003-01-01\" \"2003-12-26\" | grep Y |wc -l | awk '{print$1}'`" != "360" ]; then
	echo "first 360 days are not selected (remove)"; exit 1
fi
# verify that last 5 days are selected 
if [ "`dio87c -- rtsr r1 task1 \"2003-12-27\" \"2003-12-31\" | grep Y |wc -l | awk '{print$1}'`" != "5" ]; then
	echo "last 5 days are not selected (add)"; exit 1
fi
# verify that last 5 days are unselected 
if [ "`dio87c -- rtsr r1 task2 \"2003-12-27\" \"2003-12-31\" | grep N |wc -l | awk '{print$1}'`" != "5" ]; then
	echo "last 5 days are not unselected (remove)"; exit 1
fi
dio87c -- rtok r1 task1 1 || exit 1
dio87c -- rtok r1 task2 2 || exit 1


# add_until / remove_until
echo "  'add_until' and 'remove_until' operators"
dio87c -- rtoa r1 task1 add_until day_of_year 90 || exit 1
dio87c -- rtoa r1 task2 remove_until day_of_year 90 || exit 1
# verify that the first 89 days of the year are selected 
if [ "`dio87c -- rtsr r1 task1 \"2003-01-01\" \"2003-03-30\" | grep Y |wc -l | awk '{print$1}'`" != "89" ]; then
	echo "first 89 days are not selected (add)"; exit 1
fi
# verify that the first 89 days of the year are unselected 
if [ "`dio87c -- rtsr r1 task2 \"2003-01-01\" \"2003-03-30\" | grep N |wc -l | awk '{print$1}'`" != "89" ]; then
	echo "first 89 days are not unselected (remove)"; exit 1
fi
# verify that all days after 89 are unselected 
if [ "`dio87c -- rtsr r1 task1 \"2003-04-01\" \"2003-12-31\" | grep N |wc -l | awk '{print$1}'`" != "275" ]; then
	echo "all days after 89 are not unselected (add)"; exit 1
fi
# verify that all days after 89 are selected 
if [ "`dio87c -- rtsr r1 task2 \"2003-04-01\" \"2003-12-31\" | grep Y |wc -l | awk '{print$1}'`" != "275" ]; then
	echo "all days after 89 are not selected (remove)"; exit 1
fi
dio87c -- rtok r1 task1 1 || exit 1
dio87c -- rtok r1 task2 2 || exit 1

# negative value
dio87c -- rtoa -- r1 task1 add_until day_of_year -5 || exit 1
dio87c -- rtoa -- r1 task2 remove_until day_of_year -5 || exit 1

# verify that the first 361 days of the year are selected 
if [ "`dio87c -- rtsr r1 task1 \"2003-01-01\" \"2003-12-27\" | grep Y |wc -l | awk '{print$1}'`" != "361" ]; then
	echo "first 361 days are not unselected (add)"; exit 1
fi
# verify that the first 361 days of the year are unselected 
if [ "`dio87c -- rtsr r1 task2 \"2003-01-01\" \"2003-12-27\" | grep N |wc -l | awk '{print$1}'`" != "361" ]; then
	echo "first 360 days are not unselected (remove)"; exit 1
fi
# verify that last 4 days are unselected 
if [ "`dio87c -- rtsr r1 task1 \"2003-12-28\" \"2003-12-31\" | grep N |wc -l | awk '{print$1}'`" != "4" ]; then
	echo "last 4 days are not unselected (add)"; exit 1
fi
# verify that last 4 days are selected 
if [ "`dio87c -- rtsr r1 task2 \"2003-12-28\" \"2003-12-31\" | grep Y |wc -l | awk '{print$1}'`" != "4" ]; then
	echo "last 4 days are not selected (remove)"; exit 1
fi
dio87c -- rtok r1 task1 1 || exit 1
dio87c -- rtok r1 task2 2 || exit 1


################################################## week_of_month 
echo "test 'week_of_month' operation"
# add / remove
echo "  'add' and 'remove' operators"
dio87c -- rtoa r1 task1 add week_of_month 2 || exit 1
dio87c -- rtoa r1 task2 remove week_of_month 2 || exit 1

# test Aug-2003
if [ "`dio87c -- rtsr r1 task1 \"2003-08-01\" \"2003-08-02\" | grep N |wc -l | awk '{print $1}'`" != "2" ] ; then
	echo "first 2 days of month are not unselected (add)"; exit 1
fi
if [ "`dio87c -- rtsr r1 task2 \"2003-08-01\" \"2003-08-02\" | grep Y |wc -l | awk '{print $1}'`" != "2" ] ; then
	echo "first 2 days of month are not selected (remove)"; exit 1
fi

if [ "`dio87c -- rtsr r1 task1 \"2003-08-03\" \"2003-08-09\" | grep Y |wc -l | awk '{print $1}'`" != "7" ] ; then
	echo "second week of month is not selected (add)"; exit 1
fi
if [ "`dio87c -- rtsr r1 task2 \"2003-08-03\" \"2003-08-09\" | grep N |wc -l | awk '{print $1}'`" != "7" ] ; then
	echo "second week of month is not unselected (remove)"; exit 1
fi

if [ "`dio87c -- rtsr r1 task1 \"2003-08-10\" \"2003-08-31\" | grep N |wc -l | awk '{print $1}'`" != "22" ] ; then
	echo "last 22 days of month are not unselected (add)"; exit 1
fi
if [ "`dio87c -- rtsr r1 task2 \"2003-08-10\" \"2003-08-31\" | grep Y |wc -l | awk '{print $1}'`" != "22" ] ; then
	echo "last 22 days of month are not selected (remove)"; exit 1
fi

# test Dec-2003
if [ "`dio87c -- rtsr r1 task1 \"2003-12-01\" \"2003-12-06\" | grep N |wc -l | awk '{print $1}'`" != "6" ] ; then
	echo "first 6 days of month are not unselected (add)"; exit 1
fi
if [ "`dio87c -- rtsr r1 task2 \"2003-12-01\" \"2003-12-06\" | grep Y |wc -l | awk '{print $1}'`" != "6" ] ; then
	echo "first 6 days of month are not selected (remove)"; exit 1
fi

if [ "`dio87c -- rtsr r1 task1 \"2003-12-07\" \"2003-12-13\" | grep Y |wc -l | awk '{print $1}'`" != "7" ] ; then
	echo "second week of month is not selected (add)"; exit 1
fi
if [ "`dio87c -- rtsr r1 task2 \"2003-12-03\" \"2003-12-13\" | grep N |wc -l | awk '{print $1}'`" != "7" ] ; then
	echo "second week of month is not unselected (remove)"; exit 1
fi

if [ "`dio87c -- rtsr r1 task1 \"2003-12-14\" \"2003-12-31\" | grep N |wc -l | awk '{print $1}'`" != "18" ] ; then
	echo "last 18 days of month are not unselected (add)"; exit 1
fi
if [ "`dio87c -- rtsr r1 task2 \"2003-12-14\" \"2003-12-31\" | grep Y |wc -l | awk '{print $1}'`" != "18" ] ; then
	echo "last 18 days of month are not selected (remove)"; exit 1
fi
dio87c -- rtok r1 task1 1 || exit 1
dio87c -- rtok r1 task2 2 || exit 1

# negative value
dio87c -- rtoa -- r1 task1 add week_of_month -2 || exit 1
dio87c -- rtoa -- r1 task2 remove week_of_month -2 || exit 1

# test Aug-2003
if [ "`dio87c -- rtsr r1 task1 \"2003-08-01\" \"2003-08-23\" | grep N |wc -l | awk '{print $1}'`" != "23" ] ; then
	echo "first 23 days of month are not unselected (add)"; exit 1
fi
if [ "`dio87c -- rtsr r1 task2 \"2003-08-01\" \"2003-08-23\" | grep Y |wc -l | awk '{print $1}'`" != "23" ] ; then
	echo "first 23 days of month are not selected (remove)"; exit 1
fi

if [ "`dio87c -- rtsr r1 task1 \"2003-08-24\" \"2003-08-30\" | grep Y |wc -l | awk '{print $1}'`" != "7" ] ; then
	echo "week before last week of month is not selected (add)"; exit 1
fi
if [ "`dio87c -- rtsr r1 task2 \"2003-08-24\" \"2003-08-30\" | grep N |wc -l | awk '{print $1}'`" != "7" ] ; then
	echo "week before last week of month is not unselected (remove)"; exit 1
fi

if [ "`dio87c -- rtsr r1 task1 \"2003-08-31\"`" != "N" ] ; then
	echo "last days of month is not unselected (add)"; exit 1
fi
if [ "`dio87c -- rtsr r1 task2 \"2003-08-31\"`" != "Y" ] ; then
	echo "last days of month is not selected (remove)"; exit 1
fi
dio87c -- rtok r1 task1 1 || exit 1
dio87c -- rtok r1 task2 2 || exit 1

# add_from / remove_from
echo "  'add_from' and 'remove_from' operators"

dio87c -- rtoa r1 task1 add_from week_of_month 2 || exit 1
dio87c -- rtoa r1 task2 remove_from week_of_month 2 || exit 1

# test Aug-2003
if [ "`dio87c -- rtsr r1 task1 \"2003-08-01\" \"2003-08-02\" | grep N |wc -l | awk '{print $1}'`" != "2" ] ; then
	echo "first week of month is not unselected (add)"; exit 1
fi
if [ "`dio87c -- rtsr r1 task2 \"2003-08-01\" \"2003-08-02\" | grep Y |wc -l | awk '{print $1}'`" != "2" ] ; then
	echo "first week of month is not selected (remove)"; exit 1
fi

if [ "`dio87c -- rtsr r1 task1 \"2003-08-03\" \"2003-08-31\" | grep Y |wc -l | awk '{print $1}'`" != "29" ] ; then
	echo "last 3 weeks of month are not selected (add)"; exit 1
fi
if [ "`dio87c -- rtsr r1 task2 \"2003-08-03\" \"2003-08-31\" | grep N |wc -l | awk '{print $1}'`" != "29" ] ; then
	echo "last 3 weeks of month are not unselected (remove)"; exit 1
fi

# test Dec-2003
if [ "`dio87c -- rtsr r1 task1 \"2003-12-01\" \"2003-12-06\" | grep N |wc -l | awk '{print $1}'`" != "6" ] ; then
	echo "first week of month is not unselected (add)"; exit 1
fi
if [ "`dio87c -- rtsr r1 task2 \"2003-12-01\" \"2003-12-06\" | grep Y |wc -l | awk '{print $1}'`" != "6" ] ; then
	echo "first week of month is not selected (remove)"; exit 1
fi

if [ "`dio87c -- rtsr r1 task1 \"2003-12-07\" \"2003-12-31\" | grep Y |wc -l | awk '{print $1}'`" != "25" ] ; then
	echo "last 4 weeks of month are not selected (add)"; exit 1
fi
if [ "`dio87c -- rtsr r1 task2 \"2003-12-07\" \"2003-12-31\" | grep N |wc -l | awk '{print $1}'`" != "25" ] ; then
	echo "last 4 weeks of month are not unselected (remove)"; exit 1
fi

dio87c -- rtok r1 task1 1 || exit 1
dio87c -- rtok r1 task2 2 || exit 1

# negative value
dio87c -- rtoa -- r1 task1 add_from week_of_month -2 || exit 1
dio87c -- rtoa -- r1 task2 remove_from week_of_month -2 || exit 1

# test Aug-2003
if [ "`dio87c -- rtsr r1 task1 \"2003-08-01\" \"2003-08-23\" | grep N |wc -l | awk '{print $1}'`" != "23" ] ; then
	echo "first 23 days of month are not unselected (add)"; exit 1
fi
if [ "`dio87c -- rtsr r1 task2 \"2003-08-01\" \"2003-08-23\" | grep Y |wc -l | awk '{print $1}'`" != "23" ] ; then
	echo "first 23 days of month are not selected (remove)"; exit 1
fi

if [ "`dio87c -- rtsr r1 task1 \"2003-08-24\" \"2003-08-31\" | grep Y |wc -l | awk '{print $1}'`" != "8" ] ; then
	echo "last 8 days of month are not selected (add)"; exit 1
fi
if [ "`dio87c -- rtsr r1 task2 \"2003-08-24\" \"2003-08-31\" | grep N |wc -l | awk '{print $1}'`" != "8" ] ; then
	echo "last 8 days of month are not unselected (remove)"; exit 1
fi

dio87c -- rtok r1 task1 1 || exit 1
dio87c -- rtok r1 task2 2 || exit 1

# add_until / remove_until
echo "  'add_until' and 'remove_until' operators"

dio87c -- rtoa r1 task1 add_until week_of_month 2 || exit 1
dio87c -- rtoa r1 task2 remove_until week_of_month 2 || exit 1

# test Aug-2003
if [ "`dio87c -- rtsr r1 task1 \"2003-08-01\" \"2003-08-09\" | grep Y |wc -l | awk '{print $1}'`" != "9" ] ; then
	echo "first 2 weeks of month are not selected (add)"; exit 1
fi
if [ "`dio87c -- rtsr r1 task2 \"2003-08-01\" \"2003-08-09\" | grep N |wc -l | awk '{print $1}'`" != "9" ] ; then
	echo "first 2 weeks of month are not unselected (remove)"; exit 1
fi

if [ "`dio87c -- rtsr r1 task1 \"2003-08-10\" \"2003-08-31\" | grep N |wc -l | awk '{print $1}'`" != "22" ] ; then
	echo "last 3 weeks of month are not unselected (add)"; exit 1
fi
if [ "`dio87c -- rtsr r1 task2 \"2003-08-10\" \"2003-08-31\" | grep Y |wc -l | awk '{print $1}'`" != "22" ] ; then
	echo "last 3 weeks of month are not selected (remove)"; exit 1
fi

# test Dec-2003
if [ "`dio87c -- rtsr r1 task1 \"2003-12-01\" \"2003-12-13\" | grep Y |wc -l | awk '{print $1}'`" != "13" ] ; then
	echo "first 2 weeks of month are not selected (add)"; exit 1
fi
if [ "`dio87c -- rtsr r1 task2 \"2003-12-01\" \"2003-12-13\" | grep N |wc -l | awk '{print $1}'`" != "13" ] ; then
	echo "first 2 weeks of month are not unselected (remove)"; exit 1
fi

if [ "`dio87c -- rtsr r1 task1 \"2003-12-14\" \"2003-12-31\" | grep N |wc -l | awk '{print $1}'`" != "18" ] ; then
	echo "last 3 weeks of month are not unselected (add)"; exit 1
fi
if [ "`dio87c -- rtsr r1 task2 \"2003-12-14\" \"2003-12-31\" | grep Y |wc -l | awk '{print $1}'`" != "18" ] ; then
	echo "last 3 weeks of month are not selected (remove)"; exit 1
fi

dio87c -- rtok r1 task1 1 || exit 1
dio87c -- rtok r1 task2 2 || exit 1

# negative value
dio87c -- rtoa -- r1 task1 add_until week_of_month -3 || exit 1
dio87c -- rtoa -- r1 task2 remove_until week_of_month -3 || exit 1

# test Aug-2003
if [ "`dio87c -- rtsr r1 task1 \"2003-08-01\" \"2003-08-23\" | grep Y |wc -l | awk '{print $1}'`" != "23" ] ; then
	echo "first 23 days of month are not selected (add)"; exit 1
fi
if [ "`dio87c -- rtsr r1 task2 \"2003-08-01\" \"2003-08-23\" | grep N |wc -l | awk '{print $1}'`" != "23" ] ; then
	echo "first 23 days of month are not unselected (remove)"; exit 1
fi

if [ "`dio87c -- rtsr r1 task1 \"2003-08-24\" \"2003-08-31\" | grep N |wc -l | awk '{print $1}'`" != "8" ] ; then
	echo "last 8 days of month are not unselected (add)"; exit 1
fi
if [ "`dio87c -- rtsr r1 task2 \"2003-08-24\" \"2003-08-31\" | grep Y |wc -l | awk '{print $1}'`" != "8" ] ; then
	echo "last 8 days of month are not selected (remove)"; exit 1
fi

dio87c -- rtok r1 task1 1 || exit 1
dio87c -- rtok r1 task2 2 || exit 1


################################################## week_of_year
echo "test 'week_of_year' operation"
# add / remove
echo "  'add' and 'remove' operators"
dio87c -- rtoa r1 task1 add week_of_year 15 || exit 1
dio87c -- rtoa r1 task2 remove week_of_year 15 || exit 1

if [ "`dio87c -- rtsr r1 task1 \"2003-01-01\" \"2003-04-06\" | grep N |wc -l | awk '{print $1}'`" != "96" ] ; then
	echo "first 14 weeks of year are not unselected (add)"; exit 1
fi
if [ "`dio87c -- rtsr r1 task2 \"2003-01-01\" \"2003-04-06\" | grep Y |wc -l | awk '{print $1}'`" != "96" ] ; then
	echo "first 14 weeks of year are not selected (remove)"; exit 1
fi

if [ "`dio87c -- rtsr r1 task1 \"2003-04-07\" \"2003-04-13\" | grep Y |wc -l | awk '{print $1}'`" != "7" ] ; then
	echo "week 14 of year is not selected (add)"; exit 1
fi
if [ "`dio87c -- rtsr r1 task2 \"2003-04-07\" \"2003-04-13\" | grep N |wc -l | awk '{print $1}'`" != "7" ] ; then
	echo "week 14 of year is not unselected (remove)"; exit 1
fi

if [ "`dio87c -- rtsr r1 task1 \"2003-04-14\" \"2003-12-31\" | grep N |wc -l | awk '{print $1}'`" != "262" ] ; then
	echo "last weeks of year are not unselected (add 1)"; exit 1
fi
if [ "`dio87c -- rtsr r1 task2 \"2003-04-14\" \"2003-12-31\" | grep Y |wc -l | awk '{print $1}'`" != "262" ] ; then
	echo "last weeks of year are not selected (remove)"; exit 1
fi

dio87c -- rtok r1 task1 1 || exit 1
dio87c -- rtok r1 task2 2 || exit 1

# negative value
dio87c -- rtoa -- r1 task1 add week_of_year -6 || exit 1
dio87c -- rtoa -- r1 task2 remove week_of_year -6 || exit 1

if [ "`dio87c -- rtsr r1 task1 \"2003-01-01\" \"2003-11-23\" | grep N |wc -l | awk '{print $1}'`" != "327" ] ; then
	echo "first weeks of year are not unselected (add)"; exit 1
fi
if [ "`dio87c -- rtsr r1 task2 \"2003-01-01\" \"2003-11-23\" | grep Y |wc -l | awk '{print $1}'`" != "327" ] ; then
	echo "first weeks of year are not selected (remove)"; exit 1
fi

if [ "`dio87c -- rtsr r1 task1 \"2003-11-24\" \"2003-11-30\" | grep Y |wc -l | awk '{print $1}'`" != "7" ] ; then
	echo "week 48 of year is not selected (add)"; exit 1
fi
if [ "`dio87c -- rtsr r1 task2 \"2003-11-24\" \"2003-11-30\" | grep N |wc -l | awk '{print $1}'`" != "7" ] ; then
	echo "week 48 of year is not unselected (remove)"; exit 1
fi

if [ "`dio87c -- rtsr r1 task1 \"2003-12-01\" \"2003-12-31\" | grep N |wc -l | awk '{print $1}'`" != "31" ] ; then
	echo "last weeks of year are not unselected (add 2)"; exit 1
fi
if [ "`dio87c -- rtsr r1 task2 \"2003-12-01\" \"2003-12-31\" | grep Y |wc -l | awk '{print $1}'`" != "31" ] ; then
	echo "last weeks of year are not selected (remove)"; exit 1
fi

dio87c -- rtok r1 task1 1 || exit 1
dio87c -- rtok r1 task2 2 || exit 1


# add_from / remove_from
echo "  'add_from' and 'remove_from' operators"
dio87c -- rtoa r1 task1 add_from week_of_year 15 || exit 1
dio87c -- rtoa r1 task2 remove_from week_of_year 15 || exit 1

if [ "`dio87c -- rtsr r1 task1 \"2003-01-01\" \"2003-04-06\" | grep N |wc -l | awk '{print $1}'`" != "96" ] ; then
	echo "first 14 weeks of year are not unselected (add)"; exit 1
fi
if [ "`dio87c -- rtsr r1 task2 \"2003-01-01\" \"2003-04-06\" | grep Y |wc -l | awk '{print $1}'`" != "96" ] ; then
	echo "first 14 weeks of year are not selected (remove)"; exit 1
fi

# the last 3 days of the year are not selected, because they are in the
# week 1 of the next year !
if [ "`dio87c -- rtsr r1 task1 \"2003-04-07\" \"2003-12-31\" | grep Y |wc -l | awk '{print $1}'`" != "266" ] ; then
	echo "last weeks of year are not selected (add 3)"; exit 1
fi
if [ "`dio87c -- rtsr r1 task2 \"2003-04-07\" \"2003-12-31\" | grep N |wc -l | awk '{print $1}'`" != "266" ] ; then
	echo "last weeks of year are not unselected (remove)"; exit 1
fi

dio87c -- rtok r1 task1 1 || exit 1
dio87c -- rtok r1 task2 2 || exit 1

# negative value 
dio87c -- rtoa -- r1 task1 add_from week_of_year -6 || exit 1
dio87c -- rtoa -- r1 task2 remove_from week_of_year -6 || exit 1

if [ "`dio87c -- rtsr r1 task1 \"2003-01-01\" \"2003-11-23\" | grep N |wc -l | awk '{print $1}'`" != "327" ] ; then
	echo "first 47 weeks of year are not unselected (add)"; exit 1
fi
if [ "`dio87c -- rtsr r1 task2 \"2003-01-01\" \"2003-11-23\" | grep Y |wc -l | awk '{print $1}'`" != "327" ] ; then
	echo "first 47 weeks of year are not selected (remove)"; exit 1
fi

if [ "`dio87c -- rtsr r1 task1 \"2003-11-24\" \"2003-12-31\" | grep Y |wc -l | awk '{print $1}'`" != "38" ] ; then
	echo "last weeks of year are not selected (add 4)"; exit 1
fi
if [ "`dio87c -- rtsr r1 task2 \"2003-11-24\" \"2003-12-31\" | grep N |wc -l | awk '{print $1}'`" != "38" ] ; then
	echo "last weeks of year are not unselected (remove)"; exit 1
fi

dio87c -- rtok r1 task1 1 || exit 1
dio87c -- rtok r1 task2 2 || exit 1

# add_until / remove_until 
echo "  'add_until' and 'remove_until' operators"
dio87c -- rtoa r1 task1 add_until week_of_year 15 || exit 1
dio87c -- rtoa r1 task2 remove_until week_of_year 15 || exit 1

if [ "`dio87c -- rtsr r1 task1 \"2003-01-01\" \"2003-04-13\" | grep Y |wc -l | awk '{print $1}'`" != "103" ] ; then
	echo "first 15 weeks of year are not selected (add)"; exit 1
fi
if [ "`dio87c -- rtsr r1 task2 \"2003-01-01\" \"2003-04-13\" | grep N |wc -l | awk '{print $1}'`" != "103" ] ; then
	echo "first 15 weeks of year are not unselected (remove)"; exit 1
fi

# the last 3 days are selected because they are in the week 1 of the next year.
if [ "`dio87c -- rtsr r1 task1 \"2003-04-12\" \"2003-12-31\" | grep N |wc -l | awk '{print $1}'`" != "259" ] ; then
	echo "last weeks of year are not unselected (add 5)"; exit 1
fi
if [ "`dio87c -- rtsr r1 task2 \"2003-04-12\" \"2003-12-31\" | grep Y |wc -l | awk '{print $1}'`" != "259" ] ; then
	echo "last weeks of year are not selected (remove)"; exit 1
fi

dio87c -- rtok r1 task1 1 || exit 1
dio87c -- rtok r1 task2 2 || exit 1

# negative value 
dio87c -- rtoa -- r1 task1 add_until week_of_year -6 || exit 1
dio87c -- rtoa -- r1 task2 remove_until week_of_year -6 || exit 1

if [ "`dio87c -- rtsr r1 task1 \"2003-01-01\" \"2003-11-30\" | grep Y |wc -l | awk '{print $1}'`" != "334" ] ; then
	echo "first weeks of year are not unselected (add)"; exit 1
fi
if [ "`dio87c -- rtsr r1 task2 \"2003-01-01\" \"2003-11-30\" | grep N |wc -l | awk '{print $1}'`" != "334" ] ; then
	echo "first weeks of year are not selected (remove)"; exit 1
fi

if [ "`dio87c -- rtsr r1 task1 \"2003-12-01\" \"2003-12-31\" | grep N |wc -l | awk '{print $1}'`" != "31" ] ; then
	echo "last weeks of year are not unselected (add 6)"; exit 1
fi
if [ "`dio87c -- rtsr r1 task2 \"2003-12-01\" \"2003-12-31\" | grep Y |wc -l | awk '{print $1}'`" != "31" ] ; then
	echo "last weeks of year are not selected (remove)"; exit 1
fi

dio87c -- rtok r1 task1 1 || exit 1
dio87c -- rtok r1 task2 2 || exit 1

################################################## month_of_year
echo "test 'month_of_year' operation"
# add / remove
echo "  'add' and 'remove' operators"
dio87c -- rtoa r1 task1 add month_of_year 2 || exit 1
dio87c -- rtoa r1 task2 remove month_of_year 2 || exit 1

if [ "`dio87c -- rtsr r1 task1 \"2003-01-01\" \"2003-01-31\" | grep N |wc -l | awk '{print $1}'`" != "31" ] ; then
	echo "first month of year is not unselected (add)"; exit 1
fi
if [ "`dio87c -- rtsr r1 task2 \"2003-01-01\" \"2003-01-31\" | grep Y |wc -l | awk '{print $1}'`" != "31" ] ; then
	echo "first month of year is not selected (remove)"; exit 1
fi

if [ "`dio87c -- rtsr r1 task1 \"2003-02-01\" \"2003-02-28\" | grep Y |wc -l | awk '{print $1}'`" != "28" ] ; then
	echo "second month of year is not selected (add)"; exit 1
fi
if [ "`dio87c -- rtsr r1 task2 \"2003-02-01\" \"2003-02-28\" | grep N |wc -l | awk '{print $1}'`" != "28" ] ; then
	echo "second month of year is not unselected (remove)"; exit 1
fi

if [ "`dio87c -- rtsr r1 task1 \"2003-03-01\" \"2003-12-31\" | grep N |wc -l | awk '{print $1}'`" != "306" ] ; then
	echo "last months of year are not unselected (add)"; exit 1
fi
if [ "`dio87c -- rtsr r1 task2 \"2003-03-01\" \"2003-12-31\" | grep Y |wc -l | awk '{print $1}'`" != "306" ] ; then
	echo "last months of year are not selected (remove)"; exit 1
fi

dio87c -- rtok r1 task1 1 || exit 1
dio87c -- rtok r1 task2 2 || exit 1

# add_from / remove_from
echo "  'add_from' and 'remove_from' operators"
dio87c -- rtoa r1 task1 add_from month_of_year 3 || exit 1
dio87c -- rtoa r1 task2 remove_from month_of_year 3 || exit 1

if [ "`dio87c -- rtsr r1 task1 \"2003-01-01\" \"2003-02-28\" | grep N |wc -l | awk '{print $1}'`" != "59" ] ; then
	echo "first two months of year are not unselected (add)"; exit 1
fi
if [ "`dio87c -- rtsr r1 task2 \"2003-01-01\" \"2003-02-28\" | grep Y |wc -l | awk '{print $1}'`" != "59" ] ; then
	echo "first two months of year are not selected (remove)"; exit 1
fi

if [ "`dio87c -- rtsr r1 task1 \"2003-02-01\" \"2003-12-31\" | grep Y |wc -l | awk '{print $1}'`" != "306" ] ; then
	echo "last months of year are not selected (add)"; exit 1
fi
if [ "`dio87c -- rtsr r1 task2 \"2003-02-01\" \"2003-12-31\" | grep N |wc -l | awk '{print $1}'`" != "306" ] ; then
	echo "last months of year are not unselected (remove)"; exit 1
fi

dio87c -- rtok r1 task1 1 || exit 1
dio87c -- rtok r1 task2 2 || exit 1

# add_until / remove_until 
echo "  'add_until' and 'remove_until' operators"
dio87c -- rtoa r1 task1 add_until month_of_year 3 || exit 1
dio87c -- rtoa r1 task2 remove_until month_of_year 3 || exit 1

if [ "`dio87c -- rtsr r1 task1 \"2003-01-01\" \"2003-03-31\" | grep Y |wc -l | awk '{print $1}'`" != "90" ] ; then
	echo "first three months of year are not selected (add)"; exit 1
fi
if [ "`dio87c -- rtsr r1 task2 \"2003-01-01\" \"2003-03-31\" | grep N |wc -l | awk '{print $1}'`" != "90" ] ; then
	echo "first three months of year are not unselected (remove)"; exit 1
fi

if [ "`dio87c -- rtsr r1 task1 \"2003-04-01\" \"2003-12-31\" | grep N |wc -l | awk '{print $1}'`" != "275" ] ; then
	echo "last months of year are not unselected (add)"; exit 1
fi
if [ "`dio87c -- rtsr r1 task2 \"2003-04-01\" \"2003-12-31\" | grep Y |wc -l | awk '{print $1}'`" != "275" ] ; then
	echo "last months of year are not selected (remove)"; exit 1
fi

dio87c -- rtok r1 task1 1 || exit 1
dio87c -- rtok r1 task2 2 || exit 1

################################################## day mm-dd 
echo "test 'day' operation"
# add / remove
echo "  'add' and 'remove' operators"
dio87c -- rtoa r1 task1 add day "02-29" || exit 1
dio87c -- rtoa r1 task2 remove day "02-29" || exit 1

if [ "`dio87c -- rtsr r1 task1 \"2004-02-29\"`" != "Y" ] ; then
	echo "2004-02-29 is not selected (add)"; exit 1
fi
if [ "`dio87c -- rtsr r1 task2 \"2004-02-29\"`" != "N" ] ; then
	echo "2004-02-29 is not unselected (remove)"; exit 1
fi

if [ "`dio87c -- rtsr r1 task1 \"2004-01-01\" \"2004-12-31\" | grep Y |wc -l | awk '{print $1}'`" != "1" ] ; then
	echo "only one day should be selected in 2004 (add)"; exit 1
fi
if [ "`dio87c -- rtsr r1 task2 \"2004-01-01\" \"2004-12-31\" | grep N |wc -l | awk '{print $1}'`" != "1" ] ; then
	echo "only one day should be unselected in 2004 (remove)"; exit 1
fi

if [ "`dio87c -- rtsr r1 task1 \"2004-01-01\" \"2004-12-31\" | grep N |wc -l | awk '{print $1}'`" != "365" ] ; then
	echo "365 days should be unselected in 2004 (add)"; exit 1
fi
if [ "`dio87c -- rtsr r1 task2 \"2004-01-01\" \"2004-12-31\" | grep Y |wc -l | awk '{print $1}'`" != "365" ] ; then
	echo "365 days should be selected in 2004 (remove)"; exit 1
fi

if [ "`dio87c -- rtsr r1 task1 \"2003-01-01\" \"2003-12-31\" | grep Y |wc -l | awk '{print $1}'`" != "0" ] ; then
	echo "no day should be selected in 2003 (add)"; exit 1
fi
if [ "`dio87c -- rtsr r1 task2 \"2003-01-01\" \"2003-12-31\" | grep N |wc -l | awk '{print $1}'`" != "0" ] ; then
	echo "no day should be unselected in 2003 (remove)"; exit 1
fi

if [ "`dio87c -- rtsr r1 task1 \"2003-01-01\" \"2003-12-31\" | grep N |wc -l | awk '{print $1}'`" != "365" ] ; then
	echo "365 days should be unselected in 2003 (add)"; exit 1
fi
if [ "`dio87c -- rtsr r1 task2 \"2003-01-01\" \"2003-12-31\" | grep Y |wc -l | awk '{print $1}'`" != "365" ] ; then
	echo "365 days should be selected in 2003 (remove)"; exit 1
fi

dio87c -- rtok r1 task1 1 || exit 1
dio87c -- rtok r1 task2 2 || exit 1

# add_from / remove_from
echo "  'add_from' and 'remove_from' operators"
dio87c -- rtoa r1 task1 add_from day "02-29" || exit 1
dio87c -- rtoa r1 task2 remove_from day "02-29" || exit 1

# 2003
if [ "`dio87c -- rtsr r1 task1 \"2003-01-01\" \"2003-02-28\" | grep N |wc -l | awk '{print $1}'`" != "59" ] ; then
	echo "first 59 days should be unselected in 2003 (add)"; exit 1
fi
if [ "`dio87c -- rtsr r1 task2 \"2003-01-01\" \"2003-02-28\" | grep Y |wc -l | awk '{print $1}'`" != "59" ] ; then
	echo "first 59 days should be selected in 2003 (remove)"; exit 1
fi

if [ "`dio87c -- rtsr r1 task1 \"2003-03-01\" \"2003-12-31\" | grep Y |wc -l | awk '{print $1}'`" != "306" ] ; then
	echo "last 306 days should be selected in 2003 (add)"; exit 1
fi
if [ "`dio87c -- rtsr r1 task2 \"2003-03-01\" \"2003-12-31\" | grep N |wc -l | awk '{print $1}'`" != "306" ] ; then
	echo "last 306 days should be unselected in 2003 (remove)"; exit 1
fi

# 2004
if [ "`dio87c -- rtsr r1 task1 \"2004-01-01\" \"2004-02-28\" | grep N |wc -l | awk '{print $1}'`" != "59" ] ; then
	echo "first 59 days should be unselected in 2004 (add)"; exit 1
fi
if [ "`dio87c -- rtsr r1 task2 \"2004-01-01\" \"2004-02-28\" | grep Y |wc -l | awk '{print $1}'`" != "59" ] ; then
	echo "first 59 days should be selected in 2004 (remove)"; exit 1
fi

if [ "`dio87c -- rtsr r1 task1 \"2004-02-29\" \"2004-12-31\" | grep Y |wc -l | awk '{print $1}'`" != "307" ] ; then
	echo "last 307 days should be selected in 2004 (add)"; exit 1
fi
if [ "`dio87c -- rtsr r1 task2 \"2004-02-29\" \"2004-12-31\" | grep N |wc -l | awk '{print $1}'`" != "307" ] ; then
	echo "last 307 days should be unselected in 2004 (remove)"; exit 1
fi

dio87c -- rtok r1 task1 1 || exit 1
dio87c -- rtok r1 task2 2 || exit 1

# add_until / remove_until 
echo "  'add_until' and 'remove_until' operators"
dio87c -- rtoa r1 task1 add_until day "02-29" || exit 1
dio87c -- rtoa r1 task2 remove_until day "02-29" || exit 1

# 2003
if [ "`dio87c -- rtsr r1 task1 \"2003-01-01\" \"2003-02-28\" | grep Y |wc -l | awk '{print $1}'`" != "59" ] ; then
	echo "first 59 days should be selected in 2003 (add)"; exit 1
fi
if [ "`dio87c -- rtsr r1 task2 \"2003-01-01\" \"2003-02-28\" | grep N |wc -l | awk '{print $1}'`" != "59" ] ; then
	echo "first 59 days should be unselected in 2003 (remove)"; exit 1
fi

if [ "`dio87c -- rtsr r1 task1 \"2003-03-01\" \"2003-12-31\" | grep N |wc -l | awk '{print $1}'`" != "306" ] ; then
	echo "last 306 days should be unselected in 2003 (add)"; exit 1
fi
if [ "`dio87c -- rtsr r1 task2 \"2003-03-01\" \"2003-12-31\" | grep Y |wc -l | awk '{print $1}'`" != "306" ] ; then
	echo "last 306 days should be selected in 2003 (remove)"; exit 1
fi

# 2004
if [ "`dio87c -- rtsr r1 task1 \"2004-01-01\" \"2004-02-29\" | grep Y |wc -l | awk '{print $1}'`" != "60" ] ; then
	echo "first 60 days should be selected in 2004 (add)"; exit 1
fi
if [ "`dio87c -- rtsr r1 task2 \"2004-01-01\" \"2004-02-29\" | grep N |wc -l | awk '{print $1}'`" != "60" ] ; then
	echo "first 60 days should be unselected in 2004 (remove)"; exit 1
fi

if [ "`dio87c -- rtsr r1 task1 \"2004-03-01\" \"2004-12-31\" | grep N |wc -l | awk '{print $1}'`" != "306" ] ; then
	echo "last 306 days should be unselected in 2004 (add)"; exit 1
fi
if [ "`dio87c -- rtsr r1 task2 \"2004-03-01\" \"2004-12-31\" | grep Y |wc -l | awk '{print $1}'`" != "306" ] ; then
	echo "last 306 days should be selected in 2004 (remove)"; exit 1
fi

dio87c -- rtok r1 task1 1 || exit 1
dio87c -- rtok r1 task2 2 || exit 1

################################################## date yyyy-mm-dd 
echo "test 'date' operation"
# add / remove
echo "  'add' and 'remove' operators"
dio87c -- rtoa r1 task1 add date "2003-04-01" || exit 1
dio87c -- rtoa r1 task2 remove date "2003-04-01" || exit 1

if [ "`dio87c -- rtsr r1 task1 \"2003-04-01\"`" != "Y" ] ; then
	echo "2003-04-01 is not selected (add)"; exit 1
fi
if [ "`dio87c -- rtsr r1 task2 \"2003-04-01\"`" != "N" ] ; then
	echo "2003-04-01 is not unselected (remove)"; exit 1
fi

if [ "`dio87c -- rtsr r1 task1 \"2003-01-01\" \"2003-12-31\" | grep N |wc -l | awk '{print $1}'`" != "364" ] ; then
	echo "364 days should be unselected in 2003 (add)"; exit 1
fi
if [ "`dio87c -- rtsr r1 task2 \"2003-01-01\" \"2003-12-31\" | grep Y |wc -l | awk '{print $1}'`" != "364" ] ; then
	echo "364 days should be selected in 2003 (remove)"; exit 1
fi

if [ "`dio87c -- rtsr r1 task1 \"2002-01-01\" \"2002-12-31\" | grep N |wc -l | awk '{print $1}'`" != "365" ] ; then
	echo "365 days should be unselected in 2002 (add)"; exit 1
fi
if [ "`dio87c -- rtsr r1 task2 \"2002-01-01\" \"2002-12-31\" | grep Y |wc -l | awk '{print $1}'`" != "365" ] ; then
	echo "365 days should be selected in 2002 (remove)"; exit 1
fi

dio87c -- rtok r1 task1 1 || exit 1
dio87c -- rtok r1 task2 2 || exit 1

# add_from / remove_from
echo "  'add_from' and 'remove_from' operators"
dio87c -- rtoa r1 task1 add_from date "2003-04-01" || exit 1
dio87c -- rtoa r1 task2 remove_from date "2003-04-01" || exit 1

# 2002
if [ "`dio87c -- rtsr r1 task1 \"2002-01-01\" \"2002-12-31\" | grep N |wc -l | awk '{print $1}'`" != "365" ] ; then
	echo "365 days should be unselected in 2002 (add)"; exit 1
fi
if [ "`dio87c -- rtsr r1 task2 \"2002-01-01\" \"2002-12-31\" | grep Y |wc -l | awk '{print $1}'`" != "365" ] ; then
	echo "365 days should be selected in 2002 (remove)"; exit 1
fi

# 2003
if [ "`dio87c -- rtsr r1 task1 \"2003-01-01\" \"2003-03-31\" | grep N |wc -l | awk '{print $1}'`" != "90" ] ; then
	echo "first 90 days should be unselected in 2003 (add)"; exit 1
fi
if [ "`dio87c -- rtsr r1 task2 \"2003-01-01\" \"2003-03-31\" | grep Y |wc -l | awk '{print $1}'`" != "90" ] ; then
	echo "first 90 days should be selected in 2003 (remove)"; exit 1
fi

if [ "`dio87c -- rtsr r1 task1 \"2003-04-01\" \"2003-12-31\" | grep Y |wc -l | awk '{print $1}'`" != "275" ] ; then
	echo "last 275 days should be selected in 2003 (add)"; exit 1
fi
if [ "`dio87c -- rtsr r1 task2 \"2003-04-01\" \"2003-12-31\" | grep N |wc -l | awk '{print $1}'`" != "275" ] ; then
	echo "last 275 days should be unselected in 2003 (remove)"; exit 1
fi

# 2004
if [ "`dio87c -- rtsr r1 task1 \"2004-01-01\" \"2004-12-31\" | grep Y |wc -l | awk '{print $1}'`" != "366" ] ; then
	echo "366 days should be selected in 2004 (add)"; exit 1
fi
if [ "`dio87c -- rtsr r1 task2 \"2004-01-01\" \"2004-12-31\" | grep N |wc -l | awk '{print $1}'`" != "366" ] ; then
	echo "366 days should be unselected in 2004 (remove)"; exit 1
fi

dio87c -- rtok r1 task1 1 || exit 1
dio87c -- rtok r1 task2 2 || exit 1

# add_until / remove_until
echo "  'add_until' and 'remove_until' operators"
dio87c -- rtoa r1 task1 add_until date "2003-04-01" || exit 1
dio87c -- rtoa r1 task2 remove_until date "2003-04-01" || exit 1

# 2002
if [ "`dio87c -- rtsr r1 task1 \"2002-01-01\" \"2002-12-31\" | grep Y |wc -l | awk '{print $1}'`" != "365" ] ; then
	echo "365 days should be selected in 2002 (add)"; exit 1
fi
if [ "`dio87c -- rtsr r1 task2 \"2002-01-01\" \"2002-12-31\" | grep N |wc -l | awk '{print $1}'`" != "365" ] ; then
	echo "365 days should be unselected in 2002 (remove)"; exit 1
fi

# 2003
if [ "`dio87c -- rtsr r1 task1 \"2003-01-01\" \"2003-04-01\" | grep Y |wc -l | awk '{print $1}'`" != "91" ] ; then
	echo "first 91 days should be selected in 2003 (add)"; exit 1
fi
if [ "`dio87c -- rtsr r1 task2 \"2003-01-01\" \"2003-04-01\" | grep N |wc -l | awk '{print $1}'`" != "91" ] ; then
	echo "first 91 days should be unselected in 2003 (remove)"; exit 1
fi

if [ "`dio87c -- rtsr r1 task1 \"2003-04-02\" \"2003-12-31\" | grep N |wc -l | awk '{print $1}'`" != "274" ] ; then
	echo "last 274 days should be unselected in 2003 (add)"; exit 1
fi
if [ "`dio87c -- rtsr r1 task2 \"2003-04-02\" \"2003-12-31\" | grep Y |wc -l | awk '{print $1}'`" != "274" ] ; then
	echo "last 274 days should be selected in 2003 (remove)"; exit 1
fi

# 2004
if [ "`dio87c -- rtsr r1 task1 \"2004-01-01\" \"2004-12-31\" | grep N |wc -l | awk '{print $1}'`" != "366" ] ; then
	echo "366 days should be unselected in 2004 (add)"; exit 1
fi
if [ "`dio87c -- rtsr r1 task2 \"2004-01-01\" \"2004-12-31\" | grep Y |wc -l | awk '{print $1}'`" != "366" ] ; then
	echo "366 days should be selected in 2004 (remove)"; exit 1
fi

dio87c -- rtok r1 task1 1 || exit 1
dio87c -- rtok r1 task2 2 || exit 1

################################################## complex 
echo "test 'complex rule' operation"
# add / remove
dio87c -- rra r1 rule1 || exit 1
dio87c -- rroa r1 rule1 add day_of_week 1 || exit 1
dio87c -- rroa r1 rule1 add day_of_week 7 || exit 1
dio87c -- rtoa r1 task2 remove rule rule1 || exit 1

for d in 04 05 11 12 18 19 25 26; do
	if [ "`dio87c -- rtsr r1 task2 \"2003-01-$d\"`" != "N" ] ; then
		echo "day "2003-01-$d" should be unselected"; exit 1
	fi
done

for d in 01 02 03 06 07 08 09 10 13 14 15 16 17; do
	if [ "`dio87c -- rtsr r1 task2 \"2003-01-$d\"`" != "Y" ] ; then
		echo "day "2003-01-$d" should be selected"; exit 1
	fi
done

dio87c -- rk r1 || exit 1
# verify memory
mem2=`dio87c -- memory`
if [ $? != 0 ] ; then echo "error"; exit 1; fi
if [ $mem1 != $mem2 ] ; then
	echo "dio87d : memory error before and after rule $mem1 -> $mem2"
	exit 1
fi

stopDio87d || exit 1
