#!/bin/sh
#
# file tst26.sh 
# (test variable for dio87d) 
#
#      Diogene87
#	Copyright (C) 2003,2004,2005 - Dominique Parisot
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied wartanty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this software; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
# Boston, MA 02111-1307 USA
#


if [ "$srcdir" = "" ]; then srcdir="."; fi
. $srcdir/functions.sh
checkNoDaemon

echo "test variable for dio87d"

startDio87d || exit 1

################################################## 
echo "Test variables commands " 

# dio87d : test 
mem1=`dio87c -- memory`
if [ $? != 0 ] ; then echo "error"; exit 1; fi

# add variable 
dio87c -- va var1
if [ $? -ne 0 ]; then echo "Can't add a variable."; exit 1; fi
if [ "`dio87c -- vc`" -ne 1 ] ; then
	echo "Variables count isn't 1."; exit 1
fi
if [ "`dio87c -- vl | grep var1 | wc -l`" -ne 1 ]; then
	echo "Can't find 'var1' variable."; exit 1
fi
# add another variable with the same name
dio87c -- va var1 > /dev/null 2>&1
if [ $? -eq 0 ]; then echo "Can add a second variable with the same name !"; exit 1;fi
if [ "`dio87c -- vc`" -ne 1 ] ; then
	echo "Variable count isn't 1."; exit 1
fi
# add a second variable 
dio87c -- va var2
if [ $? -ne 0 ]; then echo "Can't add a second variable."; exit 1; fi
if [ "`dio87c -- vc`" -ne 2 ] ; then
	echo "Variables count isn't 2."; exit 1
fi
if [ "`dio87c -- vl | grep var2 | wc -l`" -ne 1 ]; then
	echo "Can't find 'var2' variable."; exit 1
fi

# delete variable
dio87c -- vk var1
if [ $? -ne 0 ]; then echo "Can't delete variable."; exit 1; fi
if [ "`dio87c -- vc`" -ne 1 ] ; then
	echo "Users count isn't 1."; exit 1
fi
dio87c -- vk var2 || exit 1

# add a variable with an initial value
dio87c -- va var1 value1
if [ $? -ne 0 ]; then echo "Can't add a variable with initial value."; exit 1; fi
if [ "`dio87c -- vc`" -ne 1 ] ; then
	echo "Variables count isn't 1."; exit 1
fi
if [ "`dio87c -- vl -vS! | grep var1`" != "var1!value1" ]; then
	echo "Can't find 'var1' variable with initial value."; exit 1
fi
if [ "`dio87c -- vi -S! var1 | grep Value`" != "Value!value1" ]; then
	echo "Can't find 'var1' initial value."; exit 1
fi

# change value of initial variable
dio87c -- vsv var1 value2
if [ $? -ne 0 ]; then echo "Can't change variable value."; exit 1; fi
if [ "`dio87c -- vi -S! var1 | grep Value`" != "Value!value2" ]; then
	echo "Can't find 'var1' value."; exit 1
fi
dio87c -- vk var1 || exit 1

# verify memory
mem2=`dio87c -- memory` || exit 1
if [ $mem1 != $mem2 ] ; then
	echo "dio87d : memory error $mem1 -> $mem2"
	exit 1
fi

stopDio87d || exit 1
