#!/bin/sh
#
# file tst27.sh 
# (test variable for task planification)
#
#      Diogene87
#	Copyright (C) 2003,2004,2005 - Dominique Parisot
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this software; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
# Boston, MA 02111-1307 USA
#


if [ "$srcdir" = "" ]; then srcdir="."; fi
. $srcdir/functions.sh
checkNoDaemon

echo "test variable for task planification"

startDio87d || exit 1

# memory 
memd1=`dio87c -- memory` || exit 1

################################################## 
echo "Test task operation"

dio87c -- ra ref || exit 1

# add variables
for f in 1 2 3 4 ; do
	dio87c -- va select_task$f || exit 1
done

# create tasks
dio87c -- rta ref task1 || exit 1
dio87c -- rtoa ref task1 add if_equal select_task1 YES || exit 1

dio87c -- rta ref task2 || exit 1
dio87c -- rtoa ref task2 add if_not_equal select_task2 NO || exit 1

dio87c -- rta ref task3 || exit 1
dio87c -- rtoa ref task3 add always || exit 1
dio87c -- rtoa ref task3 remove if_equal select_task3 NO || exit 1

dio87c -- rta ref task4 || exit 1
dio87c -- rtoa ref task4 add always || exit 1
dio87c -- rtoa ref task4 remove if_not_equal select_task4 YES || exit 1

# select all tasks
echo "  select all tasks"
for f in 1 2 3 4 ; do
	dio87c -- vsv select_task$f YES || exit 1
done
dio87c -- rp -d ref "$dayDate" d1 >/dev/null || exit 1
sleep 1
for f in 1 2 3 4 ; do
	if [ "`dio87c -- xtl d1 | grep task$f`" != "task$f" ]; then
		echo "Can't find task$f !"; exit 1
	fi
done
dio87c -- xdk d1 || exit 1
dio87c -- ldk d1 || exit 1
# select no task
echo "  select no task"
for f in 1 2 3 4 ; do
	dio87c -- vsv select_task$f NO  || exit 1
done
dio87c -- rp -d ref "$dayDate" d1 >/dev/null || exit 1
sleep 1
if [ "`dio87c -- xtc d1`" != "0" ]; then
	echo "Task count is not 0 !"; exit 1
fi
dio87c -- xdk d1 || exit 1
dio87c -- ldk d1 || exit 1

dio87c -- rk ref || exit 1
dio87c -- srk ref || exit 1
for f in 1 2 3 4 ; do
	dio87c -- vk select_task$f || exit 1
done
waitMessageSending

################################################## 
echo "Test rule operation"

dio87c -- ra ref || exit 1

# add variables
for f in 1 2 3 4 ; do
	dio87c -- va select_task$f || exit 1
done

# create tasks
dio87c -- rra ref rule1 || exit 1
dio87c -- rroa ref rule1 add if_equal select_task1 YES || exit 1
dio87c -- rta ref task1 || exit 1
dio87c -- rtoa ref task1 add rule rule1 || exit 1

dio87c -- rra ref rule2 || exit 1
dio87c -- rroa ref rule2 add if_not_equal select_task2 NO || exit 1
dio87c -- rta ref task2 || exit 1
dio87c -- rtoa ref task2 add rule rule1 || exit 1

dio87c -- rra ref rule3 || exit 1
dio87c -- rroa ref rule3 add always || exit 1
dio87c -- rroa ref rule3 remove if_equal select_task3 NO || exit 1
dio87c -- rta ref task3 || exit 1
dio87c -- rtoa ref task3 add rule rule1 || exit 1

dio87c -- rra ref rule4 || exit 1
dio87c -- rroa ref rule3 add always || exit 1
dio87c -- rroa ref rule4 remove if_not_equal select_task4 YES || exit 1
dio87c -- rta ref task4 || exit 1
dio87c -- rtoa ref task4 add rule rule1 || exit 1

# select all tasks
echo "  select all tasks"
for f in 1 2 3 4 ; do
	dio87c -- vsv select_task$f YES || exit 1
done
dio87c -- rp ref "$dayDate" d1 >/dev/null || exit 1
sleep 1
for f in 1 2 3 4 ; do
	if [ "`dio87c -- xtl d1 | grep task$f`" != "task$f" ]; then
		echo "Can't find task$f !"; exit 1
	fi
done
dio87c -- xdk d1 || exit 1
dio87c -- ldk d1 || exit 1
# select no task
echo "  select no task"
for f in 1 2 3 4 ; do
	dio87c -- vsv select_task$f NO  || exit 1
done
dio87c -- rp ref "$dayDate" d1 >/dev/null || exit 1
sleep 1
if [ "`dio87c -- xtc d1`" != "0" ]; then
	echo "Task count is not 0 !"; exit 1
fi
dio87c -- xdk d1 || exit 1
dio87c -- ldk d1 || exit 1
dio87c -- rk ref || exit 1
for f in 1 2 3 4 ; do
	dio87c -- vk select_task$f || exit 1
done
waitMessageSending
dio87c -- srk ref || exit 1

# verify memory
waitMessageSending
memd2=`dio87c -- memory` || exit 1
if [ $memd1 != $memd2 ] ; then
	echo "dio87d : memory error $memd1 -> $memd2"; exit 1
fi

stopDio87d || exit 1
