#!/bin/sh
#
# file tst28.sh 
# (test variable replacement in path and argument)
#
#      Diogene87
#	Copyright (C) 2003,2004,2005 - Dominique Parisot
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this software; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
# Boston, MA 02111-1307 USA
#


if [ "$srcdir" = "" ]; then srcdir="."; fi
. $srcdir/functions.sh
checkNoDaemon

echo "test variable replacement in path and argument"

startDio87d || exit 1

# memory 
memd1=`dio87c -- memory` || exit 1

################################################## 
echo "Test dio87d variable replacement"

dio87c -- va var1 abc1cba || exit 1
dio87c -- va var2 cde2edc || exit 1
dio87c -- ra ref || exit 1
dio87c -- rta ref tsk || exit 1
dio87c -- rtoa ref tsk add always || exit 1

dio87c -- rja ref tsk job1 || exit 1
dio87c -- rjsp ref tsk job1 "$<var1>"
dio87c -- rjsa ref tsk job1 "$<var1>"

dio87c -- rja ref tsk job2 || exit 1
dio87c -- rjsp ref tsk job2 "$<var1> $<var2>"
dio87c -- rjsa ref tsk job2 "$<var1> $<var2>"

dio87c -- rja ref tsk job3 || exit 1
dio87c -- rjsp ref tsk job3 "$<xxx>"
dio87c -- rjsa ref tsk job3 "$<xxx>"

dio87c -- rja ref tsk job4 || exit 1
dio87c -- rjsp ref tsk job4 "$<var1>$<xxx>"
dio87c -- rjsa ref tsk job4 "$<var1>$<xxx>"

dio87c -- rja ref tsk job5 || exit 1
dio87c -- rjsp ref tsk job5 "xyz$<var1>zyx"
dio87c -- rjsa ref tsk job5 "xyz$<var1>zyx"

dio87c -- rja ref tsk job6 || exit 1
dio87c -- rjsp ref tsk job6 "xyz$<var1>zyx$<var2>"
dio87c -- rjsa ref tsk job6 "xyz$<var1>zyx$<var2>"

dio87c -- rja ref tsk job7 || exit 1
dio87c -- rjsp ref tsk job7 "$<>"
dio87c -- rjsa ref tsk job7 "$<>"

dio87c -- rja ref tsk job8 || exit 1
dio87c -- rjsp ref tsk job8 "$<"
dio87c -- rjsa ref tsk job8 "$<"

dio87c -- rja ref tsk job9 || exit 1
dio87c -- rjsp ref tsk job9 "$<xxx"
dio87c -- rjsa ref tsk job9 "$<xxx"

dio87c -- rp ref "$dayDate" d1 >/dev/null || exit 1
sleep 1

# control job1
if [ "`dio87c -- xji -S! d1 tsk job1 | grep Path`" != "Path!abc1cba" ]; then
	echo "Incorrect path for job1 !"; exit 1
fi
if [ "`dio87c -- xji -S! d1 tsk job1 | grep Argument`" != "Argument!abc1cba" ]; then
	echo "Incorrect argument for job1 !"; exit 1
fi
# control job2
if [ "`dio87c -- xji -S! d1 tsk job2 | grep Path`" != "Path!abc1cba cde2edc" ]; then
	echo "Incorrect path for job2 !"; exit 1
fi
if [ "`dio87c -- xji -S! d1 tsk job2 | grep Argument`" != "Argument!abc1cba cde2edc" ]; then
	echo "Incorrect argument for job2 !"; exit 1
fi
# control job3
if [ "`dio87c -- xji -S! d1 tsk job3 | grep Path`" != "Path!$<xxx>" ]; then
	echo "Incorrect path for job3 !"; exit 1
fi
if [ "`dio87c -- xji -S! d1 tsk job3 | grep Argument`" != "Argument!$<xxx>" ]; then
	echo "Incorrect argument for job3 !"; exit 1
fi
# control job4
if [ "`dio87c -- xji -S! d1 tsk job4 | grep Path`" != "Path!abc1cba$<xxx>" ]; then
	echo "Incorrect path for job4 !"; exit 1
fi
if [ "`dio87c -- xji -S! d1 tsk job4 | grep Argument`" != "Argument!abc1cba$<xxx>" ]; then
	echo "Incorrect argument for job4 !"; exit 1
fi
# control job5 "xyz$<var1>zyx"
if [ "`dio87c -- xji -S! d1 tsk job5 | grep Path`" != "Path!xyzabc1cbazyx" ]; then
	echo "Incorrect path for job5 !"; exit 1
fi
if [ "`dio87c -- xji -S! d1 tsk job5 | grep Argument`" != "Argument!xyzabc1cbazyx" ]; then
	echo "Incorrect argument for job5 !"; exit 1
fi
# control job6 "xyz$<var1>zyx"
if [ "`dio87c -- xji -S! d1 tsk job6 | grep Path`" != "Path!xyzabc1cbazyxcde2edc" ]; then
	echo "Incorrect path for job6 !"; exit 1
fi
if [ "`dio87c -- xji -S! d1 tsk job6 | grep Argument`" != "Argument!xyzabc1cbazyxcde2edc" ]; then
	echo "Incorrect argument for job6 !"; exit 1
fi
# control job7 "$<>"
if [ "`dio87c -- xji -S! d1 tsk job7 | grep Path`" != "Path!$<>" ]; then
	echo "Incorrect path for job7 !"; exit 1
fi
if [ "`dio87c -- xji -S! d1 tsk job7 | grep Argument`" != "Argument!$<>" ]; then
	echo "Incorrect argument for job7 !"; exit 1
fi

# control job8 "$<"
if [ "`dio87c -- xji -S! d1 tsk job8 | grep Path`" != "Path!$<" ]; then
	echo "Incorrect path for job8 !"; exit 1
fi
if [ "`dio87c -- xji -S! d1 tsk job8 | grep Argument`" != "Argument!$<" ]; then
	echo "Incorrect argument for job8 !"; exit 1
fi
# control job9 "$<xxx"
if [ "`dio87c -- xji -S! d1 tsk job9 | grep Path`" != "Path!$<xxx" ]; then
	echo "Incorrect path for job9 !"; exit 1
fi
if [ "`dio87c -- xji -S! d1 tsk job9 | grep Argument`" != "Argument!$<xxx" ]; then
	echo "Incorrect argument for job9 !"; exit 1
fi
dio87c -- rk ref || exit 1
dio87c -- srk ref || exit 1
dio87c -- xdk d1 || exit 1
dio87c -- ldk d1 || exit 1
dio87c -- vk var1 || exit 1
dio87c -- vk var2 || exit 1

################################################## 
echo "Test dio87d variable replacement"

dio87c -- va var1 "c_c" || exit 1
dio87c -- va var2 "job10.sh" || exit 1

dio87c -- ra ref || exit 1
dio87c -- rta ref task_1 || exit 1
dio87c -- rtoa ref task_1 add always || exit 1

dio87c -- rja ref task_1 job_1 || exit 1
dio87c -- rjsp ref task_1 job_1 "$JOBPATH/$<var2>"
dio87c -- rjsa ref task_1 job_1 "ab$<var1>ba"

dio87c -- rp ref "$dayDate" day_1 >/dev/null || exit 1
sleep 2

waitretry 9 "dio87c -- xjl -sS! day_1 task_1" "job_1!terminated"
if [ $? -ne 0 ]; then
	echo "Job isn't terminated !" ; exit 1
fi

# interpret exit code
res="`dio87c -- xji day_1 task_1 job_1 | grep Exit | awk '{print $3}'`"


if [ $res -eq 1 ]; then
	echo "incorrect value for DG87_DAY environment variable !"; exit 1
fi
if [ $res -eq 2 ]; then
	echo "incorrect value for DG87_TASK environment variable !"; exit 1
fi
if [ $res -eq 3 ]; then
	echo "incorrect value for DG87_JOB environment variable !"; exit 1
fi
if [ $res -eq 4 ]; then
	echo "incorrect value for argument !"; exit 1
fi

if [ $res -ne 0 ]; then
	echo "Job exit code isn't zero !"; exit 1
fi


dio87c -- rk ref || exit 1
dio87c -- srk ref || exit 1
dio87c -- xdk day_1 || exit 1
dio87c -- ldk day_1 || exit 1
dio87c -- vk var1 || exit 1
dio87c -- vk var2 || exit 1

waitMessageSending
# verify memory
memd2=`dio87c -- memory` || exit 1
if [ $memd1 != $memd2 ] ; then
	echo "dio87d : memory error $memd1 -> $memd2"; exit 1
fi

stopDio87d || exit 1
