#!/bin/sh
#
# file tst29.sh 
# (test long hostname for targets)
#
#      Diogene87
#	Copyright (C) 2003,2004,2005 - Dominique Parisot
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this software; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
# Boston, MA 02111-1307 USA
#


if [ "$srcdir" = "" ]; then srcdir="."; fi
. $srcdir/functions.sh
checkNoDaemon

echo "test long hostname for targets"

startDio87d || exit 1

# memory 
memd1=`dio87c -- memory` || exit 1

################################################## 
echo "Test dio87d target hostname"

dio87c -- ta my_computer || exit 1
dio87c -- tsh my_computer localhost
if [ $? -ne 0 ]; then
	echo "Can't set long hostname for target"; exit 1
fi
if [ "`dio87c -- ti my_computer | grep \"Host Name\" | awk '{print $3}'`" != "localhost" ]; then
	echo "Long hostname for target is not set"; exit 1
fi
dio87c -- tsh my_computer "" 
if [ $? -ne 0 ]; then
	echo "Can't erase long hostname for target"; exit 1
fi
if [ "`dio87c -- ti my_computer | grep \"Host Name\" | awk '{print $3}'`" != "" ]; then
	echo "Long hostname for target is not erased"; exit 1
fi
dio87c -- tk my_computer || exit 1


################################################## 
echo "Test dio87d communication with target hostname"

dio87c -- ta my_computer || exit 1
dio87c -- tsh my_computer localhost || exit 1

dio87c -- ra ref || exit 1
dio87c -- rta ref tsk || exit 1
dio87c -- rtoa ref tsk add always || exit 1
dio87c -- rtst ref tsk my_computer || exit 1

dio87c -- rja ref tsk job || exit 1
dio87c -- rjsp ref tsk job "$JOBPATH/job6.sh" || exit 1

dio87c -- rp ref "$dayDate" day1 >/dev/null || exit 1
waitretry 9 "dio87c -- xjl day1 tsk -sS!" "job!running"
if [ $? -ne 0 ]; then
	echo "Job is not running !"; exit 1
fi

waitretry 5 "dio87c -- xjl day1 tsk -sS!" "job!terminated"
if [ $? -ne 0 ]; then
	echo "Job is not terminated !"; exit 1
fi

dio87c -- rk ref || exit 1
dio87c -- srk ref || exit 1
dio87c -- xdk day1 || exit 1
dio87c -- ldk day1 || exit 1
dio87c -- tk my_computer || exit 1

waitMessageSending
# verify memory
memd2=`dio87c -- memory` || exit 1
if [ $memd1 != $memd2 ] ; then
	echo "dio87d : memory error $memd1 -> $memd2"; exit 1
fi

stopDio87d || exit 1
