#!/bin/sh
#
# file tst31.sh 
# (test DIOGENE_PASSWORD)
#
#      Diogene87
#	Copyright (C) 2003,2004,2005 - Dominique Parisot
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this software; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
# Boston, MA 02111-1307 USA
#


if [ "$srcdir" = "" ]; then srcdir="."; fi
. $srcdir/functions.sh
checkNoDaemon

echo "test DIOGENE_PASSWORD"

DIOGENE_PASSWORD=ad_77x+k

# start daemon
startDio87d

memd1=`dio87c -- memory` || exit 1

# define diogene password
echo "Change diogene password"
dio87c -- password diogene $DIOGENE_PASSWORD || exit 1

# test diogene password
$PathDio87c -u diogene -p $DIOGENE_PASSWORD -- version >/dev/null 
if [ $? -ne 0 ]; then 
	echo "Can't communicate with dio87d with diogene account"; exit 1
fi

# test daemons communication
echo "test daemons communication with a new password for diogene account"

dio87c -- ra r1 || exit 1
dio87c -- rta r1 t1 || exit 1
dio87c -- rtoa r1 t1 add always || exit 1
dio87c -- rja r1 t1 j1 || exit 1
dio87c -- rjsp r1 t1 j1 "$JOBPATH/job1.sh"

dio87c -- rp r1 "$dayDate" d1 >/dev/null || exit 1
sleep 1
if [ "`dio87c -- xdl`" != "d1" ]; then
	echo "Day 'd1' is not created ! Communication problem between dio87d and dio87d"; exit 1
fi

waitretry 5 "dio87c -- xji d1 t1 j1 | grep State | awk '{print \$2}'" "terminated"
if [ $? -ne 0 ]; then
	echo "Job isn't terminated. Communication problem between dio87d and dio87d"; exit 1
fi
if [ "`dio87c -- xti d1 t1 | grep State | awk '{print $2}'`" != "terminated" ]; then
	echo "Task isn't terminated."; exit 1
fi
if [ "`dio87c -- ldl`" != "d1" ]; then
	echo "Day is not created in dio87d !"; exit 1
fi
if [ "`dio87c -- srl`" != "r1" ]; then
	echo "Referential is not created in dio87d !"; exit 1
fi
dio87c -- rk r1 || exit 1
dio87c -- srk r1 || exit 1
dio87c -- xdk d1 || exit 1
dio87c -- ldk d1 || exit 1

waitMessageSending
# verify memory
memd2=`dio87c -- memory` || exit 1
if [ $memd1 != $memd2 ] ; then
	echo "dio87d : memory error $memd1 -> $memd2"; exit 1
fi

stopDio87d || exit 1

exit 0
