#!/bin/sh
#
# file tst32.sh 
# (test job scheduling with dio87d stopped)
#
#      Diogene87
#	Copyright (C) 2003,2004,2005 - Dominique Parisot
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this software; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
# Boston, MA 02111-1307 USA
#


if [ "$srcdir" = "" ]; then srcdir="."; fi
. $srcdir/functions.sh
checkNoDaemon

echo "test job scheduling with dio87d stopped"


startDio87d || exit 1

# create the configuration file of a second daemon 
# which listens on 9992
cat > $DATAPATH/dio87d_2.conf << EOF
IPPORT=9992
PID_FILE=$DATAPATH/dio87d_2.pid
DATA_DIR=$DATAPATH
SAVE_TEMPO=300
LOG_LEVEL=ERROR
EOF

################################################## 
echo "Test job scheduling with dio87d stopped"

dio87c -- ta computer || exit 1
dio87c -- tsh computer localhost || exit 1
dio87c -- tsp computer 9992 || exit 1

dio87c -- ra ref || exit 1
dio87c -- rta ref tsk || exit 1
dio87c -- rtoa ref tsk add always || exit 1
dio87c -- rtst ref tsk computer || exit 1

dio87c -- rja ref tsk job || exit 1
dio87c -- rjsp ref tsk job "$JOBPATH/job6.sh" || exit 1

dio87c -- rp ref "$dayDate" day1 >/dev/null || exit 1
waitretry 3 "dio87c -- xjl day1 tsk -sS!" "job!submit"
if [ $? -ne 0 ]; then
	echo "Job is not submited !"; exit 1
fi

# wait 3 seconds and verify that job is not executed
sleep 3
waitretry 3 "dio87c -- xjl day1 tsk -sS!" "job!submit"
if [ $? -ne 0 ]; then
	echo "Job is not submited after 3 seconds !"; exit 1
fi

dio87c -- ese true || exit 1

# start the second deamon
echo "Start a second daemon"
rm $DATAPATH/dio87d.data >/dev/null 2>&1
$PathDio87d -C $DATAPATH/dio87d_2.conf -I >/dev/null 2>&1
$PathDio87d -C $DATAPATH/dio87d_2.conf -d
sleep 1
dio87c -P 9992 -- version > /dev/null
if [ $? != 0 ] ; then
	echo "Can't communicate with dio87d"
	return 1;
fi


echo -n "Wait connection retry (<20s)"
n=0
while [ $n -le 20 ] ; do 
	n=$(( $n + 1 )) 
	sleep 1
	echo -n "."
	if [ "`dio87c -- xjl day1 tsk -sS!`" = "job!running" ]; then
		echo -e "\nJob is running."
		break
	fi
	if [ "`dio87c -- xjl day1 tsk -sS!`" = "job!terminated" ]; then
		echo -e "\nJob is terminated."
		break
	fi
done
if [ $n -ge 20 ]; then
	echo -e "\nTimeout ! Job is not running !"; exit 1
fi
echo "Wait job termination"
waitretry 5 "dio87c -- xjl day1 tsk -sS!" "job!terminated" 
if [ $? -ne 0 ]; then
	echo "Job is not terminated !"; exit 1
fi

dio87c -- rk ref || exit 1
dio87c -- xdk day1 || exit 1
dio87c -- tk computer || exit 1

# stop the two daemons
stopDio87d || exit 1

