#!/bin/sh
#
# file tst33.sh 
# (test dio87d save)
#
#      Diogene87
#	Copyright (C) 2003,2004,2005 - Dominique Parisot
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this software; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
# Boston, MA 02111-1307 USA
#


if [ "$srcdir" = "" ]; then srcdir="."; fi
. $srcdir/functions.sh
checkNoDaemon

echo "test dio87d save"

startDio87d || exit 1

echo " create database"

# variables
dio87c -- va vr1 value1 || exit 1
dio87c -- va vr2 || exit 1
dio87c -- va vr3 || exit 1

# targets
dio87c -- ta tg1 "target_1" || exit 1 
dio87c -- tsh tg1 "www.tg1.com"
dio87c -- tsp tg1 8888
dio87c -- ta tg2 "target_2" || exit 1

# queues
dio87c -- qa tg1 q1 "queue_1" || exit 1
dio87c -- qa tg1 q2 "queue_2" || exit 1
dio87c -- qa tg2 q3 || exit 1
dio87c -- qa tg2 q4 || exit 1
dio87c -- qa tg2 q5 || exit 1

# referentials
dio87c -- ra ref1 || exit 1
dio87c -- ra ref2 || exit 1
dio87c -- ra ref3 || exit 1

# tasks 
dio87c -- rta ref1 tsk1 "task_1" || exit 1
dio87c -- rta ref1 tsk2 || exit 1
dio87c -- rta ref2 tsk3 || exit 1
dio87c -- rta ref2 tsk4 || exit 1
dio87c -- rta ref3 tsk5 || exit 1
dio87c -- rtswad ref1 tsk1 true || exit 1
dio87c -- rtswad ref1 tsk2 false || exit 1
dio87c -- rtsoec ref1 tsk1 true || exit 1
dio87c -- rtsoec ref1 tsk2 false || exit 1
dio87c -- rtst ref1 tsk2 none || exit 1
dio87c -- rtst ref1 tsk1 tg1 q1 || exit 1
dio87c -- rtse ref2 tsk3 true || exit 1
dio87c -- rtse ref2 tsk4 false || exit 1
dio87c -- rtsl ref2 tsk3 vr1 lock || exit 1
dio87c -- rtsl ref2 tsk4 vr2 unlock || exit 1
dio87c -- rtsl ref1 tsk1 none || exit 1
dio87c -- rtsc ref2 tsk3 33 44 begin || exit 1
dio87c -- rtsc ref2 tsk4 66 55 end || exit 1

# jobs
dio87c -- rja ref1 tsk1 job1 "job_1" || exit 1
dio87c -- rja ref1 tsk1 job2 || exit 1
dio87c -- rja ref1 tsk1 job3 || exit 1
dio87c -- rja ref2 tsk3 job4 || exit 1
dio87c -- rja ref2 tsk3 job5 || exit 1

dio87c -- rjsp ref1 tsk1 job1 "/bin/ls" || exit 1
dio87c -- rjsa ref1 tsk1 job1 "args" || exit 1
dio87c -- rjst ref1 tsk1 job1 33 36 || exit 1
dio87c -- rjswad ref1 tsk1 job1 true || exit 1
dio87c -- rjswad ref1 tsk1 job2 false || exit 1
dio87c -- rjsoec ref1 tsk1 job1 true || exit 1
dio87c -- rjsoec ref1 tsk1 job2 false || exit 1

# job dependencies 
dio87c -- rjda ref1 tsk1 job1 job2 always || exit 1
dio87c -- rjda ref1 tsk1 job1 job3 onerror || exit 1
dio87c -- rjda ref1 tsk1 job2 job3 onsuccess || exit 1
dio87c -- rjda ref2 tsk3 job4 job5 || exit 1

# task dependencies 
dio87c -- rta ref3 t1 || exit 1
dio87c -- rta ref3 t2 || exit 1
dio87c -- rta ref3 t3 || exit 1
dio87c -- rta ref3 t4 || exit 1
dio87c -- rtda ref3 t1 t2 always || exit 1
dio87c -- rtda ref3 t1 t3 onerror || exit 1
dio87c -- rtda ref3 t1 t4 onsuccess || exit 1

# task conditions
dio87c -- rtca ref1 tsk1 hmin "08:05" 0 || exit 1
dio87c -- rtca ref1 tsk1 hmax "09:05" 0 || exit 1
dio87c -- rtca ref1 tsk1 hlate "10:05" 0 || exit 1
dio87c -- rtca ref1 tsk1 file "/tmp/top" || exit 1
dio87c -- rtca ref1 tsk1 manual "OK" || exit 1
dio87c -- rtca ref1 tsk1 if_equal vr1 YES  || exit 1
dio87c -- rtca ref1 tsk1 if_not_equal vr2 NO  || exit 1

dio87c -- rtca ref1 tsk2 hmin "06:05" 1 || exit 1
dio87c -- rtca ref1 tsk2 hmax "07:05" 1 || exit 1
dio87c -- rtca ref1 tsk2 hlate "08:05" 1 || exit 1

# rules
dio87c -- rra ref1 rul1 || exit 1
dio87c -- rroa ref1 rul1 add day_of_week 3 || exit 1
dio87c -- rroa ref1 rul1 add day_of_month 4 || exit 1
dio87c -- rroa ref1 rul1 add week_of_month 5 || exit 1
dio87c -- rroa ref1 rul1 add month_of_year 6 || exit 1
dio87c -- rroa ref1 rul1 add day "07-08" || exit 1
dio87c -- rroa ref1 rul1 add date "2004-09-10" || exit 1
dio87c -- rroa ref1 rul1 add always || exit 1
dio87c -- rroa ref1 rul1 add if_equal vr1 OK || exit 1
dio87c -- rroa ref1 rul1 add if_not_equal vr2 NO || exit 1

dio87c -- rra ref1 rul2 || exit 1
dio87c -- rroa ref1 rul2 add day_of_week 2|| exit 1
dio87c -- rroa ref1 rul2 add_from day_of_week 3 || exit 1
dio87c -- rroa ref1 rul2 add_until day_of_week 4 || exit 1

dio87c -- rra ref1 rul3 || exit 1
dio87c -- rroa ref1 rul3 remove day_of_week 2|| exit 1
dio87c -- rroa ref1 rul3 remove_from day_of_week 3 || exit 1
dio87c -- rroa ref1 rul3 remove_until day_of_week 4 || exit 1

dio87c -- rra ref1 rul4 || exit 1
dio87c -- rroa ref1 rul4 shift_after day_of_week 2|| exit 1
dio87c -- rroa ref1 rul4 shift_before day_of_week 3|| exit 1

dio87c -- rra ref1 rul5 || exit 1
dio87c -- rroa ref1 rul5 add rule rul1 || exit 1

# task operations 
dio87c -- rtoa ref1 tsk1 add day_of_week 3 || exit 1
dio87c -- rtoa ref1 tsk1 add day_of_month 4 || exit 1
dio87c -- rtoa ref1 tsk1 add week_of_month 5 || exit 1
dio87c -- rtoa ref1 tsk1 add month_of_year 6 || exit 1
dio87c -- rtoa ref1 tsk1 add day "07-08" || exit 1
dio87c -- rtoa ref1 tsk1 add date "2004-09-10" || exit 1
dio87c -- rtoa ref1 tsk1 add always || exit 1
dio87c -- rtoa ref1 tsk1 add if_equal vr1 OK || exit 1
dio87c -- rtoa ref1 tsk1 add if_not_equal vr2 NO || exit 1

dio87c -- rtoa ref1 tsk2 add day_of_week 2|| exit 1
dio87c -- rtoa ref1 tsk2 add_from day_of_week 3 || exit 1
dio87c -- rtoa ref1 tsk2 add_until day_of_week 4 || exit 1

dio87c -- rtoa ref2 tsk3 remove day_of_week 2|| exit 1
dio87c -- rtoa ref2 tsk3 remove_from day_of_week 3 || exit 1
dio87c -- rtoa ref2 tsk3 remove_until day_of_week 4 || exit 1

dio87c -- rtoa ref2 tsk4 shift_after day_of_week 2|| exit 1
dio87c -- rtoa ref2 tsk4 shift_before day_of_week 3|| exit 1

dio87c -- rra ref3 rul1 || exit 1
dio87c -- rtoa ref3 tsk5 add rule rul1 || exit 1

# users
for f in generic communication user engine target referential job day variable ;
do
	dio87c -- ua user_$f
	dio87c -- usp user_$f none generic communication user engine target referential job day variable ;
	dio87c -- usp user_$f admin $f
done

echo "Restart dio87d"
stopDio87d
sleep 1
$PathDio87d -C $DATAPATH/dio87d.conf -d
sleep 1

# verify targets
echo " verify targets"
if [ "`dio87c -- tc`" != 3 ]; then
	echo "Can't find 3 targets !"; exit 1
fi
if [ "`dio87c -- tl | grep tg1`" != "tg1" ] ; then
	echo "Can't find target_1 !"; exit 1
fi
if [ "`dio87c -- tl | grep tg2`" != "tg2" ] ; then
	echo "Can't find target_2 !"; exit 1
fi
if [ "`dio87c -- ti -S! tg1 | grep Description`" != "Description!target_1" ] ; then
	echo "Incorrect target description !"; exit 1
fi
if [ "`dio87c -- ti -S! tg1 | grep \"Host Name\"`" != "Host Name!www.tg1.com" ] ; then
	echo "Incorrect target host name!"; exit 1
fi
if [ "`dio87c -- ti -S! tg1 | grep \"IP Port\"`" != "IP Port!8888" ] ; then
	echo "Incorrect target IP Port!"; exit 1
fi

# verify queues
echo " verify queues"
if [ "`dio87c -- qc tg1`" != 3 ]; then
	echo "Can't find 3 queues in target tg1 !"; exit 1
fi
if [ "`dio87c -- qc tg2`" != 4 ]; then
	echo "Can't find 4 queues in target tg2 !"; exit 1
fi
if [ "`dio87c -- ql tg1 | grep q1`" != "q1" ] ; then
	echo "Can't find queue 'q1' in target_1 !"; exit 1
fi
if [ "`dio87c -- ql tg1 | grep q2`" != "q2" ] ; then
	echo "Can't find queue 'q2' in target_1 !"; exit 1
fi
if [ "`dio87c -- qi -S! tg1 q1 | grep Description`" != "Description!queue_1" ] ; then
	echo "Incorrect queue description !"; exit 1
fi

# verify variables 
echo " verify variables"
if [ "`dio87c -- vc`" != 3 ]; then
	echo "Can't find three variables !"; exit 1
fi
for f in vr1 vr2 vr3 ; do
	if [ "`dio87c -- vl | grep $f`" != "$f" ] ; then
		echo "Can't find variable '$f' !"; exit 1
	fi
done
if [ "`dio87c -- vi -S! vr1 | grep Value`" != "Value!value1" ] ; then
	echo "Incorrect variable value !"; exit 1
fi

# verify users 
echo " verify users"
if [ "`dio87c -- uc`" -ne 11 ] ; then
	echo "Can't find 11 users !"; exit 1
fi
for f in generic communication user engine target referential job day variable ;
do
	if [ "`dio87c -- ul | grep user_$f | wc -l`" -ne "1" ]; then
		echo "Can't find user 'user_$f' !"; exit 1
	fi
	# all privileges are 'none' except one
	if [ "`dio87c -- ui user_$f | grep none | wc -l`" -ne "10" ]; then
		echo "Can't find 10 privileges to 'none' for user_$f"; exit 1
	fi
	if [ "`dio87c -- ui -S_ user_$f | grep ${f}_admin | wc -l`" -ne "1" ]; then
		echo "privileges '$f' is not set to 'admin'"; exit 1
	fi
done

# verify referentials
echo " verify referentials"
if [ "`dio87c -- rc`" != 3 ]; then
	echo "Can't find three referentials !"; exit 1
fi
for f in ref1 ref2 ref3 ; do
	if [ "`dio87c -- rl | grep $f`" != "$f" ] ; then
		echo "Can't find referential '$f' !"; exit 1
	fi
done

# verify tasks 
echo " verify tasks"
if [ "`dio87c -- rtc ref1`" != 2 ]; then
	echo "Can't find two tasks in ref1!"; exit 1
fi
for f in tsk1 tsk2 ; do
	if [ "`dio87c -- rtl ref1 | grep $f`" != "$f" ] ; then
		echo "Can't find tasks '$f' in ref1 !"; exit 1
	fi
done
if [ "`dio87c -- rtc ref2`" != 2 ]; then
	echo "Can't find two tasks in ref2!"; exit 1
fi
for f in tsk3 tsk4 ; do
	if [ "`dio87c -- rtl ref2 | grep $f`" != "$f" ] ; then
		echo "Can't find tasks '$f' in ref2 !"; exit 1
	fi
done
if [ "`dio87c -- rtc ref3`" != 5 ]; then
	echo "Can't find one tasks in ref3!"; exit 1
fi
# verify task properties
if [ "`dio87c -- rti -S! ref1 tsk1 | grep Description`" != "Description!task_1" ] ; then
	echo "Incorrect task description !"; exit 1
fi
# verify "wait all dependencies"
if [ "`dio87c -- rti -S! ref1 tsk1 | grep \"Wait All Dependencies\"`" != "Wait All Dependencies!true" ] ; then
	echo "Incorrect 'Wait All Dependencies' for tsk1 !"; exit 1
fi
if [ "`dio87c -- rti -S! ref1 tsk2 | grep \"Wait All Dependencies\"`" != "Wait All Dependencies!false" ] ; then
	echo "Incorrect 'Wait All Dependencies' for tsk2 !"; exit 1
fi
# verify "on error continue"
if [ "`dio87c -- rti -S! ref1 tsk1 | grep \"On Error Continue\"`" != "On Error Continue!true" ] ; then
	echo "Incorrect 'On Error Continue' for tsk1 !"; exit 1
fi
if [ "`dio87c -- rti -S! ref1 tsk2 | grep \"On Error Continue\"`" != "On Error Continue!false" ] ; then
	echo "Incorrect 'On Error Continue' for tsk2 !"; exit 1
fi
# verify target and queue 
if [ "`dio87c -- rti -S! ref1 tsk1 | grep Target`" != "Target!tg1" ] ; then
	echo "Incorrect target for tsk1 !"; exit 1
fi
if [ "`dio87c -- rti -S! ref1 tsk2 | grep Target`" != "Target!none" ] ; then
	echo "Incorrect target for tsk2 !"; exit 1
fi
if [ "`dio87c -- rti -S! ref1 tsk1 | grep Queue`" != "Queue!q1" ] ; then
	echo "Incorrect queue for tsk1 !"; exit 1
fi
if [ "`dio87c -- rti -S! ref1 tsk2 | grep Queue`" != "Queue!none" ] ; then
	echo "Incorrect queue for tsk2 !"; exit 1
fi
#check rtse ref2 tsk3 true 
if [ "`dio87c -- rti -S_ ref2 tsk3 | grep Enabled`" != "Enabled_true" ]; then
	echo "Incorrect value for 'enabled' property"; exit 1
fi
#check ref2 tsk4 false
if [ "`dio87c -- rti -S_ ref2 tsk4 | grep Enabled`" != "Enabled_false" ]; then
	echo "Incorrect value for 'enabled' property"; exit 1
fi
# check "ref1 tsk1 none"
if [ "`dio87c -- rti -S_ ref1 tsk1 | grep \"Lock Variable\"`" != "Lock Variable_none" ]; then
	echo "Incorrect value for 'lock variable' property"; exit 1
fi
if [ "`dio87c -- rti -S_ ref1 tsk1 | grep \"Lock Action\"`" != "Lock Action_none" ]; then
	echo "Incorrect value for 'lock action' property"; exit 1
fi

#check ref2 tsk3 vr1 lock
if [ "`dio87c -- rti -S_ ref2 tsk3 | grep \"Lock Variable\"`" != "Lock Variable_vr1" ]; then
	echo "Incorrect value for 'lock variable' property"; exit 1
fi
if [ "`dio87c -- rti -S_ ref2 tsk3 | grep \"Lock Action\"`" != "Lock Action_lock" ]; then
	echo "Incorrect value for 'lock action' property"; exit 1
fi

#check ref2 tsk4 vr2 unlock
if [ "`dio87c -- rti -S_ ref2 tsk4 | grep \"Lock Variable\"`" != "Lock Variable_vr2" ]; then
	echo "Incorrect value for 'lock variable' property"; exit 1
fi
if [ "`dio87c -- rti -S_ ref2 tsk4 | grep \"Lock Action\"`" != "Lock Action_unlock" ]; then
	echo "Incorrect value for 'lock action' property"; exit 1
fi

#check "rtsc ref2 tsk3 33 44 begin" 
if [ "`dio87c -- rti -S_ ref2 tsk3 | grep Iterations`" != "Iterations_33" ]; then
	echo "Incorrect value for 'iteration' property"; exit 1
fi
if [ "`dio87c -- rti -S_ ref2 tsk3 | grep Interval`" != "Interval_44" ]; then
	echo "Incorrect value for 'interval' property"; exit 1
fi
if [ "`dio87c -- rti -S_ ref2 tsk3 | grep From`" != "From_begin" ]; then
	echo "Incorrect value for 'from' property"; exit 1
fi
#check "rtsc ref2 tsk4 66 55 end"
if [ "`dio87c -- rti -S_ ref2 tsk4 | grep Iterations`" != "Iterations_66" ]; then
	echo "Incorrect value for 'iteration' property"; exit 1
fi
if [ "`dio87c -- rti -S_ ref2 tsk4 | grep Interval`" != "Interval_55" ]; then
	echo "Incorrect value for 'interval' property"; exit 1
fi
if [ "`dio87c -- rti -S_ ref2 tsk4 | grep From`" != "From_end" ]; then
	echo "Incorrect value for 'from' property"; exit 1
fi

# verify jobs 
echo " verify jobs"
if [ "`dio87c -- rjc ref1 tsk1`" != 3 ]; then
	echo "Can't find three jobs in tsk1 in ref1!"; exit 1
fi
for f in job1 job2 job3 ; do
	if [ "`dio87c -- rjl ref1 tsk1 | grep $f`" != "$f" ] ; then
		echo "Can't find job '$f' in tsk1 in ref1 !"; exit 1
	fi
done
if [ "`dio87c -- rjc ref2 tsk3`" != 2 ]; then
	echo "Can't find two jobs in tsk3 in ref2!"; exit 1
fi
for f in job4 job5 ; do
	if [ "`dio87c -- rjl ref2 tsk3 | grep $f`" != "$f" ] ; then
		echo "Can't find job '$f' in tsk3 in ref2 !"; exit 1
	fi
done

# verify job properties
if [ "`dio87c -- rji -S! ref1 tsk1 job1 | grep Description`" != "Description!job_1" ] ; then
	echo "Incorrect job description !"; exit 1
fi
if [ "`dio87c -- rji -S! ref1 tsk1 job1 | grep Path`" != "Path!/bin/ls" ] ; then
	echo "Incorrect job path !"; exit 1
fi
if [ "`dio87c -- rji -S! ref1 tsk1 job1 | grep Argument`" != "Argument!args" ] ; then
	echo "Incorrect job argument !"; exit 1
fi
if [ "`dio87c -- rji -S! ref1 tsk1 job1 | grep \"Start Tempo\"`" != "Start Tempo!33" ] ; then
	echo "Incorrect job start tempo!"; exit 1
fi
if [ "`dio87c -- rji -S! ref1 tsk1 job1 | grep \"End Tempo\"`" != "End Tempo!36" ] ; then
	echo "Incorrect job start tempo!"; exit 1
fi
if [ "`dio87c -- rji -S! ref1 tsk1 job1 | grep \"Wait All Dependencies\"`" != "Wait All Dependencies!true" ] ; then
	echo "Incorrect 'wait all dependencies' for job1 !"; exit 1
fi
if [ "`dio87c -- rji -S! ref1 tsk1 job2 | grep \"Wait All Dependencies\"`" != "Wait All Dependencies!false" ] ; then
	echo "Incorrect 'wait all dependencies' for job2 !"; exit 1
fi
if [ "`dio87c -- rji -S! ref1 tsk1 job1 | grep \"On Error Continue\"`" != "On Error Continue!true" ] ; then
	echo "Incorrect 'on error continue' for job1 !"; exit 1
fi
if [ "`dio87c -- rji -S! ref1 tsk1 job2 | grep \"On Error Continue\"`" != "On Error Continue!false" ] ; then
	echo "Incorrect 'on error continue' for job2 !"; exit 1
fi

# verify jobs dependencies
echo " verify jobs dependencies"
if [ "`dio87c -- rjdc ref1 tsk1`" != 3 ]; then
	echo "Can't find three jobs dependencies in tsk1 in ref1!"; exit 1
fi
if [ "`dio87c -- rjdc ref2 tsk3`" != 1 ]; then
	echo "Can't find one jobs dependence in tsk3 in ref2!"; exit 1
fi
if [ "`dio87c -- rjdl -tS_ ref1 tsk1 | grep job1_job2_always | wc -l`" -ne "1" ] ; then
	echo "Can't find 'always' job dependence  !"; exit 1
fi
if [ "`dio87c -- rjdl -tS_ ref1 tsk1 | grep job1_job3_onerror | wc -l`" -ne "1" ] ; then
	echo "Can't find 'onerror' job dependence  !"; exit 1
fi
if [ "`dio87c -- rjdl -tS_ ref1 tsk1 | grep job2_job3_onsuccess | wc -l`" -ne "1" ] ; then
	echo "Can't find 'onsuccess' job dependence  !"; exit 1
fi

# verify tasks dependencies
echo " verify tasks dependencies"
if [ "`dio87c -- rtdc ref3`" != 3 ]; then
	echo "Can't find three tasks dependencies in ref3!"; exit 1
fi
if [ "`dio87c -- rtdl -tS_ ref3 | grep t1_t2_always | wc -l`" -ne "1" ] ; then
	echo "Can't find 'always' task dependence  !"; exit 1
fi
if [ "`dio87c -- rtdl -tS_ ref3 | grep t1_t3_onerror | wc -l`" -ne "1" ] ; then
	echo "Can't find 'onerror' task dependence  !"; exit 1
fi
if [ "`dio87c -- rtdl -tS_ ref3 | grep t1_t4_onsuccess | wc -l`" -ne "1" ] ; then
	echo "Can't find 'onsuccess' task dependence  !"; exit 1
fi

# verify rules
echo " verify rules"
if [ "`dio87c -- rrc ref1`" -ne 5 ] ; then
	echo "Can't find 4 rules in ref1 !"; exit 1
fi
for f in rul1 rul2 rul3 rul4 rul5 ; do
	if [ "`dio87c -- rrl ref1 | grep $f | wc -l`" -ne "1" ]; then
		echo "Can't find rule '$f' !"; exit 1
	fi
done

# verify rul1
if [ "`dio87c -- rrol -S_ ref1 rul1 | grep add_day_of_week_3 | wc -l`" -ne "1" ] ; then
	echo "Can't find 'add day_of_week' rule operation !"; exit 1
fi
if [ "`dio87c -- rrol -S_ ref1 rul1 | grep add_day_of_month_4 | wc -l`" -ne "1" ] ; then
	echo "Can't find 'add day_of_month' rule operation !"; exit 1
fi
if [ "`dio87c -- rrol -S_ ref1 rul1 | grep add_week_of_month_5 | wc -l`" -ne "1" ] ; then
	echo "Can't find 'add week_of_month' rule operation !"; exit 1
fi
if [ "`dio87c -- rrol -S_ ref1 rul1 | grep add_month_of_year_6 | wc -l`" -ne "1" ] ; then
	echo "Can't find 'add month_of_year' rule operation !"; exit 1
fi
if [ "`dio87c -- rrol -S_ ref1 rul1 | grep \"add_day_07-08\" | wc -l`" -ne "1" ] ; then
	echo "Can't find 'add day' rule operation !"; exit 1
fi
if [ "`dio87c -- rrol -S_ ref1 rul1 | grep \"add_date_2004-09-10\" | wc -l`" -ne "1" ] ; then
	echo "Can't find 'add date' rule operation !"; exit 1
fi
if [ "`dio87c -- rrol -S_ ref1 rul1 | grep add_always | wc -l`" -ne "1" ] ; then
	echo "Can't find 'add always' rule operation !"; exit 1
fi
if [ "`dio87c -- rrol -S_ ref1 rul1 | grep add_if_equal_vr1_OK | wc -l`" -ne "1" ] ; then
	echo "Can't find 'add if_equal' rule operation !"; exit 1
fi
if [ "`dio87c -- rrol -S_ ref1 rul1 | grep add_if_not_equal_vr2_NO | wc -l`" -ne "1" ] ; then
	echo "Can't find 'add if_not_equal' rule operation !"; exit 1
fi

#verify rul2
if [ "`dio87c -- rrol -S_ ref1 rul2 | grep add_day_of_week_2 | wc -l`" -ne "1" ] ; then
	echo "Can't find 'add day_of_week' rule operation !"; exit 1
fi
if [ "`dio87c -- rrol -S_ ref1 rul2 | grep add_from_day_of_week_3 | wc -l`" -ne "1" ] ; then
	echo "Can't find 'add_from day_of_week' rule operation !"; exit 1
fi
if [ "`dio87c -- rrol -S_ ref1 rul2 | grep add_until_day_of_week_4 | wc -l`" -ne "1" ] ; then
	echo "Can't find 'add_until day_of_week' rule operation !"; exit 1
fi

#verify rul3
if [ "`dio87c -- rrol -S_ ref1 rul3 | grep remove_day_of_week_2 | wc -l`" -ne "1" ] ; then
	echo "Can't find 'remove day_of_week' rule operation !"; exit 1
fi
if [ "`dio87c -- rrol -S_ ref1 rul3 | grep remove_from_day_of_week_3 | wc -l`" -ne "1" ] ; then
	echo "Can't find 'remove_from day_of_week' rule operation !"; exit 1
fi
if [ "`dio87c -- rrol -S_ ref1 rul3 | grep remove_until_day_of_week_4 | wc -l`" -ne "1" ] ; then
	echo "Can't find 'remove_until day_of_week' rule operation !"; exit 1
fi

#verify rul4
if [ "`dio87c -- rrol -S_ ref1 rul4 | grep shift_after_day_of_week_2 | wc -l`" -ne "1" ] ; then
	echo "Can't find 'shift_after day_of_week' rule operation !"; exit 1
fi
if [ "`dio87c -- rrol -S_ ref1 rul4 | grep shift_before_day_of_week_3 | wc -l`" -ne "1" ] ; then
	echo "Can't find 'shift_before day_of_week' rule operation !"; exit 1
fi

#verify rul5
if [ "`dio87c -- rrol -S_ ref1 rul5 | grep add_rule_rul1 | wc -l`" -ne "1" ] ; then
	echo "Can't find 'add rule' rule operation !"; exit 1
fi

# verify tasks rules
echo " verify task operations"
# verify tsk1
if [ "`dio87c -- rtol -S_ ref1 tsk1 | grep add_day_of_week_3 | wc -l`" -ne "1" ] ; then
	echo "Can't find 'add day_of_week' task operation !"; exit 1
fi
if [ "`dio87c -- rtol -S_ ref1 tsk1 | grep add_day_of_month_4 | wc -l`" -ne "1" ] ; then
	echo "Can't find 'add day_of_month' task operation !"; exit 1
fi
if [ "`dio87c -- rtol -S_ ref1 tsk1 | grep add_week_of_month_5 | wc -l`" -ne "1" ] ; then
	echo "Can't find 'add week_of_month' task operation !"; exit 1
fi
if [ "`dio87c -- rtol -S_ ref1 tsk1 | grep add_month_of_year_6 | wc -l`" -ne "1" ] ; then
	echo "Can't find 'add month_of_year' task operation !"; exit 1
fi
if [ "`dio87c -- rtol -S_ ref1 tsk1 | grep \"add_day_07-08\" | wc -l`" -ne "1" ] ; then
	echo "Can't find 'add day' task operation !"; exit 1
fi
if [ "`dio87c -- rtol -S_ ref1 tsk1 | grep \"add_date_2004-09-10\" | wc -l`" -ne "1" ] ; then
	echo "Can't find 'add date' task operation !"; exit 1
fi
if [ "`dio87c -- rtol -S_ ref1 tsk1 | grep add_always | wc -l`" -ne "1" ] ; then
	echo "Can't find 'add always' task operation !"; exit 1
fi
if [ "`dio87c -- rtol -S_ ref1 tsk1 | grep add_if_equal_vr1_OK | wc -l`" -ne "1" ] ; then
	echo "Can't find 'add if_equal' task operation !"; exit 1
fi
if [ "`dio87c -- rtol -S_ ref1 tsk1 | grep add_if_not_equal_vr2_NO | wc -l`" -ne "1" ] ; then
	echo "Can't find 'add if_not_equal' taskoperation !"; exit 1
fi

#verify tsk2
if [ "`dio87c -- rtol -S_ ref1 tsk2 | grep add_day_of_week_2 | wc -l`" -ne "1" ] ; then
	echo "Can't find 'add day_of_week' task operation !"; exit 1
fi
if [ "`dio87c -- rtol -S_ ref1 tsk2 | grep add_from_day_of_week_3 | wc -l`" -ne "1" ] ; then
	echo "Can't find 'add_from day_of_week' task operation !"; exit 1
fi
if [ "`dio87c -- rtol -S_ ref1 tsk2 | grep add_until_day_of_week_4 | wc -l`" -ne "1" ] ; then
	echo "Can't find 'add_until day_of_week' task operation !"; exit 1
fi

#verify tsk3
if [ "`dio87c -- rtol -S_ ref2 tsk3 | grep remove_day_of_week_2 | wc -l`" -ne "1" ] ; then
	echo "Can't find 'remove day_of_week' task operation !"; exit 1
fi
if [ "`dio87c -- rtol -S_ ref2 tsk3 | grep remove_from_day_of_week_3 | wc -l`" -ne "1" ] ; then
	echo "Can't find 'remove_from day_of_week' task operation !"; exit 1
fi
if [ "`dio87c -- rtol -S_ ref2 tsk3 | grep remove_until_day_of_week_4 | wc -l`" -ne "1" ] ; then
	echo "Can't find 'remove_until day_of_week' task operation !"; exit 1
fi

#verify tsk4
if [ "`dio87c -- rtol -S_ ref2 tsk4 | grep shift_after_day_of_week_2 | wc -l`" -ne "1" ] ; then
	echo "Can't find 'shift_after day_of_week' task operation !"; exit 1
fi
if [ "`dio87c -- rtol -S_ ref2 tsk4 | grep shift_before_day_of_week_3 | wc -l`" -ne "1" ] ; then
	echo "Can't find 'shift_before day_of_week' task operation !"; exit 1
fi

if [ "`dio87c -- rtol -S_ ref3 tsk5 | grep add_rule_rul1 | wc -l`" -ne "1" ] ; then
	echo "Can't find 'add rule' task operation !"; exit 1
fi

# verify conditions
echo " verify tasks conditions"
if [ "`dio87c -- rtcl -S_ ref1 tsk1 | grep \"hmin_08:05_+0\" | wc -l`" -ne "1" ] ; then
	echo "Can't find 'hmin' task condition !"; exit 1
fi
if [ "`dio87c -- rtcl -S_ ref1 tsk1 | grep \"hmax_09:05_+0\" | wc -l`" -ne "1" ] ; then
	echo "Can't find 'hmax' task condition !"; exit 1
fi
if [ "`dio87c -- rtcl -S_ ref1 tsk1 | grep \"hlate_10:05_+0\" | wc -l`" -ne "1" ] ; then
	echo "Can't find 'hlate' task condition !"; exit 1
fi
if [ "`dio87c -- rtcl -S_ ref1 tsk1 | grep \"file_/tmp/top\" | wc -l`" -ne "1" ] ; then
	echo "Can't find 'file' task condition !"; exit 1
fi
if [ "`dio87c -- rtcl -S_ ref1 tsk1 | grep \"manual_OK\" | wc -l`" -ne "1" ] ; then
	echo "Can't find 'manual' task condition !"; exit 1
fi
if [ "`dio87c -- rtcl -S_ ref1 tsk1 | grep \"if_equal_vr1_YES\" | wc -l`" -ne "1" ] ; then
	echo "Can't find 'if_equal' task condition !"; exit 1
fi
if [ "`dio87c -- rtcl -S_ ref1 tsk1 | grep \"if_not_equal_vr2_NO\" | wc -l`" -ne "1" ] ; then
	echo "Can't find 'if_not_equal' task condition !"; exit 1
fi

if [ "`dio87c -- rtcl -S_ ref1 tsk2 | grep \"hmin_06:05_+1\" | wc -l`" -ne "1" ] ; then
	echo "Can't find 'hmin' task condition !"; exit 1
fi
if [ "`dio87c -- rtcl -S_ ref1 tsk2 | grep \"hmax_07:05_+1\" | wc -l`" -ne "1" ] ; then
	echo "Can't find 'hmax' task condition !"; exit 1
fi
if [ "`dio87c -- rtcl -S_ ref1 tsk2 | grep \"hlate_08:05_+1\" | wc -l`" -ne "1" ] ; then
	echo "Can't find 'hlate' task condition !"; exit 1
fi

stopDio87d || exit 1
