#!/bin/sh
#
# file tst34.sh 
# (test dio87d save)
#
#      Diogene87
#	Copyright (C) 2003,2004,2005 - Dominique Parisot
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this software; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
# Boston, MA 02111-1307 USA
#


if [ "$srcdir" = "" ]; then srcdir="."; fi
. $srcdir/functions.sh
checkNoDaemon

echo "test dio87d save"

startDio87d || exit 1

echo " create database"

# variables
dio87c -- va vr1 value1 || exit 1
dio87c -- va vr2 || exit 1
dio87c -- va vr3 || exit 1

# targets
dio87c -- ta tg1 "target_1" || exit 1 
dio87c -- tsh tg1 "www.tg1.com"
dio87c -- tsp tg1 8888
dio87c -- ta tg2 "target_2" || exit 1

# queues
dio87c -- qa tg1 q1 "queue_1" || exit 1
dio87c -- qsm tg1 q1 99 || exit 1
dio87c -- qa tg1 q2 "queue_2" || exit 1
dio87c -- qa tg2 q3 || exit 1
dio87c -- qa tg2 q4 || exit 1
dio87c -- qa tg2 q5 || exit 1

# users
for f in generic communication user engine target referential job day variable ;
do
	dio87c -- ua user_$f || exit 1
	dio87c -- usp user_$f none generic communication user engine target referential job day variable || exit 1
	dio87c -- usp user_$f admin $f || exit 1
done

# referential
dio87c -- ra ref1 || exit 1
dio87c -- ra ref2 || exit 1

# tasks
dio87c -- rta ref1 tsk1 "tsk1" || exit 1
dio87c -- rtoa ref1 tsk1 add always || exit 1
dio87c -- rta ref1 tsk2 || exit 1
dio87c -- rtoa ref1 tsk2 add always || exit 1
dio87c -- rta ref1 tsk3 || exit 1
dio87c -- rtoa ref1 tsk3 add always || exit 1
dio87c -- rta ref1 tsk4 || exit 1
dio87c -- rtoa ref1 tsk4 add always || exit 1
dio87c -- rta ref1 tsk5 || exit 1
dio87c -- rtoa ref1 tsk5 add always || exit 1

dio87c -- rta ref2 tsk6 || exit 1
dio87c -- rtoa ref2 tsk6 add always || exit 1
dio87c -- rta ref2 tsk7 || exit 1
dio87c -- rtoa ref2 tsk7 add always || exit 1

dio87c -- rtswad ref1 tsk1 true || exit 1
dio87c -- rtswad ref1 tsk2 false || exit 1
dio87c -- rtsoec ref1 tsk1 true || exit 1
dio87c -- rtsoec ref1 tsk2 false || exit 1
dio87c -- rtst ref1 tsk1 tg1 q1 || exit 1
dio87c -- rtst ref1 tsk2 none || exit 1

dio87c -- rtsl ref1 tsk3 vr1 lock || exit 1
dio87c -- rtsl ref1 tsk4 vr2 unlock || exit 1
dio87c -- rtsl ref1 tsk1 none || exit 1
dio87c -- rtsc ref1 tsk3 33 44 begin || exit 1
dio87c -- rtsc ref1 tsk4 66 55 end || exit 1


# tasks conditions
dio87c -- rtca ref1 tsk5 hmin "08:05" 0 || exit 1
dio87c -- rtca ref1 tsk5 hmax "09:05" 0 || exit 1
dio87c -- rtca ref1 tsk5 hlate "10:05" 0 || exit 1
dio87c -- rtca ref1 tsk5 file "/tmp/top" || exit 1
dio87c -- rtca ref1 tsk5 manual "OK" || exit 1
dio87c -- rtca ref1 tsk5 if_equal vr1 YES  || exit 1
dio87c -- rtca ref1 tsk5 if_not_equal vr2 NO  || exit 1

dio87c -- rtca ref1 tsk4 hmin "06:05" 1 || exit 1
dio87c -- rtca ref1 tsk4 hmax "07:05" 1 || exit 1
dio87c -- rtca ref1 tsk4 hlate "08:05" 1 || exit 1

# tasks dependencies
dio87c -- rtda ref1 tsk1 tsk2 always || exit 1
dio87c -- rtda ref1 tsk1 tsk3 onerror || exit 1
dio87c -- rtda ref1 tsk2 tsk4 onsuccess || exit 1
dio87c -- rtda ref2 tsk6 tsk7 always || exit 1

# jobs
dio87c -- rja ref1 tsk1 job1 "job1" || exit 1
dio87c -- rja ref1 tsk1 job2 || exit 1
dio87c -- rja ref1 tsk1 job3 || exit 1
dio87c -- rja ref1 tsk1 job4 || exit 1
dio87c -- rja ref1 tsk1 job5 || exit 1
dio87c -- rja ref1 tsk2 job6 || exit 1
dio87c -- rja ref1 tsk2 job7 || exit 1

dio87c -- rjsp ref1 tsk1 job1 "/bin/ls" || exit 1
dio87c -- rjsa ref1 tsk1 job1 "args" || exit 1
dio87c -- rjst ref1 tsk1 job1 33 36 || exit 1
dio87c -- rjswad ref1 tsk1 job1 true || exit 1
dio87c -- rjswad ref1 tsk1 job2 false || exit 1
dio87c -- rjsoec ref1 tsk1 job1 true || exit 1
dio87c -- rjsoec ref1 tsk1 job2 false || exit 1

# jobs dependencies
dio87c -- rjda ref1 tsk1 job1 job2 always || exit 1
dio87c -- rjda ref1 tsk1 job2 job3 onsuccess || exit 1
dio87c -- rjda ref1 tsk1 job3 job4 onerror || exit 1
dio87c -- rjda ref1 tsk2 job6 job7 always || exit 1

# create new days
echo " create new days"
dio87c -- rp -d ref1 "$dayDate" day1 >/dev/null || exit 1
sleep 2
dio87c -- rp -d ref2 "$dayDate" day2 >/dev/null || exit 1
sleep 2
dio87c -- ese false || exit 1
dio87c -- xdse day1 false || exit 1
dio87c -- xdse day2 true || exit 1

# change task state
dio87c -- xtu day1 tsk1 terminated || exit 1
dio87c -- xtu day1 tsk2 aborted || exit 1
# change job state
dio87c -- xju day1 tsk1 job1 terminated || exit 1
dio87c -- xju day1 tsk1 job2 aborted 23 || exit 1
# change condition state
dio87c -- xtcv day1 tsk5 hmin "08:05" 0 || exit 1

restartDio87d

# verify targets
echo " verify targets"
if [ "`dio87c -- tc`" != 3 ]; then
	echo "Can't find 3 targets !"; exit 1
fi
if [ "`dio87c -- tl | grep tg1`" != "tg1" ] ; then
	echo "Can't find target_1 !"; exit 1
fi
if [ "`dio87c -- tl | grep tg2`" != "tg2" ] ; then
	echo "Can't find target_2 !"; exit 1
fi
if [ "`dio87c -- ti -S! tg1 | grep Description`" != "Description!target_1" ] ; then
	echo "Incorrect target description !"; exit 1
fi
if [ "`dio87c -- ti -S! tg1 | grep \"Host Name\"`" != "Host Name!www.tg1.com" ] ; then
	echo "Incorrect target host name!"; exit 1
fi
if [ "`dio87c -- ti -S! tg1 | grep \"IP Port\"`" != "IP Port!8888" ] ; then
	echo "Incorrect target IP Port!"; exit 1
fi

# verify queues
echo " verify queues"
if [ "`dio87c -- qc tg1`" != 3 ]; then
	echo "Can't find 3 queues in target tg1 !"; exit 1
fi
if [ "`dio87c -- qc tg2`" != 4 ]; then
	echo "Can't find 4 queues in target tg2 !"; exit 1
fi
if [ "`dio87c -- ql tg1 | grep q1`" != "q1" ] ; then
	echo "Can't find queue 'q1' in target_1 !"; exit 1
fi
if [ "`dio87c -- ql tg1 | grep q2`" != "q2" ] ; then
	echo "Can't find queue 'q2' in target_1 !"; exit 1
fi
if [ "`dio87c -- qi -S! tg1 q1 | grep Description`" != "Description!queue_1" ] ; then
	echo "Incorrect queue description !"; exit 1
fi
if [ "`dio87c -- qi -S! tg1 q1 | grep Max`" != "Max!99" ] ; then
	echo "Incorrect queue max running job!"; exit 1
fi

# verify variables 
echo " verify variables"
if [ "`dio87c -- vc`" != 3 ]; then
	echo "Can't find three variables !"; exit 1
fi
for f in vr1 vr2 vr3 ; do
	if [ "`dio87c -- vl | grep $f`" != "$f" ] ; then
		echo "Can't find variable '$f' !"; exit 1
	fi
done
if [ "`dio87c -- vi -S! vr1 | grep Value`" != "Value!value1" ] ; then
	echo "Incorrect variable value !"; exit 1
fi

# verify users 
echo " verify users"
if [ "`dio87c -- uc`" -ne 11 ] ; then
	echo "Can't find 11 users !"; exit 1
fi
for f in generic communication user engine target referential job day variable ;
do
	if [ "`dio87c -- ul | grep user_$f | wc -l`" -ne "1" ]; then
		echo "Can't find user 'user_$f' !"; exit 1
	fi
	# all privileges are 'none' except one
	if [ "`dio87c -- ui user_$f | grep none | wc -l`" -ne "10" ]; then
		echo "Can't find 10 privileges to 'none'"; exit 1
	fi
	if [ "`dio87c -- ui -S_ user_$f | grep ${f}_admin | wc -l`" -ne "1" ]; then
		echo "privileges '$f' is not set to 'admin'"; exit 1
	fi
done

# verify days 
echo " verify days"
if [ "`dio87c -- xdc`" != 2 ]; then
	echo "Can't find 2 days !"; exit 1
fi
for f in day1 day2 ; do
	if [ "`dio87c -- xdl | grep $f`" != "$f" ] ; then
		echo "Can't find day '$f' !"; exit 1
	fi
done
if [ "`dio87c -- xdi -S_ day1 | grep \"Start Time_$dayDate\" | wc -l`" -ne "1" ]; then
	echo "Incorrect date for day1"; exit 1
fi
if [ "`dio87c -- xdi -S_ day1 | grep \"Enabled_false\" | wc -l`" -ne "1" ]; then
	echo "day1 is not disabled"; exit 1
fi
if [ "`dio87c -- xdi -S_ day2 | grep \"Enabled_true\" | wc -l`" -ne "1" ]; then
	echo "day2 is not enabled"; exit 1
fi

# verify tasks 
echo " verify tasks"
if [ "`dio87c -- xtc day1`" != 5 ]; then
	echo "Can't find 5 tasks in day1 !"; exit 1
fi
for f in tsk1 tsk2 tsk3 tsk4 tsk5 ; do
	if [ "`dio87c -- xtl day1 | grep $f`" != "$f" ] ; then
		echo "Can't find task '$f' in day1 !"; exit 1
	fi
done
if [ "`dio87c -- xtc day2`" != 2 ]; then
	echo "Can't find 2 tasks in day2 !"; exit 1
fi
for f in tsk6 tsk7 ; do
	if [ "`dio87c -- xtl day2 | grep $f`" != "$f" ] ; then
		echo "Can't find task '$f' in day2 !"; exit 1
	fi
done

# verify task properties
if [ "`dio87c -- xti -S! day1 tsk1 | grep Description`" != "Description!tsk1" ] ; then
	echo "Incorrect task description !"; exit 1
fi
if [ "`dio87c -- xti -S_ day1 tsk1 | grep State`" != "State_terminated" ] ; then
	echo "Incorrect state for tsk1 !"; exit 1
fi
if [ "`dio87c -- xti -S_ day1 tsk2 | grep State`" != "State_aborted" ] ; then
	echo "Incorrect state for tsk2 !"; exit 1
fi
if [ "`dio87c -- xti -S_ day1 tsk3 | grep State`" != "State_uninitialized" ] ; then
	echo "Incorrect state for tsk3 !"; exit 1
fi

# verify "wait all dependencies"
if [ "`dio87c -- xti -S! day1 tsk1 | grep \"Wait All Dependencies\"`" != "Wait All Dependencies!true" ] ; then
	echo "Incorrect 'Wait All Dependencies' for tsk1 !"; exit 1
fi
if [ "`dio87c -- xti -S! day1 tsk2 | grep \"Wait All Dependencies\"`" != "Wait All Dependencies!false" ] ; then
	echo "Incorrect 'Wait All Dependencies' for tsk2 !"; exit 1
fi
# verify "on error continue"
if [ "`dio87c -- xti -S! day1 tsk1 | grep \"On Error Continue\"`" != "On Error Continue!true" ] ; then
	echo "Incorrect 'On Error Continue' for tsk1 !"; exit 1
fi
if [ "`dio87c -- xti -S! day1 tsk2 | grep \"On Error Continue\"`" != "On Error Continue!false" ] ; then
	echo "Incorrect 'On Error Continue' for tsk2 !"; exit 1
fi
# verify target and queue 
if [ "`dio87c -- xti -S! day1 tsk1 | grep Target`" != "Target!tg1" ] ; then
	echo "Incorrect target for tsk1 !"; exit 1
fi
if [ "`dio87c -- xti -S! day1 tsk2 | grep Target`" != "Target!none" ] ; then
	echo "Incorrect target for tsk2 !"; exit 1
fi
if [ "`dio87c -- xti -S! day1 tsk1 | grep Queue`" != "Queue!q1" ] ; then
	echo "Incorrect queue for tsk1 !"; exit 1
fi
if [ "`dio87c -- xti -S! day1 tsk2 | grep Queue`" != "Queue!none" ] ; then
	echo "Incorrect queue for tsk2 !"; exit 1
fi

# check "rtsl ref1 tsk3 vr1 lock"
if [ "`dio87c -- xti -S_ day1 tsk3 | grep \"Lock Variable\"`" != "Lock Variable_vr1" ]; then
	echo "Incorrect value for 'lock variable' property"; exit 1
fi
if [ "`dio87c -- xti -S_ day1 tsk3 | grep \"Lock Action\"`" != "Lock Action_lock" ]; then
	echo "Incorrect value for 'lock action' property"; exit 1
fi

# check "rtsl ref1 tsk4 vr2 unlock"
if [ "`dio87c -- xti -S_ day1 tsk4 | grep \"Lock Variable\"`" != "Lock Variable_vr2" ]; then
	echo "Incorrect value for 'lock variable' property"; exit 1
fi
if [ "`dio87c -- xti -S_ day1 tsk4 | grep \"Lock Action\"`" != "Lock Action_unlock" ]; then
	echo "Incorrect value for 'lock action' property"; exit 1
fi


# check "rtsl ref1 tsk1 none"
if [ "`dio87c -- xti -S_ day1 tsk1 | grep \"Lock Variable\"`" != "Lock Variable_none" ]; then
	echo "Incorrect value for 'lock variable' property"; exit 1
fi
if [ "`dio87c -- xti -S_ day1 tsk1 | grep \"Lock Action\"`" != "Lock Action_none" ]; then
	echo "Incorrect value for 'lock action' property"; exit 1
fi

# check "rtsc ref1 tsk3 33 44 begin"
if [ "`dio87c -- xti -S_ day1 tsk3 | grep Iterations`" != "Iterations_33" ]; then
	echo "Incorrect value for 'iteration' property"; exit 1
fi
if [ "`dio87c -- xti -S_ day1 tsk3 | grep Interval`" != "Interval_44" ]; then
	echo "Incorrect value for 'interval' property"; exit 1
fi
if [ "`dio87c -- xti -S_ day1 tsk3 | grep From`" != "From_begin" ]; then
	echo "Incorrect value for 'from' property"; exit 1
fi

# check "rtsc ref1 tsk4 66 55 end"
if [ "`dio87c -- xti -S_ day1 tsk4 | grep Iterations`" != "Iterations_66" ]; then
	echo "Incorrect value for 'iteration' property"; exit 1
fi
if [ "`dio87c -- xti -S_ day1 tsk4 | grep Interval`" != "Interval_55" ]; then
	echo "Incorrect value for 'interval' property"; exit 1
fi
if [ "`dio87c -- xti -S_ day1 tsk4 | grep From`" != "From_end" ]; then
	echo "Incorrect value for 'from' property"; exit 1
fi

# verify tasks conditions
echo " verify tasks conditions"
if [ "`dio87c -- xtcc day1 tsk5`" != 7 ]; then
	echo "Can't find 7 tasks dependencies in tsk5 of day1 !"; exit 1
fi
if [ "`dio87c -- xtcl -S_ day1 tsk5 | grep \"hmin_08:05_+0\" | wc -l`" -ne "1" ] ; then
	echo "Can't find 'hmin' condition in tsk5 of day1"; exit 1
fi
if [ "`dio87c -- xtcl -S_ day1 tsk5 | grep \"hmax_09:05_+0\" | wc -l`" -ne "1" ] ; then
	echo "Can't find 'hmax' condition in tsk5 of day1"; exit 1
fi
if [ "`dio87c -- xtcl -S_ day1 tsk5 | grep \"hlate_10:05_+0\" | wc -l`" -ne "1" ] ; then
	echo "Can't find 'hlate' condition in tsk5 of day1"; exit 1
fi
if [ "`dio87c -- xtcl -S_ day1 tsk5 | grep \"file_/tmp/top\" | wc -l`" -ne "1" ] ; then
	echo "Can't find 'file' condition in tsk5 of day1"; exit 1
fi
if [ "`dio87c -- xtcl -S_ day1 tsk5 | grep \"manual_OK\" | wc -l`" -ne "1" ] ; then
	echo "Can't find 'manual' condition in tsk5 of day1"; exit 1
fi
if [ "`dio87c -- xtcl -S_ day1 tsk5 | grep \"if_equal_vr1_YES\" | wc -l`" -ne "1" ] ; then
	echo "Can't find 'if_equal' condition in tsk5 of day1"; exit 1
fi
if [ "`dio87c -- xtcl -S_ day1 tsk5 | grep \"if_not_equal_vr2_NO\" | wc -l`" -ne "1" ] ; then
	echo "Can't find 'if_not_equal' condition in tsk5 of day1"; exit 1
fi

if [ "`dio87c -- xtcl -S_ day1 tsk4 | grep \"hmin_06:05_+1\" | wc -l`" -ne "1" ] ; then
	echo "Can't find 'hmin' condition in tsk6 of day1"; exit 1
fi
if [ "`dio87c -- xtcl -S_ day1 tsk4 | grep \"hmax_07:05_+1\" | wc -l`" -ne "1" ] ; then
	echo "Can't find 'hmax' condition in tsk6 of day1"; exit 1
fi
if [ "`dio87c -- xtcl -S_ day1 tsk4 | grep \"hlate_08:05_+1\" | wc -l`" -ne "1" ] ; then
	echo "Can't find 'hlate' condition in tsk6 of day1"; exit 1
fi



# verify condition state
if [ "`dio87c -- xtcl day1 tsk5 -sS_ | grep \"hmin_08:05_+0_finished\" | wc -l `" -ne "1" ] ; then
	echo "First task conditions is not finished"; exit 1
fi
if [ "`dio87c -- xtcl day1 tsk5 -sS_ | grep \"hmax_09:05_+0_waiting\" | wc -l `" -ne "1" ] ; then
	echo "Second task conditions is not finished"; exit 1
fi

# verify tasks dependencies
echo " verify tasks dependencies"
if [ "`dio87c -- xtdc day1`" != 3 ]; then
	echo "Can't find 3 tasks dependencies in day1 !"; exit 1
fi
if [ "`dio87c -- xtdl -tS_ day1 | grep tsk1_tsk2_always | wc -l`" -ne "1" ] ; then
	echo "Can't find 'always' dependence in day1"; exit 1
fi
if [ "`dio87c -- xtdl -tS_ day1 | grep tsk1_tsk3_onerror| wc -l`" -ne "1" ] ; then
	echo "Can't find 'onerror' dependence in day1"; exit 1
fi
if [ "`dio87c -- xtdl -tS_ day1 | grep tsk2_tsk4_onsuccess | wc -l`" -ne "1" ] ; then
	echo "Can't find 'onsuccess' dependence in day1"; exit 1
fi
if [ "`dio87c -- xtdc day2`" != 1 ]; then
	echo "Can't find 1 tasks dependencies in day2 !"; exit 1
fi
if [ "`dio87c -- xtdl -tS_ day2 | grep tsk6_tsk7_always | wc -l`" -ne "1" ] ; then
	echo "Can't find 'always' dependence in day2"; exit 1
fi

# verify dependence state
if [ "`dio87c -- xtdl -sS_ day1 | grep tsk1_tsk2_validated | wc -l`" -ne "1" ] ; then
	echo "Dependence between tsk1 and tsk2 isn't validated"; exit 1
fi
if [ "`dio87c -- xtdl -sS_ day1 | grep tsk1_tsk3_canceled | wc -l`" -ne "1" ] ; then
	echo "Dependence between tsk1 and tsk3 isn't canceled"; exit 1
fi

# verify jobs 
echo " verify jobs"
if [ "`dio87c -- xjc day1 tsk1`" != 5 ]; then
	echo "Can't find 5 jobs in tsk1 of day1 !"; exit 1
fi
for f in job1 job2 job3 job4 job5 ; do
	if [ "`dio87c -- xjl day1 tsk1 | grep $f`" != "$f" ] ; then
		echo "Can't find job '$f' in tsk1 of day1 !"; exit 1
	fi
done
if [ "`dio87c -- xjc day1 tsk2`" != 2 ]; then
	echo "Can't find 2 jobs in tsk2 of day1 !"; exit 1
fi
for f in job6 job7 ; do
	if [ "`dio87c -- xjl day1 tsk2 | grep $f`" != "$f" ] ; then
		echo "Can't find job '$f' in tsk2 of day1 !"; exit 1
	fi
done
# verify job properties
if [ "`dio87c -- xji -S! day1 tsk1 job1 | grep Description`" != "Description!job1" ] ; then
	echo "Incorrect job description !"; exit 1
fi
if [ "`dio87c -- xji -S! day1 tsk1 job1 | grep Path`" != "Path!/bin/ls" ] ; then
	echo "Incorrect job path !"; exit 1
fi
if [ "`dio87c -- xji -S! day1 tsk1 job1 | grep Argument`" != "Argument!args" ] ; then
	echo "Incorrect job argument !"; exit 1
fi
if [ "`dio87c -- xji -S! day1 tsk1 job1 | grep \"Start Tempo\"`" != "Start Tempo!33" ] ; then
	echo "Incorrect job start tempo!"; exit 1
fi
if [ "`dio87c -- xji -S! day1 tsk1 job1 | grep \"End Tempo\"`" != "End Tempo!36" ] ; then
	echo "Incorrect job start tempo!"; exit 1
fi
if [ "`dio87c -- xji -S! day1 tsk1 job1 | grep \"Wait All Dependencies\"`" != "Wait All Dependencies!true" ] ; then
	echo "Incorrect 'wait all dependencies' for job1 !"; exit 1
fi
if [ "`dio87c -- xji -S! day1 tsk1 job2 | grep \"Wait All Dependencies\"`" != "Wait All Dependencies!false" ] ; then
	echo "Incorrect 'wait all dependencies' for job2 !"; exit 1
fi
if [ "`dio87c -- xji -S! day1 tsk1 job1 | grep \"On Error Continue\"`" != "On Error Continue!true" ] ; then
	echo "Incorrect 'on error continue' for job1 !"; exit 1
fi
if [ "`dio87c -- xji -S! day1 tsk1 job2 | grep \"On Error Continue\"`" != "On Error Continue!false" ] ; then
	echo "Incorrect 'on error continue' for job2 !"; exit 1
fi

if [ "`dio87c -- xji -S_ day1 tsk1 job1 | grep State`" != "State_terminated" ] ; then
	echo "Incorrect state for job1 !"; exit 1
fi
if [ "`dio87c -- xji -S_ day1 tsk1 job2 | grep State`" != "State_aborted" ] ; then
	echo "Incorrect state for job2 !"; exit 1
fi
if [ "`dio87c -- xji -S_ day1 tsk1 job2 | grep \"Exit code_23\" | wc -l `" -ne "1" ] ; then
	echo "Incorrect exit code for job2 !"; exit 1
fi

# verify jobs dependencies
echo " verify jobs dependencies"
if [ "`dio87c -- xjdc day1 tsk1`" != 3 ]; then
	echo "Can't find 3 jobs dependencies in tsk1 of day1 !"; exit 1
fi
if [ "`dio87c -- xjdl -tS_ day1 tsk1 | grep job1_job2_always | wc -l`" -ne "1" ] ; then
	echo "Can't find 'always' dependence in tsk1 of day1"; exit 1
fi
if [ "`dio87c -- xjdl -tS_ day1 tsk1 | grep job2_job3_onsuccess | wc -l`" -ne "1" ] ; then
	echo "Can't find 'onsuccess' dependence in tsk1 of day1"; exit 1
fi
if [ "`dio87c -- xjdl -tS_ day1 tsk1 | grep job3_job4_onerror | wc -l`" -ne "1" ] ; then
	echo "Can't find 'onerror' dependence in tsk1 of day1"; exit 1
fi
if [ "`dio87c -- xjdc day1 tsk2`" != 1 ]; then
	echo "Can't find 1 jobs dependencies in tsk2 of day1 !"; exit 1
fi
if [ "`dio87c -- xjdl -tS_ day1 tsk2 | grep job6_job7_always | wc -l`" -ne "1" ] ; then
	echo "Can't find 'always' dependence in tsk2 of day1"; exit 1
fi


stopDio87d || exit 1

exit 0
