#!/bin/sh
#
# file tst37.sh 
# (test communication between dio87d and dio87d)
#
#      Diogene87
#	Copyright (C) 2003,2004,2005 - Dominique Parisot
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this software; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
# Boston, MA 02111-1307 USA
#


if [ "$srcdir" = "" ]; then srcdir="."; fi
. $srcdir/functions.sh
checkNoDaemon

echo "Test log entries"

startDio87d || exit 1

dio87c -- ra r1 || exit 1
dio87c -- rta r1 t1 || exit 1
dio87c -- rtoa r1 t1 add always || exit 1

dio87c -- rja r1 t1 j1 || exit 1
dio87c -- rjsp r1 t1 j1 "/bin/echo" || exit 1
dio87c -- rjsa r1 t1 j1 "This_is_job_1" || exit 1

dio87c -- rja r1 t1 j2 || exit 1
dio87c -- rjsp r1 t1 j2 "/bin/echo" || exit 1
dio87c -- rjsa r1 t1 j2 "This_is_job_2" || exit 1

echo " plan a new day"
dio87c -- rp r1 "$dayDate" d1 >/dev/null || exit 1
waitretry 9 "dio87c -- xtl d1 -sS_" "t1_terminated"
if [ $? -ne 0 ]; then
	echo "Task t1 is not terminated !"; exit 1
fi

waitMessageSending

echo " check log entries"
# test day entries
if [ "`dio87c -- ldl | grep d1 | wc -l`" -eq 0 ] ; then
	echo "Can't find the log day 'd1' !"; exit 1
fi
if [ "`dio87c -- ldel d1 | grep Creation | wc -l`" -eq 0 ] ; then
	echo "Can't find the 'Creation' log entry !"; exit 1
fi
# test tasks entries
if [ "`dio87c -- ltl d1 | grep t1 | wc -l`" -eq 0 ] ; then
	echo "Can't find the task entry 't1' !"; exit 1
fi
if [ "`dio87c -- ltel d1 t1 | grep running | wc -l`" -eq 0 ] ; then
	echo "Can't find 'running' entry for task 't1' in dio87d"; exit 1
fi
if [ "`dio87c -- ltel d1 t1 | grep terminated | wc -l`" -eq 0 ] ; then
	echo "Can't find 'terminated' entry for task 't1' in dio87d"; exit 1
fi
# test jobs entries
if [ "`dio87c -- ljl d1 t1 | grep j1 | wc -l`" -eq 0 ] ; then
	echo "Can't find the job entry 'j1' !"; exit 1
fi
if [ "`dio87c -- ljl d1 t1 | grep j2 | wc -l`" -eq 0 ] ; then
	echo "Can't find the job entry 'j2'"; exit 1
fi
# job 1
waitretry 2 "dio87c -- ljel -S_ d1 t1 j1 | grep \"info_Path:/bin/echo\" | wc -l | awk '{print \$1}'" 1
if [ $? -ne 0 ] ; then
	echo "Can't find the 'path' entry for job 'j1' !"; exit 1
fi
waitretry 2 "dio87c -- ljel -S_ d1 t1 j1 | grep \"info_Arguments:This_is_job_1\" | wc -l | awk '{print \$1}'" 1
if [ $? -ne 0 ] ; then
	echo "Can't find the 'argument' entry for job 'j1' !"; exit 1
fi
waitretry 2 "dio87c -- ljel -S_ d1 t1 j1 | grep \"info_Hostname:\" | wc -l | awk '{print \$1}'" 1
if [ $? -ne 0 ] ; then
	echo "Can't find the 'hostname' entry for job 'j1' !"; exit 1
fi
if [ "`dio87c -- ljel d1 t1 j1 | grep running | wc -l`" -eq 0 ] ; then
	echo "Can't find the 'running' entry for job 'j1' !"; exit 1
fi
if [ "`dio87c -- ljel d1 t1 j1 | grep terminated | wc -l`" -eq 0 ] ; then
	echo "Can't find the 'terminated' entry for job 'j1' !"; exit 1
fi
if [ "`dio87c -- ljel -o d1 t1 j1 | grep This_is_job_1 | wc -l`" -eq 0 ] ; then
	echo "Can't find the 'output' entry for job 'j1' !"; exit 1
fi
# job 2
waitretry 2 "dio87c -- ljel -S_ d1 t1 j2 | grep \"info_Path:/bin/echo\" | wc -l | awk '{print \$1}'" 1
if [ $? -ne 0 ] ; then
	echo "Can't find the 'path' entry for job 'j2' !"; exit 1
fi
waitretry 2 "dio87c -- ljel -S_ d1 t1 j2 | grep \"info_Arguments:This_is_job_2\" | wc -l | awk '{print \$1}'" 1
if [ $? -ne 0 ] ; then
	echo "Can't find the 'argument' entry for job 'j2' !"; exit 1
fi
waitretry 2 "dio87c -- ljel -S_ d1 t1 j2 | grep \"info_Hostname:\" | wc -l | awk '{print \$1}'" 1
if [ $? -ne 0 ] ; then
	echo "Can't find the 'hostname' entry for job 'j2' !"; exit 1
fi

if [ "`dio87c -- ljel d1 t1 j2 | grep running | wc -l`" -eq 0 ] ; then
	echo "Can't find the 'running' entry for job 'j2' !"; exit 1
fi
if [ "`dio87c -- ljel d1 t1 j2 | grep terminated | wc -l`" -eq 0 ] ; then
	echo "Can't find the 'terminated' entry for job 'j2' !"; exit 1
fi
if [ "`dio87c -- ljel -o d1 t1 j2 | grep This_is_job_2 | wc -l`" -eq 0 ] ; then
	echo "Can't find the 'output' entry for job 'j2' !"; exit 1
fi

stopDio87d || exit 1

