#!/bin/sh
#
# file tst38.sh 
# (test stat commands)
#
#      Diogene87
#	Copyright (C) 2003,2004,2005 - Dominique Parisot
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this software; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
# Boston, MA 02111-1307 USA
#


if [ "$srcdir" = "" ]; then srcdir="."; fi
. $srcdir/functions.sh
checkNoDaemon

startDio87d || exit 1

mem1=`dio87c -- memory` || exit 1

# referentials commands
echo "Verifiy stat referential commands"
dio87c -- ra r1 || exit 1
dio87c -- rp r1 "$dayDate" d1 >/dev/null || exit 1
if [ "`dio87c -- src`" -ne "1" ]; then
	echo "Referential count isn't 1"; exit 1
fi
if [ "`dio87c -- srl | grep r1 `" != "r1" ]; then
	echo "Can't find a referential "; exit 1
fi
dio87c -- ra r2 || exit 1
dio87c -- rp r2 "$dayDate" d2 >/dev/null || exit 1
if [ "`dio87c -- src`" -ne "2" ]; then
	echo "Referential count isn't 2"; exit 1
fi
if [ "`dio87c -- srl | grep r2 `" != "r2" ]; then
	echo "Can't find r2 "; exit 1
fi
dio87c -- srk r2
if [ $? -ne 0 ]; then
	echo "Can't delete r2 "; exit 1
fi
if [ "`dio87c -- src`" -ne "1" ]; then
	echo "Referential count isn't 1"; exit 1
fi
if [ "`dio87c -- srl | grep r2 `" = "r2" ]; then
	echo "Can find r2 after deleting it "; exit 1
fi
dio87c -- srk r1
if [ $? -ne 0 ]; then
	echo "Can't delete r1 "; exit 1
fi
if [ "`dio87c -- src`" -ne "0" ]; then
	echo "Referential count isn't 0"; exit 1
fi

dio87c -- rk r1 || exit 1
dio87c -- rk r2 || exit 1
dio87c -- xdk d1 || exit 1
dio87c -- xdk d2 || exit 1
dio87c -- ldk d1 || exit 1
dio87c -- ldk d2 || exit 1

waitMessageSending
mem2=`dio87c -- memory` || exit 1
if [ $mem1 != $mem2 ] ; then
	echo "dio87d : memory error $mem1 -> $mem2"
	exit 1
fi


# tasks commands
mem1=`dio87c -- memory` || exit 1
echo "Verifiy stat task commands"

dio87c -- ra r1 || exit 1
dio87c -- rta r1 task1 || exit 1
dio87c -- rtoa r1 task1 add always || exit 1
dio87c -- rp r1 "$dayDate" d1 >/dev/null || exit 1
dio87c -- xdk d1 || exit 1
dio87c -- ldk d1 || exit 1
if [ "`dio87c -- stc r1`" -ne "1" ]; then
	echo "Task count isn't 1"; exit 1
fi
if [ "`dio87c -- stl r1 | grep task1`" != "task1" ]; then
	echo "Can't find a task "; exit 1
fi

dio87c -- rta r1 task2 || exit 1
dio87c -- rtoa r1 task2 add always || exit 1
dio87c -- rp r1 "$dayDate" d1 >/dev/null || exit 1
dio87c -- xdk d1 || exit 1
dio87c -- ldk d1 || exit 1
if [ "`dio87c -- stc r1`" -ne "2" ]; then
	echo "Task count isn't 2"; exit 1
fi
if [ "`dio87c -- stl r1 | grep task2 `" != "task2" ]; then
	echo "Can't find task2 "; exit 1
fi
if [ "`dio87c -- stl r1 | grep task1 `" != "task1" ]; then
	echo "Can't find task1 "; exit 1
fi

dio87c -- rk r1 || exit 1
dio87c -- srk r1 || exit 1

waitMessageSending
mem2=`dio87c -- memory` || exit 1
if [ $mem1 != $mem2 ] ; then
	echo "dio87d : memory error $mem1 -> $mem2"
	exit 1
fi


# jobs commands
mem1=`dio87c -- memory` || exit 1
echo "Verifiy stat job commands"

dio87c -- ra r1 || exit 1
dio87c -- rta r1 task1 || exit 1
dio87c -- rtoa r1 task1 add always || exit 1
dio87c -- rja r1 task1 job1 || exit 1
dio87c -- rp r1 "$dayDate" d1 >/dev/null || exit 1
dio87c -- xdk d1 || exit 1
dio87c -- ldk d1 || exit 1

if [ "`dio87c -- sjc r1 task1`" -ne "1" ]; then
	echo "Job count isn't 1"; exit 1
fi
if [ "`dio87c -- sjl r1 task1 | grep job1`" != "job1" ]; then
	echo "Can't find a job "; exit 1
fi

dio87c -- rja r1 task1 job2 || exit 1
dio87c -- rp r1 "$dayDate" d1 >/dev/null || exit 1
dio87c -- xdk d1 || exit 1
dio87c -- ldk d1 || exit 1

if [ "`dio87c -- sjc r1 task1`" -ne "2" ]; then
	echo "Job count isn't 2"; exit 1
fi
if [ "`dio87c -- sjl r1 task1 | grep job2 `" != "job2" ]; then
	echo "Can't find job2 "; exit 1
fi
if [ "`dio87c -- sjl r1 task1 | grep job1 `" != "job1" ]; then
	echo "Can't find job1 "; exit 1
fi

dio87c -- rk r1 || exit 1
dio87c -- srk r1 || exit 1
waitMessageSending

mem2=`dio87c -- memory` || exit 1
if [ $mem1 != $mem2 ] ; then
	echo "dio87d : memory error $mem1 -> $mem2"
	exit 1
fi

stopDio87d || exit 1

