#!/bin/sh
#
# file tst39.sh 
# (test rtoa and rroa with day/month names)
#
#      Diogene87
#	Copyright (C) 2003,2004,2005 - Dominique Parisot
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this software; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
# Boston, MA 02111-1307 USA
#


if [ "$srcdir" = "" ]; then srcdir="."; fi
. $srcdir/functions.sh
checkNoDaemon

echo "Test day/month names with rroa,rrol,rtoa,rtol commands"

startDio87d || exit 1
# memory 
memd1=`dio87c -- memory` || exit 1

dio87c ra ref1 || exit 1

####################################
echo " test rtoa/rtol commands"

############ rtoa/rtol with day name
#Sunday Monday Tuesday Wednesday Thursday Friday Saturday

# check day_of_week 1
dio87c rta ref1 tsk1 || exit 1
dio87c rtoa ref1 tsk1 add day_of_week Monday || exit 1
if [ "`dio87c -- rtol -S_ ref1 tsk1`" != "add_day_of_week_1" ] ; then
	echo "Can't find add_day_of_week_1 in the operation list !"; exit 1
fi
if [ "`dio87c -- rtol -hS_ ref1 tsk1`" != "add_day_of_week_Monday" ] ; then
	echo "Can't find add_day_of_week_Monday in the operation list !"; exit 1
fi
dio87c rtk ref1 tsk1 || exit 1

# check day_of_week 7
dio87c rta ref1 tsk1 || exit 1
dio87c rtoa ref1 tsk1 add day_of_week Sunday || exit 1
if [ "`dio87c -- rtol -S_ ref1 tsk1`" != "add_day_of_week_7" ] ; then
	echo "Can't find add_day_of_week_7 in the operation list !"; exit 1
fi
if [ "`dio87c -- rtol -hS_ ref1 tsk1`" != "add_day_of_week_Sunday" ] ; then
	echo "Can't find add_day_of_week_Sunday in the operation list !"; exit 1
fi
dio87c rtk ref1 tsk1 || exit 1

# check day name control
dio87c rta ref1 tsk1 || exit 1
dio87c rtoa ref1 tsk1 add day_of_week bad_day_name >/dev/null 2>&1
if [ $? -eq 0 ]; then
	echo "Incorrect day name was not detected !"; exit 1
fi
dio87c rtk ref1 tsk1 || exit 1

############ rtoa/rtol with month name
#January Febuary March April May June July August September October November December

# check month_of_year 1
dio87c rta ref1 tsk1 || exit 1
dio87c rtoa ref1 tsk1 add month_of_year January || exit 1
if [ "`dio87c -- rtol -S_ ref1 tsk1`" != "add_month_of_year_1" ] ; then
	echo "Can't find add_month_of_year_1 in the operation list !"; exit 1
fi
if [ "`dio87c -- rtol -hS_ ref1 tsk1`" != "add_month_of_year_January" ] ; then
	echo "Can't find add_month_of_year_January in the operation list !"; exit 1
fi
dio87c rtk ref1 tsk1 || exit 1

# check month_of_year 12
dio87c rta ref1 tsk1 || exit 1
dio87c rtoa ref1 tsk1 add month_of_year December || exit 1
if [ "`dio87c -- rtol -S_ ref1 tsk1`" != "add_month_of_year_12" ] ; then
	echo "Can't find add_month_of_year_12 in the operation list !"; exit 1
fi
if [ "`dio87c -- rtol -hS_ ref1 tsk1`" != "add_month_of_year_December" ] ; then
	echo "Can't find add_month_of_year_December in the operation list !"; exit 1
fi
dio87c rtk ref1 tsk1 || exit 1

# check month name control
dio87c rta ref1 tsk1 || exit 1
dio87c rtoa ref1 tsk1 add month_of_year bad_month_name >/dev/null 2>&1
if [ $? -eq 0 ]; then
	echo "Incorrect month name was not detected !"; exit 1
fi
dio87c rtk ref1 tsk1 || exit 1

####################################
echo " test rroa/rrol commands"

############ rroa/rrol with day name
#Sunday Monday Tuesday Wednesday Thursday Friday Saturday

# check day_of_week 1
dio87c rra ref1 rul1 || exit 1
dio87c rroa ref1 rul1 add day_of_week Monday || exit 1
if [ "`dio87c -- rrol -S_ ref1 rul1`" != "add_day_of_week_1" ] ; then
	echo "Can't find add_day_of_week_1 in the operation list !"; exit 1
fi
if [ "`dio87c -- rrol -hS_ ref1 rul1`" != "add_day_of_week_Monday" ] ; then
	echo "Can't find add_day_of_week_Monday in the operation list !"; exit 1
fi
dio87c rrk ref1 rul1 || exit 1

# check day_of_week 7
dio87c rra ref1 rul1 || exit 1
dio87c rroa ref1 rul1 add day_of_week Sunday || exit 1
if [ "`dio87c -- rrol -S_ ref1 rul1`" != "add_day_of_week_7" ] ; then
	echo "Can't find add_day_of_week_7 in the operation list !"; exit 1
fi
if [ "`dio87c -- rrol -hS_ ref1 rul1`" != "add_day_of_week_Sunday" ] ; then
	echo "Can't find add_day_of_week_Sunday in the operation list !"; exit 1
fi
dio87c rrk ref1 rul1 || exit 1

# check day name control
dio87c rra ref1 rul1 || exit 1
dio87c rroa ref1 rul1 add day_of_week bad_day_name >/dev/null 2>&1
if [ $? -eq 0 ]; then
	echo "Incorrect day name was not detected !"; exit 1
fi
dio87c rrk ref1 rul1 || exit 1

############ rroa/rrol with month name
#January Febuary March April May June July August September October November December

# check month_of_year 1
dio87c rra ref1 rul1 || exit 1
dio87c rroa ref1 rul1 add month_of_year January || exit 1
if [ "`dio87c -- rrol -S_ ref1 rul1`" != "add_month_of_year_1" ] ; then
	echo "Can't find add_month_of_year_1 in the operation list !"; exit 1
fi
if [ "`dio87c -- rrol -hS_ ref1 rul1`" != "add_month_of_year_January" ] ; then
	echo "Can't find add_month_of_year_January in the operation list !"; exit 1
fi
dio87c rrk ref1 rul1 || exit 1

# check month_of_year 12
dio87c rra ref1 rul1 || exit 1
dio87c rroa ref1 rul1 add month_of_year December || exit 1
if [ "`dio87c -- rrol -S_ ref1 rul1`" != "add_month_of_year_12" ] ; then
	echo "Can't find add_month_of_year_12 in the operation list !"; exit 1
fi
if [ "`dio87c -- rrol -hS_ ref1 rul1`" != "add_month_of_year_December" ] ; then
	echo "Can't find add_month_of_year_December in the operation list !"; exit 1
fi
dio87c rrk ref1 rul1 || exit 1

# check month name control
dio87c rra ref1 rul1 || exit 1
dio87c rroa ref1 rul1 add month_of_year bad_month_name >/dev/null 2>&1
if [ $? -eq 0 ]; then
	echo "Incorrect month name was not detected !"; exit 1
fi
dio87c rrk ref1 rul1 || exit 1




dio87c rk ref1 || exit 1

# verify memory
memd2=`dio87c -- memory` || exit 1
if [ $memd1 != $memd2 ] ; then
	echo "dio87d : memory error $memd1 -> $memd2"; exit 1
fi

stopDio87d || exit 1

exit 0


