#!/bin/sh
#
# file tst40.sh 
# (test rename commands in dio87d)
#
#      Diogene87
#	Copyright (C) 2003,2004,2005 - Dominique Parisot
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this software; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
# Boston, MA 02111-1307 USA
#


if [ "$srcdir" = "" ]; then srcdir="."; fi
. $srcdir/functions.sh
checkNoDaemon

echo "Test rename commands in dio87d"

startDio87d || exit 1

memd1=`dio87c -- memory` || exit 1

#### check rsn command
echo " check 'rsn' command"
dio87c -- ra r1 || exit 1
dio87c -- ra r2 || exit 1
dio87c -- ra r3 || exit 1
dio87c -- ra r4 || exit 1
# rename r3 -> ref3
if [ "`dio87c -- rc`" != "4" ]; then
	echo "Can't find 4 referentials"; exit 1
fi
if [ "`dio87c -- rl | grep r3`" != "r3" ] ; then
	echo "Can't find referential r3"; exit 1
fi
dio87c -- rsn r3 ref3 || exit 1
if [ "`dio87c -- rc`" != "4" ]; then
	echo "Can't find 4 referentials"; exit 1
fi
if [ "`dio87c -- rl | grep ref3`" != "ref3" ] ; then
	echo "Can't find referential ref3"; exit 1
fi
# rename r2 with an existing name
dio87c -- rsn r2 ref3 > /dev/null 2>&1
if [ $? -eq 0 ]; then
	echo "rsn command doesn't return an error when renaming with existing name" ; exit 1
fi
if [ "`dio87c -- rc`" != "4" ]; then
	echo "Can't find 4 referentials"; exit 1
fi
if [ "`dio87c -- rl | grep ref3`" != "ref3" ] ; then
	echo "Can't find referential ref3"; exit 1
fi
if [ "`dio87c -- rl | grep r2`" != "r2" ] ; then
	echo "Can't find referential r2"; exit 1
fi
# rename r2 -> ref2
if [ "`dio87c -- rc`" != "4" ]; then
	echo "Can't find 4 referentials"; exit 1
fi
if [ "`dio87c -- rl | grep r2`" != "r2" ] ; then
	echo "Can't find task r2"; exit 1
fi
dio87c -- rsn r2 ref2 || exit 1
if [ "`dio87c -- rc`" != "4" ]; then
	echo "Can't find 4 referentials"; exit 1
fi
if [ "`dio87c -- rl | grep ref2`" != "ref2" ] ; then
	echo "Can't find referential ref2"; exit 1
fi
if [ "`dio87c -- rl | grep r1`" != "r1" ] ; then
	echo "Can't find referential r1"; exit 1
fi
if [ "`dio87c -- rl | grep r4`" != "r4" ] ; then
	echo "Can't find referential r4"; exit 1
fi
dio87c -- rk ref2 || exit 1
dio87c -- rk ref3 || exit 1
dio87c -- rk r1 || exit 1
dio87c -- rk r4 || exit 1


#### check rtsn command
echo " check 'rtsn' command"
dio87c -- ra ref1 || exit 1
dio87c -- rta ref1 t1 || exit 1
dio87c -- rta ref1 t2 || exit 1
dio87c -- rta ref1 t3 || exit 1
dio87c -- rta ref1 t4 || exit 1
# rename t3 -> task3
if [ "`dio87c -- rtc ref1`" != "4" ]; then
	echo "Can't find 4 tasks"; exit 1
fi
if [ "`dio87c -- rtl ref1 | grep t3`" != "t3" ] ; then
	echo "Can't find task t3"; exit 1
fi
dio87c -- rtsn ref1 t3 task3 || exit 1
if [ "`dio87c -- rtc ref1`" != "4" ]; then
	echo "Can't find 4 tasks"; exit 1
fi
if [ "`dio87c -- rtl ref1 | grep task3`" != "task3" ] ; then
	echo "Can't find task task3"; exit 1
fi
# rename t2 with an existing name
dio87c -- rtsn ref1 t2 task3 > /dev/null 2>&1
if [ $? -eq 0 ]; then
	echo "rtsn command doesn't return an error when renaming with existing name" ; exit 1
fi
if [ "`dio87c -- rtc ref1`" != "4" ]; then
	echo "Can't find 4 tasks"; exit 1
fi
if [ "`dio87c -- rtl ref1 | grep task3`" != "task3" ] ; then
	echo "Can't find task task3"; exit 1
fi
if [ "`dio87c -- rtl ref1 | grep t2`" != "t2" ] ; then
	echo "Can't find task t2"; exit 1
fi
# rename t2 -> task2
if [ "`dio87c -- rtc ref1`" != "4" ]; then
	echo "Can't find 4 tasks"; exit 1
fi
if [ "`dio87c -- rtl ref1 | grep t2`" != "t2" ] ; then
	echo "Can't find task t2"; exit 1
fi
dio87c -- rtsn ref1 t2 task2 || exit 1
if [ "`dio87c -- rtc ref1`" != "4" ]; then
	echo "Can't find 4 tasks"; exit 1
fi
if [ "`dio87c -- rtl ref1 | grep task2`" != "task2" ] ; then
	echo "Can't find task task2"; exit 1
fi
if [ "`dio87c -- rtl ref1 | grep t1`" != "t1" ] ; then
	echo "Can't find task t1"; exit 1
fi
if [ "`dio87c -- rtl ref1 | grep t4`" != "t4" ] ; then
	echo "Can't find task t4"; exit 1
fi
dio87c -- rk ref1 || exit 1

#### check rjsn command
echo " check 'rjsn' command"
dio87c -- ra ref1 || exit 1
dio87c -- rta ref1 t1 || exit 1
dio87c -- rja ref1 t1 j1 || exit 1
dio87c -- rja ref1 t1 j2 || exit 1
dio87c -- rja ref1 t1 j3 || exit 1
dio87c -- rja ref1 t1 j4 || exit 1
# rename j3 -> job3
if [ "`dio87c -- rjc ref1 t1`" != "4" ]; then
	echo "Can't find 4 jobs"; exit 1
fi
if [ "`dio87c -- rjl ref1 t1 | grep j3`" != "j3" ] ; then
	echo "Can't find job j3"; exit 1
fi
dio87c -- rjsn ref1 t1 j3 job3 || exit 1
if [ "`dio87c -- rjc ref1 t1`" != "4" ]; then
	echo "Can't find 4 jobs"; exit 1
fi
if [ "`dio87c -- rjl ref1 t1 | grep job3`" != "job3" ] ; then
	echo "Can't find job job3"; exit 1
fi
# rename j2 with an existing name
dio87c -- rjsn ref1 t1 j2 job3 > /dev/null 2>&1
if [ $? -eq 0 ]; then
	echo "rjsn command doesn't return an error when renaming with existing name" ; exit 1
fi
if [ "`dio87c -- rjc ref1 t1`" != "4" ]; then
	echo "Can't find 4 jobs"; exit 1
fi
if [ "`dio87c -- rjl ref1 t1 | grep job3`" != "job3" ] ; then
	echo "Can't find job job3"; exit 1
fi
if [ "`dio87c -- rjl ref1 t1 | grep j2`" != "j2" ] ; then
	echo "Can't find job j2"; exit 1
fi
# rename j2 -> job2
if [ "`dio87c -- rjc ref1 t1`" != "4" ]; then
	echo "Can't find 4 jobs"; exit 1
fi
if [ "`dio87c -- rjl ref1 t1 | grep j2`" != "j2" ] ; then
	echo "Can't find job j2"; exit 1
fi
dio87c -- rjsn ref1 t1 j2 job2 || exit 1
if [ "`dio87c -- rjc ref1 t1`" != "4" ]; then
	echo "Can't find 4 jobs"; exit 1
fi
if [ "`dio87c -- rjl ref1 t1 | grep job2`" != "job2" ] ; then
	echo "Can't find job job2"; exit 1
fi
if [ "`dio87c -- rjl ref1 t1 | grep j1`" != "j1" ] ; then
	echo "Can't find job j1"; exit 1
fi
if [ "`dio87c -- rjl ref1 t1 | grep j4`" != "j4" ] ; then
	echo "Can't find job j4"; exit 1
fi
dio87c -- rk ref1 || exit 1

#### check rrsn command
echo " check 'rrsn' command"
dio87c -- ra ref1 || exit 1
dio87c -- rra ref1 r1 || exit 1
dio87c -- rra ref1 r2 || exit 1
dio87c -- rra ref1 r3 || exit 1
dio87c -- rra ref1 r4 || exit 1
# rename r3 -> rule3
if [ "`dio87c -- rrc ref1`" != "4" ]; then
	echo "Can't find 4 rules"; exit 1
fi
if [ "`dio87c -- rrl ref1 | grep r3`" != "r3" ] ; then
	echo "Can't find rule r3"; exit 1
fi
dio87c -- rrsn ref1 r3 rule3 || exit 1
if [ "`dio87c -- rrc ref1`" != "4" ]; then
	echo "Can't find 4 rules"; exit 1
fi
if [ "`dio87c -- rrl ref1 | grep rule3`" != "rule3" ] ; then
	echo "Can't find rule rule3"; exit 1
fi
# rename r2 with an existing name
dio87c -- rrsn ref1 r2 rule3 > /dev/null 2>&1
if [ $? -eq 0 ]; then
	echo "rrsn command doesn't return an error when renaming with existing name" ; exit 1
fi
if [ "`dio87c -- rrc ref1`" != "4" ]; then
	echo "Can't find 4 rules"; exit 1
fi
if [ "`dio87c -- rrl ref1 | grep rule3`" != "rule3" ] ; then
	echo "Can't find rule rule3"; exit 1
fi
if [ "`dio87c -- rrl ref1 | grep r2`" != "r2" ] ; then
	echo "Can't find rule r2"; exit 1
fi
# rename r2 -> rule2
if [ "`dio87c -- rrc ref1`" != "4" ]; then
	echo "Can't find 4 rules"; exit 1
fi
if [ "`dio87c -- rrl ref1 | grep r2`" != "r2" ] ; then
	echo "Can't find rule r2"; exit 1
fi
dio87c -- rrsn ref1 r2 rule2 || exit 1
if [ "`dio87c -- rrc ref1`" != "4" ]; then
	echo "Can't find 4 rules"; exit 1
fi
if [ "`dio87c -- rrl ref1 | grep rule2`" != "rule2" ] ; then
	echo "Can't find rule rule2"; exit 1
fi
if [ "`dio87c -- rrl ref1 | grep r1`" != "r1" ] ; then
	echo "Can't find rule r1"; exit 1
fi
if [ "`dio87c -- rrl ref1 | grep r4`" != "r4" ] ; then
	echo "Can't find rule r4"; exit 1
fi
dio87c -- rk ref1 || exit 1

# verify memory
memd2=`dio87c -- memory` || exit 1
if [ $memd1 != $memd2 ] ; then
	echo "dio87d : memory error $memd1 -> $memd2"; exit 1
fi


stopDio87d || exit 1

