#!/bin/sh
#
# file tst44.sh 
# (test deltaDay in hmin, hmax and hlate conditions)
#
#      Diogene87
#	Copyright (C) 2003,2004,2005 - Dominique Parisot
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this software; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
# Boston, MA 02111-1307 USA
#


if [ "$srcdir" = "" ]; then srcdir="."; fi
. $srcdir/functions.sh
checkNoDaemon

echo "test 'deltaDay' in hmin, hmax and hlate conditions "

startDio87d || exit 1

dio87c -- ra r1 || exit 1
dio87c -- rta r1 t1 || exit 1
dio87c -- rtoa r1 t1 add always || exit 1
dio87c -- rtca r1 t1 hmin "00:00" +0 || exit 1
if [ "`dio87c -- rtcl -S_ r1 t1`" != "hmin_00:00_+0" ] ; then
	echo "Can't find condition of task t1"; exit 1
fi

dio87c -- rta r1 t2 || exit 1
dio87c -- rtoa r1 t2 add always || exit 1
dio87c -- rtca r1 t2 hmin "00:00" +1 || exit 1
if [ "`dio87c -- rtcl -S_ r1 t2`" != "hmin_00:00_+1" ] ; then
	echo "Can't find condition of task t2"; exit 1
fi


dio87c -- rp -d r1 "$dayDate" d1 >/dev/null || exit 1
sleep 1
if [ "`dio87c -- xtcl -S_ d1 t1`" != "hmin_00:00_+0" ] ; then
	echo "Can't find condition of task t1 in day d1"; exit 1
fi
if [ "`dio87c -- xtcl -S_ d1 t2`" != "hmin_00:00_+1" ] ; then
	echo "Can't find condition of task t2 in day d1"; exit 1
fi

dio87c -- xdse d1 true || exit 1
sleep 2

if [ "`dio87c -- xtcl -sS_ d1 t1`" != "hmin_00:00_+0_finished" ] ; then
	echo "Can't find condition of task t1 in day d1"; exit 1
fi
if [ "`dio87c -- xtcl -sS_ d1 t2`" != "hmin_00:00_+1_waiting" ] ; then
	echo "Can't find condition of task t2 in day d1"; exit 1
fi

dio87c -- rk r1 || exit 1

stopDio87d || exit 1

