#!/bin/sh
#
# file tst47.sh 
# (test autoplan property)
#
#      Diogene87
#	Copyright (C) 2003,2004,2005 - Dominique Parisot
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this software; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
# Boston, MA 02111-1307 USA
#


if [ "$srcdir" = "" ]; then srcdir="."; fi
. $srcdir/functions.sh
checkNoDaemon

echo "Test the autoplanned and autopurged properties"

############################## check the rsa command
startDio87d || exit 1

dio87c -- ra r1 || exit 1
dio87c -- ra r2 || exit 1
dio87c -- ra r3 || exit 1
dio87c -- ra r4 || exit 1

memd1=`dio87c -- memory` || exit 1

echo " check the 'rsa' command"
# check default value of 'auto planned' and 'auto purged' properties
if [ "`dio87c -- ri -S_ r1 | grep \"Auto Planned\"`" != "Auto Planned_false" ] ; then
	echo "By default, the 'auto planned' property is not false"; exit 1
fi
if [ "`dio87c -- ri -S_ r1 | grep \"Auto Purged\"`" != "Auto Purged_false" ] ; then
	echo "By default, the 'auto purged' property is not false"; exit 1
fi

# change the 'auto planned' property
dio87c -- rsa r2 true false || exit 1
if [ "`dio87c -- ri -S_ r2 | grep \"Auto Planned\"`" != "Auto Planned_true" ] ; then
	echo "The 'auto planned' property is not true"; exit 1
fi
if [ "`dio87c -- ri -S_ r2 | grep \"Auto Purged\"`" != "Auto Purged_false" ] ; then
	echo "The 'auto purged' property is not false"; exit 1
fi

# change the 'auto purged' property
dio87c -- rsa r3 false true || exit 1
if [ "`dio87c -- ri -S_ r3 | grep \"Auto Planned\"`" != "Auto Planned_false" ] ; then
	echo "The 'auto planned' property is not false"; exit 1
fi
if [ "`dio87c -- ri -S_ r3 | grep \"Auto Purged\"`" != "Auto Purged_true" ] ; then
	echo "The 'auto purged' property is not true"; exit 1
fi

# change the 'auto planned' and 'auto purged' properties
dio87c -- rsa r4 true true || exit 1
if [ "`dio87c -- ri -S_ r4 | grep \"Auto Planned\"`" != "Auto Planned_true" ] ; then
	echo "The 'auto planned' property is not true"; exit 1
fi
if [ "`dio87c -- ri -S_ r4 | grep \"Auto Purged\"`" != "Auto Purged_true" ] ; then
	echo "The 'auto purged' property is not true"; exit 1
fi

# verify memory
memd2=`dio87c -- memory` || exit 1
if [ $memd1 != $memd2 ] ; then
	echo "dio87d : memory error $memd1 -> $memd2"
	exit 1
fi

restartDio87d || exit 1

memd1=`dio87c -- memory` || exit 1

echo " check the values of 'auto planned' and 'auto purged' properties"

# check default value of 'auto planned' and 'auto purged' properties
if [ "`dio87c -- ri -S_ r1 | grep \"Auto Planned\"`" != "Auto Planned_false" ] ; then
	echo "By default, the 'auto planned' property is not false"; exit 1
fi
if [ "`dio87c -- ri -S_ r1 | grep \"Auto Purged\"`" != "Auto Purged_false" ] ; then
	echo "By default, the 'auto purged' property is not false"; exit 1
fi

# change the 'auto planned' property
if [ "`dio87c -- ri -S_ r2 | grep \"Auto Planned\"`" != "Auto Planned_true" ] ; then
	echo "The 'auto planned' property is not true"; exit 1
fi
if [ "`dio87c -- ri -S_ r2 | grep \"Auto Purged\"`" != "Auto Purged_false" ] ; then
	echo "The 'auto purged' property is not false"; exit 1
fi

# change the 'auto purged' property
if [ "`dio87c -- ri -S_ r3 | grep \"Auto Planned\"`" != "Auto Planned_false" ] ; then
	echo "The 'auto planned' property is not false"; exit 1
fi
if [ "`dio87c -- ri -S_ r3 | grep \"Auto Purged\"`" != "Auto Purged_true" ] ; then
	echo "The 'auto purged' property is not true"; exit 1
fi

# change the 'auto planned' and 'auto purged' properties
if [ "`dio87c -- ri -S_ r4 | grep \"Auto Planned\"`" != "Auto Planned_true" ] ; then
	echo "The 'auto planned' property is not true"; exit 1
fi
if [ "`dio87c -- ri -S_ r4 | grep \"Auto Purged\"`" != "Auto Purged_true" ] ; then
	echo "The 'auto purged' property is not true"; exit 1
fi

# verify memory
memd2=`dio87c -- memory` || exit 1
if [ $memd1 != $memd2 ] ; then
	echo "dio87d : memory error $memd1 -> $memd2"
	exit 1
fi

dio87c -- rk r1 || exit 1
dio87c -- rk r2 || exit 1
dio87c -- rk r3 || exit 1
dio87c -- rk r4 || exit 1

stopDio87d || exit 1

##################################"
echo " check the 'xdsa' command"

startDio87d || exit 1

dio87c -- ra r1 || exit 1
dio87c -- ra r2 || exit 1
dio87c -- rp -d r1 "2004-01-05" d1 >/dev/null || exit 1
dio87c -- rp -d r2 "2004-01-05" d2 >/dev/null || exit 1

memx1=`dio87c -- memory` || exit 1

# check the default value
if [ "`dio87c -- xdi -S_ d1 | grep \"Auto Purged\"`" != "Auto Purged_false" ] ; then
	echo "By default, the 'auto purged' property is not false"; exit 1
fi

# change the value of the autopurged property
dio87c -- xdsa d2 true || exit 1
if [ "`dio87c -- xdi -S_ d2 | grep \"Auto Purged\"`" != "Auto Purged_true" ] ; then
	echo "The 'auto purged' property is not true"; exit 1
fi


# verify memory
memx2=`dio87c -- memory` || exit 1
if [ $memx1 != $memx2 ] ; then
	echo "dio87d : memory error $memx1 -> $memx2"
	exit 1
fi

echo "restart dio87d"
restartDio87d || exit 1

memx1=`dio87c -- memory` || exit 1

echo " check the value of the 'auto purged' property"
if [ "`dio87c -- xdi -S_ d1 | grep \"Auto Purged\"`" != "Auto Purged_false" ] ; then
	echo "The 'auto purged' property of d1 is not false"; exit 1
fi
if [ "`dio87c -- xdi -S_ d2 | grep \"Auto Purged\"`" != "Auto Purged_true" ] ; then
	echo "The 'auto purged' property of d2 is not true"; exit 1
fi

# verify memory
waitMessageSending
memx2=`dio87c -- memory` || exit 1
if [ $memx1 != $memx2 ] ; then
	echo "dio87d : memory error $memx1 -> $memx2"
	exit 1
fi

dio87c -- rk r1 || exit 1
dio87c -- rk r2 || exit 1
dio87c -- xdk d1 || exit 1
dio87c -- xdk d2 || exit 1
dio87c -- ldk d1 || exit 1
dio87c -- ldk d2 || exit 1
dio87c -- srk r1 || exit 1
dio87c -- srk r2 || exit 1

stopDio87d || exit 1

########################### check the day creation process
echo "Check the day creation process"

startDio87d || exit 1
memd1=`dio87c -- memory` || exit 1

dio87c -- ra r1 || exit 1
dio87c -- rsa r1 false false || exit 1
dio87c -- ra r2 || exit 1
dio87c -- rsa r2 false true || exit 1

dio87c -- rp r1 "$dayDate" d1 >/dev/null || exit 1
dio87c -- rp r2 "$dayDate" d2 >/dev/null || exit 1

echo " check the value of the 'auto purged' property"
if [ "`dio87c -- xdi -S_ d1 | grep \"Auto Purged\"`" != "Auto Purged_false" ] ; then
	echo "The 'auto purged' property of d1 is not false"; exit 1
fi
if [ "`dio87c -- xdi -S_ d2 | grep \"Auto Purged\"`" != "Auto Purged_true" ] ; then
	echo "The 'auto purged' property of d2 is not true"; exit 1
fi

dio87c -- rk r1 || exit 1
dio87c -- rk r2 || exit 1
dio87c -- srk r1 || exit 1
dio87c -- srk r2 || exit 1

dio87c -- ldk d1 || exit 1
dio87c -- ldk d2 || exit 1
dio87c -- xdk d1 || exit 1
dio87c -- xdk d2 || exit 1

waitMessageSending
memd2=`dio87c -- memory` || exit 1
if [ $memd1 != $memd2 ] ; then
	echo "dio87d : memory error $memd1 -> $memd2"
	exit 1
fi

stopDio87d || exit 1
