#!/bin/sh
#
# file tst48.sh 
# (test the 'rp' command)
#
#      Diogene87
#	Copyright (C) 2003,2004,2005 - Dominique Parisot
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this software; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
# Boston, MA 02111-1307 USA
#


if [ "$srcdir" = "" ]; then srcdir="."; fi
. $srcdir/functions.sh
checkNoDaemon

echo "Test the 'rp' command"

########################### 
echo "Check the date argument format"

startDio87d || exit 1

memd1=`dio87c -- memory` || exit 1

echo " check the date argument format"

dio87c -- ra ref1 || exit 1

dio87c -- rp ref1 "2005-01-05" > /dev/null || exit 1
dio87c -- rp ref1 "2005-01-06 12" > /dev/null || exit 1
dio87c -- rp ref1 "2005-01-07 13:27" > /dev/null || exit 1
dio87c -- rp ref1 "2005-01-08 13:29:40" > /dev/null || exit 1

if [ "`dio87c -- xdc`" -ne "4" ] ; then
	echo "Can't find 4 days"; exit 1
fi

if [ "`dio87c -- xdi -S_ ref1_20050105 | grep \"Start Time\"`" != "Start Time_2005-01-05 00:00:00" ] ; then
	echo "The start time of ref1_20050105 is not correct !"; exit 1
fi

if [ "`dio87c -- xdi -S_ ref1_20050106 | grep \"Start Time\"`" != "Start Time_2005-01-06 12:00:00" ] ; then
	echo "The start time of ref1_20050106 is not correct !"; exit 1
fi

if [ "`dio87c -- xdi -S_ ref1_20050107 | grep \"Start Time\"`" != "Start Time_2005-01-07 13:27:00" ] ; then
	echo "The start time of ref1_20050107 is not correct !"; exit 1
fi

if [ "`dio87c -- xdi -S_ ref1_20050108 | grep \"Start Time\"`" != "Start Time_2005-01-08 13:29:40" ] ; then
	echo "The start time of ref1_20050107 is not correct !"; exit 1
fi

dio87c -- rk ref1 || exit 1
dio87c -- srk ref1 || exit 1

for d in `dio87c -- xdl` ; do
	dio87c -- xdk $d || exit 1
	dio87c -- ldk $d || exit 1
done

waitMessageSending
memd2=`dio87c -- memory` || exit 1
if [ $memd1 != $memd2 ] ; then
	echo "dio87d : memory error $memd1 -> $memd2"
	exit 1
fi

stopDio87d || exit 1
