#!/bin/sh
#
# file tst50.sh 
# (test the xjsa and xjsp commands)
#
#      Diogene87
#	Copyright (C) 2003,2004,2005 - Dominique Parisot
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this software; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
# Boston, MA 02111-1307 USA
#


if [ "$srcdir" = "" ]; then srcdir="."; fi
. $srcdir/functions.sh
checkNoDaemon

echo "Test the xjsa and xjsp commands" 

########################### 

startDio87d || exit 1

memx1=`dio87c -- memory` || exit 1

echo " create job"
dio87c -- ra r1 || exit 1
dio87c -- rta r1 t1 || exit 1
dio87c -- rtoa r1 t1 add always || exit 1
dio87c -- rja r1 t1 j1 || exit 1
dio87c -- rjsp r1 t1 j1 "cmd" || exit 1
dio87c -- rjsa r1 t1 j1 "arg" || exit 1
dio87c -- rp -d r1 "$dayDate" d1 >/dev/null || exit 1


if [ "`dio87c -- xji -S_ d1 t1 j1 | grep Path`" != "Path_cmd" ]; then
	echo "Path is not 'cmd' !"; exit 1
fi
if [ "`dio87c -- xji -S_ d1 t1 j1 | grep Argument`" != "Argument_arg" ]; then
	echo "Argument is not 'arg' !"; exit 1
fi

echo " change path and argument"
dio87c -- xjsp d1 t1 j1 "/bin/sleep"
if [ $? -ne 0 ]; then
	echo "Can't change the path"; exit 1
fi
dio87c -- xjsa d1 t1 j1 "60"
if [ $? -ne 0 ]; then
	echo "Can't change the argument"; exit 1
fi
echo " check values"
if [ "`dio87c -- xji -S_ d1 t1 j1 | grep Path`" != "Path_/bin/sleep" ]; then
	echo "Path was not changed !"; exit 1
fi
if [ "`dio87c -- xji -S_ d1 t1 j1 | grep Argument`" != "Argument_60" ]; then
	echo "Argument was not changed !"; exit 1
fi

dio87c -- xdk d1 || exit 1
dio87c -- ldk d1 || exit 1
dio87c -- rk r1 || exit 1
dio87c -- srk r1 || exit 1

waitMessageSending
memx2=`dio87c -- memory` || exit 1
if [ $memx1 != $memx2 ] ; then
	echo "dio87d : memory error $memx1 -> $memx2"
	exit 1
fi

stopDio87d || exit 1
