#!/bin/sh
#
# file tst51.sh 
# (test the auto purge process)
#
#      Diogene87
#	Copyright (C) 2003,2004,2005 - Dominique Parisot
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this software; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
# Boston, MA 02111-1307 USA
#


if [ "$srcdir" = "" ]; then srcdir="."; fi
. $srcdir/functions.sh
checkNoDaemon

echo "Test the auto purge process" 

startDio87d || exit 1

memd1=`dio87c -- memory` || exit 1

dio87c -- ra ref1 || exit 1
if [ "`dio87c -- ri -S_ ref1 | grep \"Auto Purged\"`" != "Auto Purged_false" ] ; then
	echo "The value of AutoPurged of ref1 is not 'false' !"; exit 1
fi
dio87c -- rp ref1 "2005-01-01" d1 >/dev/null || exit 1
dio87c -- rp ref1 "$dayDate" d2 >/dev/null || exit 1

echo " create two days with autopurged to false"
if [ "`dio87c -- xdc`" != "2" ]; then
	echo "Day count is not 2 !"; exit 1
fi
if [ "`dio87c -- xdi -S_ d1 | grep \"Auto Purged\"`" != "Auto Purged_false" ] ; then
	echo "The value of AutoPurged of d1 is not 'false' !"; exit 1
fi
if [ "`dio87c -- xdi -S_ d2 | grep \"Auto Purged\"`" != "Auto Purged_false" ] ; then
	echo "The value of AutoPurged of d2 is not 'false' !"; exit 1
fi

echo " start the day purge process"
dio87c -- xdk || exit 1
if [ "`dio87c -- xdc`" != "2" ]; then
	echo "Day count is not 2 !"; exit 1
fi

echo " set the autopurged properties to true"
dio87c -- xdsa d1 true || exit 1
if [ "`dio87c -- xdi -S_ d1 | grep \"Auto Purged\"`" != "Auto Purged_true" ] ; then
	echo "The value of AutoPurged of d1 is not 'true' !"; exit 1
fi
dio87c -- xdsa d2 true || exit 1
if [ "`dio87c -- xdi -S_ d2 | grep \"Auto Purged\"`" != "Auto Purged_true" ] ; then
	echo "The value of AutoPurged of d2 is not 'true' !"; exit 1
fi

echo " start the day purge process"
dio87c -- xdk || exit 1
if [ "`dio87c -- xdc`" != "1" ]; then
	echo "Day count is not 1 !"; exit 1
fi
if [ "`dio87c -- xdl | grep d2`" != "d2" ]; then
	echo "Can't find the day d2 !"; exit 1
fi
if [ "`dio87c -- xdl | grep d1`" == "d1" ]; then
	echo "The day d1 should be deleted !"; exit 1
fi

dio87c -- xdk d2 || true
dio87c -- ldk d2 || true

echo " set the autopurged property of the referential to true"
dio87c -- rsa ref1 true true || exit 1
if [ "`dio87c -- ri -S_ ref1 | grep \"Auto Purged\"`" != "Auto Purged_true" ] ; then
	echo "The value of AutoPurged of ref1 is not 'true' !"; exit 1
fi

echo " create a new day"
dio87c -- rp ref1 "$dayDate" d2 >/dev/null || exit 1

echo " check the autopurged property of the new day"
if [ "`dio87c -- xdi -S_ d2 | grep \"Auto Purged\"`" != "Auto Purged_true" ] ; then
	echo "The value of AutoPurged of d2 is not 'true' !"; exit 1
fi

dio87c -- xdk d2 || exit 1
dio87c -- ldk d2 || exit 1
dio87c -- rk ref1 || exit 1
dio87c -- srk ref1 || exit 1
dio87c -- ldk d1 || exit 1

waitMessageSending

memd2=`dio87c -- memory` || exit 1
if [ $memd1 != $memd2 ] ; then
	echo "dio87d : memory error $memd1 -> $memd2"
	exit 1
fi

stopDio87d || exit 1
