#!/bin/sh
#
# file tst52.sh 
# (test argument controls)
#
#      Diogene87
#	Copyright (C) 2003,2004,2005 - Dominique Parisot
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this software; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
# Boston, MA 02111-1307 USA
#


if [ "$srcdir" = "" ]; then srcdir="."; fi
. $srcdir/functions.sh
checkNoDaemon

echo "Test argument controls" 

startDio87d || exit 1

#### ra
echo " check referential commands"
dio87c -- ra "abAZ09-_"
if [ $? -ne 0 ]; then
	echo "The 'ra' function fails with legal characters !"; exit 1
fi
dio87c -- ra "ref@" > /dev/null
if [ $? -eq 0 ]; then
	echo "The 'ra' function accepts illegal characters !"; exit 1
fi
dio87c -- ra "" > /dev/null
if [ $? -eq 0 ]; then
	echo "The 'ra' function accepts an empty string !"; exit 1
fi
dio87c -- ra "aaaaaaaaabbbbbbbbbbcccccc"
if [ $? -ne 0 ]; then
	echo "The 'ra' function fails with a long name !"; exit 1
fi
dio87c -- ra "aaaaaaaaabbbbbbbbbbccccccE" > /dev/null
if [ $? -eq 0 ]; then
	echo "The 'ra' function accepts a too long name !"; exit 1
fi
if [ "`dio87c -- rc`" -ne 2 ]; then
	echo "There is not two referential !"; exit 1
fi
dio87c -- rk "abAZ09-_" || exit 1
dio87c -- rk "aaaaaaaaabbbbbbbbbbcccccc" || exit 1

### rsn
dio87c -- ra r1 || exit 1
dio87c -- rsn r1 "abAZ09-_"
if [ $? -ne 0 ]; then
	echo "The 'rsn' function fails with legal characters !"; exit 1
fi
dio87c -- rsn "abAZ09-_" r1 || exit 1
dio87c -- rsn r1 "ref@" > /dev/null
if [ $? -eq 0 ]; then
	echo "The 'rsn' function accepts illegal characters !"; exit 1
fi
dio87c -- rsn r1 "" > /dev/null
if [ $? -eq 0 ]; then
	echo "The 'rsn' function accepts an empty string !"; exit 1
fi
dio87c -- rsn r1 "aaaaaaaaabbbbbbbbbbccccccE" > /dev/null
if [ $? -eq 0 ]; then
	echo "The 'rsn' function accepts a too long name !"; exit 1
fi
dio87c -- rk r1 || exit 1

echo " check referential task commands"

#### rta
dio87c -- ra r1 || exit 1
dio87c -- rta r1 "abAZ09-_"
if [ $? -ne 0 ]; then
	echo "The 'rta' function fails with legal characters !"; exit 1
fi
dio87c -- rta r1 "ref@" > /dev/null
if [ $? -eq 0 ]; then
	echo "The 'rta' function accepts illegal characters !"; exit 1
fi
dio87c -- rta r1 "" > /dev/null
if [ $? -eq 0 ]; then
	echo "The 'rta' function accepts an empty string !"; exit 1
fi
dio87c -- rta r1 "aaaaaaaaabbbbbb"
if [ $? -ne 0 ]; then
	echo "The 'rta' function fails with a long name !"; exit 1
fi
dio87c -- rta r1 "aaaaaaaaabbbbbbE" >/dev/null
if [ $? -eq 0 ]; then
	echo "The 'rta' function accepts a too long name !"; exit 1
fi
if [ "`dio87c -- rtc r1`" -ne 2 ]; then
	echo "There is not two tasks !"; exit 1
fi
dio87c -- rtk r1 "abAZ09-_" || exit 1
dio87c -- rtk r1 "aaaaaaaaabbbbbb" || exit 1
dio87c -- rk r1 || exit 1

### rtsn
dio87c -- ra r1 || exit 1
dio87c -- rta r1 t1 || exit 1
dio87c -- rtsn r1 t1 "abAZ09-_"
if [ $? -ne 0 ]; then
	echo "The 'rtsn' function fails with legal characters !"; exit 1
fi
dio87c -- rtsn r1 "abAZ09-_" t1 || exit 1
dio87c -- rtsn r1 t1 "ref@" > /dev/null
if [ $? -eq 0 ]; then
	echo "The 'rtsn' function accepts illegal characters !"; exit 1
fi
dio87c -- rtsn r1 t1 "" > /dev/null
if [ $? -eq 0 ]; then
	echo "The 'rtsn' function accepts an empty string !"; exit 1
fi
dio87c -- rtsn r1 t1 "aaaaaaaaabbbbbbbbbbccccccE" > /dev/null
if [ $? -eq 0 ]; then
	echo "The 'rsn' function accepts a too long name !"; exit 1
fi
dio87c -- rtk r1 t1 || exit 1
dio87c -- rk r1 || exit 1

### rtsd
dio87c -- ra r1 || exit 1
dio87c -- rta r1 t1 || exit 1

dio87c -- rtsd r1 t1 "azAZ09-_ " 
if [ $? -ne 0 ]; then
	echo "The 'rtsd' function fails with legal characters !"; exit 1
fi
dio87c -- rtsd r1 t1 "" 
if [ $? -ne 0 ]; then
	echo "The 'rtsd' function fails with an empty string !"; exit 1
fi
dio87c -- rtsd r1 t1 "aaaaaaaaabbbbbbbbbbccccccccccdddddddddde" 
if [ $? -ne 0 ]; then
	echo "The 'rtsd' function fails with a long description !"; exit 1
fi
dio87c -- rtsd r1 t1 "aaaaaaaaabbbbbbbbbbccccccccccddddddddddeE" > /dev/null
if [ $? -eq 0 ]; then
	echo "The 'rtsd' function accepts a too long description !"; exit 1
fi
dio87c -- rtk r1 t1 || exit 1
dio87c -- rk r1 || exit 1

echo " check referential job commands"

#### rja
dio87c -- ra r1 || exit 1
dio87c -- rta r1 t1 || exit 1
dio87c -- rja r1 t1 "abAZ09-_"
if [ $? -ne 0 ]; then
	echo "The 'rja' function fails with legal characters !"; exit 1
fi
dio87c -- rja r1 t1 "job@" > /dev/null
if [ $? -eq 0 ]; then
	echo "The 'rja' function accepts illegal characters !"; exit 1
fi
dio87c -- rja r1 t1 "" > /dev/null
if [ $? -eq 0 ]; then
	echo "The 'rja' function accepts an empty string !"; exit 1
fi
dio87c -- rja r1 t1 "aaaaaaaaab"
if [ $? -ne 0 ]; then
	echo "The 'rja' function fails with a long name !"; exit 1
fi
dio87c -- rja r1 t1 "aaaaaaaaabE" >/dev/null
if [ $? -eq 0 ]; then
	echo "The 'rja' function accepts a too long name !"; exit 1
fi
if [ "`dio87c -- rjc r1 t1`" -ne 2 ]; then
	echo "There is not two jobs !"; exit 1
fi
dio87c -- rjk r1 t1 "abAZ09-_" || exit 1
dio87c -- rjk r1 t1 "aaaaaaaaab" || exit 1
dio87c -- rtk r1 t1 || exit 1
dio87c -- rk r1 || exit 1

### rjsn
dio87c -- ra r1 || exit 1
dio87c -- rta r1 t1 || exit 1
dio87c -- rja r1 t1 j1 || exit 1
dio87c -- rjsn r1 t1 j1 "abAZ09-_"
if [ $? -ne 0 ]; then
	echo "The 'rjsn' function fails with legal characters !"; exit 1
fi
dio87c -- rjsn r1 t1 "abAZ09-_" j1 || exit 1
dio87c -- rjsn r1 t1 j1 "ref@" > /dev/null
if [ $? -eq 0 ]; then
	echo "The 'rjsn' function accepts illegal characters !"; exit 1
fi
dio87c -- rjsn r1 t1 j1 "" > /dev/null
if [ $? -eq 0 ]; then
	echo "The 'rjsn' function accepts an empty string !"; exit 1
fi
dio87c -- rjsn r1 t1 j1 "aaaaaaaaabbbbbbbbbbccccccE" > /dev/null
if [ $? -eq 0 ]; then
	echo "The 'rjn' function accepts a too long name !"; exit 1
fi
dio87c -- rjk r1 t1 j1 || exit 1
dio87c -- rtk r1 t1 || exit 1
dio87c -- rk r1 || exit 1

### rjsd
dio87c -- ra r1 || exit 1
dio87c -- rta r1 t1 || exit 1
dio87c -- rja r1 t1 j1 || exit 1

dio87c -- rjsd r1 t1 j1 "azAZ09-_ " 
if [ $? -ne 0 ]; then
	echo "The 'rjsd' function fails with legal characters !"; exit 1
fi
dio87c -- rjsd r1 t1 j1 "" 
if [ $? -ne 0 ]; then
	echo "The 'rjsd' function fails with an empty string !"; exit 1
fi
dio87c -- rjsd r1 t1 j1 "aaaaaaaaabbbbbbbbbbccccccccccdddddddddde" 
if [ $? -ne 0 ]; then
	echo "The 'rjsd' function fails with a long description !"; exit 1
fi
dio87c -- rjsd r1 t1 j1 "aaaaaaaaabbbbbbbbbbccccccccccddddddddddeE" > /dev/null
if [ $? -eq 0 ]; then
	echo "The 'rjsd' function accepts a too long description !"; exit 1
fi
dio87c -- rjk r1 t1 j1 || exit 1
dio87c -- rtk r1 t1 || exit 1
dio87c -- rk r1 || exit 1

echo " check referential rules commands"

#### rra
dio87c -- ra r1 || exit 1
dio87c -- rra r1 "abAZ09-_"
if [ $? -ne 0 ]; then
	echo "The 'rra' function fails with legal characters !"; exit 1
fi
dio87c -- rra r1 "rul@" > /dev/null
if [ $? -eq 0 ]; then
	echo "The 'rra' function accepts illegal characters !"; exit 1
fi
dio87c -- rra r1 "" > /dev/null
if [ $? -eq 0 ]; then
	echo "The 'rra' function accepts an empty string !"; exit 1
fi
dio87c -- rra r1 "aaaaaaaaabbbbbbbbbbccccccccccdddddddddde"
if [ $? -ne 0 ]; then
	echo "The 'rra' function fails with a long name !"; exit 1
fi
dio87c -- rra r1 "aaaaaaaaabbbbbbbbbbccccccccccddddddddddeE" >/dev/null
if [ $? -eq 0 ]; then
	echo "The 'rra' function accepts a too long name !"; exit 1
fi
if [ "`dio87c -- rrc r1`" -ne 2 ]; then
	echo "There is not two rules !"; exit 1
fi
dio87c -- rrk r1 "abAZ09-_" || exit 1
dio87c -- rrk r1 "aaaaaaaaabbbbbbbbbbccccccccccdddddddddde" || exit 1
dio87c -- rk r1 || exit 1

### rrsn
dio87c -- ra r1 || exit 1
dio87c -- rra r1 t1 || exit 1
dio87c -- rrsn r1 t1 "abAZ09-_"
if [ $? -ne 0 ]; then
	echo "The 'rrsn' function fails with legal characters !"; exit 1
fi
dio87c -- rrsn r1 "abAZ09-_" t1 || exit 1
dio87c -- rrsn r1 t1 "rul@" > /dev/null
if [ $? -eq 0 ]; then
	echo "The 'rrsn' function accepts illegal characters !"; exit 1
fi
dio87c -- rrsn r1 t1 "" > /dev/null
if [ $? -eq 0 ]; then
	echo "The 'rrsn' function accepts an empty string !"; exit 1
fi
dio87c -- rrsn r1 t1 "aaaaaaaaabbbbbbbbbbccccccccccddddddddddeE" > /dev/null
if [ $? -eq 0 ]; then
	echo "The 'rrsn' function accepts a too long name !"; exit 1
fi
dio87c -- rrk r1 t1 || exit 1
dio87c -- rk r1 || exit 1

echo " check target commands "

#### ta
dio87c -- ta "abAZ09-_"
if [ $? -ne 0 ]; then
	echo "The 'ta' function fails with legal characters !"; exit 1
fi
dio87c -- ta "tar@" > /dev/null
if [ $? -eq 0 ]; then
	echo "The 'ta' function accepts illegal characters !"; exit 1
fi
dio87c -- ta "" > /dev/null
if [ $? -eq 0 ]; then
	echo "The 'ta' function accepts an empty string !"; exit 1
fi
dio87c -- ta "aaaaaaaaabbbbbbbbbbccccccccccddddddddddeeeeeeeeeeffffffffffg"
if [ $? -ne 0 ]; then
	echo "The 'ta' function fails with a long name !"; exit 1
fi
dio87c -- ta "aaaaaaaaabbbbbbbbbbccccccccccddddddddddeeeeeeeeeeffffffffffgE">/dev/null
if [ $? -eq 0 ]; then
	echo "The 'ta' function accepts a too long name !"; exit 1
fi
if [ "`dio87c -- tc`" -ne 3 ]; then
	echo "There is not 3 targets !"; exit 1
fi
dio87c -- tk "abAZ09-_" || exit 1
dio87c -- tk "aaaaaaaaabbbbbbbbbbccccccccccddddddddddeeeeeeeeeeffffffffffg" || exit 1

### tsd
dio87c -- ta t1 || exit 1

dio87c -- tsd t1 "azAZ09-_ " 
if [ $? -ne 0 ]; then
	echo "The 'tsd' function fails with legal characters !"; exit 1
fi
dio87c -- tsd t1 "" 
if [ $? -ne 0 ]; then
	echo "The 'tsd' function fails with an empty string !"; exit 1
fi
dio87c -- tsd t1 "aaaaaaaaabbbbbbbbbbccccccccccddddddddddeeeeeeeeeeffffffffffg" 
if [ $? -ne 0 ]; then
	echo "The 'tsd' function fails with a long description !"; exit 1
fi
dio87c -- tsd t1 "aaaaaaaaabbbbbbbbbbccccccccccddddddddddeeeeeeeeeeffffffffffgE" > /dev/null
if [ $? -eq 0 ]; then
	echo "The 'tsd' function accepts a too long description !"; exit 1
fi
dio87c -- tk t1 || exit 1

echo " check queue commands "

#### qa
dio87c -- ta t1 || exit 1
dio87c -- qa t1 "abAZ09-_"
if [ $? -ne 0 ]; then
	echo "The 'qa' function fails with legal characters !"; exit 1
fi
dio87c -- qa t1 "tar@" > /dev/null
if [ $? -eq 0 ]; then
	echo "The 'qa' function accepts illegal characters !"; exit 1
fi
dio87c -- qa t1 "" > /dev/null
if [ $? -eq 0 ]; then
	echo "The 'qa' function accepts an empty string !"; exit 1
fi
dio87c -- qa t1 "aaaaaaaaabbbbbb"
if [ $? -ne 0 ]; then
	echo "The 'qa' function fails with a long name !"; exit 1
fi
dio87c -- qa t1 "aaaaaaaaabbbbbbE">/dev/null
if [ $? -eq 0 ]; then
	echo "The 'qa' function accepts a too long name !"; exit 1
fi
if [ "`dio87c -- qc t1`" -ne 3 ]; then
	echo "There is not 3 targets !"; exit 1
fi
dio87c -- qk t1 "abAZ09-_" || exit 1
dio87c -- qk t1 "aaaaaaaaabbbbbb" || exit 1
dio87c -- tk t1 || exit 1

### qsd
dio87c -- ta t1 || exit 1
dio87c -- qa t1 q1 || exit 1

dio87c -- qsd t1 q1 "azAZ09-_ " 
if [ $? -ne 0 ]; then
	echo "The 'qsd' function fails with legal characters !"; exit 1
fi
dio87c -- qsd t1 q1 "" 
if [ $? -ne 0 ]; then
	echo "The 'qsd' function fails with an empty string !"; exit 1
fi
dio87c -- qsd t1 q1 "aaaaaaaaabbbbbbbbbbccccccccccdddddddddde" 
if [ $? -ne 0 ]; then
	echo "The 'qsd' function fails with a long description !"; exit 1
fi
dio87c -- qsd t1 q1 "aaaaaaaaabbbbbbbbbbccccccccccddddddddddeE" > /dev/null
if [ $? -eq 0 ]; then
	echo "The 'qsd' function accepts a too long description !"; exit 1
fi
dio87c -- qk t1 q1 || exit 1
dio87c -- tk t1 || exit 1


echo " check variable commands "

#### va
dio87c -- va "abAZ09-_"
if [ $? -ne 0 ]; then
	echo "The 'va' function fails with legal characters !"; exit 1
fi
dio87c -- va "var@" > /dev/null
if [ $? -eq 0 ]; then
	echo "The 'va' function accepts illegal characters !"; exit 1
fi
dio87c -- va "" > /dev/null
if [ $? -eq 0 ]; then
	echo "The 'va' function accepts an empty string !"; exit 1
fi
dio87c -- va "aaaaaaaaabbbbbbbbbbc"
if [ $? -ne 0 ]; then
	echo "The 'va' function fails with a long name !"; exit 1
fi
dio87c -- va "aaaaaaaaabbbbbbbbbbcE">/dev/null
if [ $? -eq 0 ]; then
	echo "The 'va' function accepts a too long name !"; exit 1
fi
if [ "`dio87c -- vc`" -ne 2 ]; then
	echo "There is not two variables !"; exit 1
fi
dio87c -- vk "abAZ09-_" || exit 1
dio87c -- vk "aaaaaaaaabbbbbbbbbbc" || exit 1

echo " check user commands "

#### ua
dio87c -- ua "abAZ09-_"
if [ $? -ne 0 ]; then
	echo "The 'ua' function fails with legal characters !"; exit 1
fi
dio87c -- ua "var@" > /dev/null
if [ $? -eq 0 ]; then
	echo "The 'ua' function accepts illegal characters !"; exit 1
fi
dio87c -- ua "" > /dev/null
if [ $? -eq 0 ]; then
	echo "The 'ua' function accepts an empty string !"; exit 1
fi
dio87c -- ua "aaaaaaaaabbbbbbbbbbcccccc"
if [ $? -ne 0 ]; then
	echo "The 'ua' function fails with a long name !"; exit 1
fi
dio87c -- ua "aaaaaaaaabbbbbbbbbbccccccE">/dev/null
if [ $? -eq 0 ]; then
	echo "The 'ua' function accepts a too long name !"; exit 1
fi
if [ "`dio87c -- uc`" -ne 4 ]; then
	echo "There is not four users !"; exit 1
fi
dio87c -- uk "abAZ09-_" || exit 1
dio87c -- uk "aaaaaaaaabbbbbbbbbbcccccc" || exit 1



echo " check target commands "

### tsd 
dio87c -- ta t1 || exit 1

dio87c -- tsd t1 "azAZ09-_ " 
if [ $? -ne 0 ]; then
	echo "The 'tsd' function fails with legal characters !"; exit 1
fi
dio87c -- tsd t1 "" 
if [ $? -ne 0 ]; then
	echo "The 'tsd' function fails with an empty string !"; exit 1
fi
dio87c -- tsd t1 "aaaaaaaaabbbbbbbbbbccccccccccddddddddddeeeeeeeeeeffffffffffg" 
if [ $? -ne 0 ]; then
	echo "The 'tsd' function fails with a long description !"; exit 1
fi
dio87c -- tsd t1 "aaaaaaaaabbbbbbbbbbccccccccccddddddddddeeeeeeeeeeffffffffffgE" > /dev/null
if [ $? -eq 0 ]; then
	echo "The 'tsd' function accepts a too long description !"; exit 1
fi
dio87c -- tk t1 || exit 1

#### qa
echo " check queue commands "
dio87c -- ta t1 || exit 1
dio87c -- qa t1 "abAZ09-_"
if [ $? -ne 0 ]; then
	echo "The 'qa' function fails with legal characters !"; exit 1
fi
dio87c -- qa t1 "tar@" > /dev/null
if [ $? -eq 0 ]; then
	echo "The 'qa' function accepts illegal characters !"; exit 1
fi
dio87c -- qa t1 "" > /dev/null
if [ $? -eq 0 ]; then
	echo "The 'qa' function accepts an empty string !"; exit 1
fi
dio87c -- qa t1 "aaaaaaaaabbbbbb"
if [ $? -ne 0 ]; then
	echo "The 'qa' function fails with a long name !"; exit 1
fi
dio87c -- qa t1 "aaaaaaaaabbbbbbE">/dev/null
if [ $? -eq 0 ]; then
	echo "The 'qa' function accepts a too long name !"; exit 1
fi
if [ "`dio87c -- qc t1`" -ne 3 ]; then
	echo "There is not 3 targets !"; exit 1
fi
dio87c -- qk t1 "abAZ09-_" || exit 1
dio87c -- qk t1 "aaaaaaaaabbbbbb" || exit 1
dio87c -- tk t1 || exit 1

### qsd
dio87c -- ta t1 || exit 1
dio87c -- qa t1 q1 || exit 1

dio87c -- qsd t1 q1 "azAZ09-_ " 
if [ $? -ne 0 ]; then
	echo "The 'qsd' function fails with legal characters !"; exit 1
fi
dio87c -- qsd t1 q1 "" 
if [ $? -ne 0 ]; then
	echo "The 'qsd' function fails with an empty string !"; exit 1
fi
dio87c -- qsd t1 q1 "aaaaaaaaabbbbbbbbbbccccccccccdddddddddde" 
if [ $? -ne 0 ]; then
	echo "The 'qsd' function fails with a long description !"; exit 1
fi
dio87c -- qsd t1 q1 "aaaaaaaaabbbbbbbbbbccccccccccddddddddddeE" > /dev/null
if [ $? -eq 0 ]; then
	echo "The 'qsd' function accepts a too long description !"; exit 1
fi
dio87c -- qk t1 q1 || exit 1
dio87c -- tk t1 || exit 1


echo " check variable commands "

#### va
dio87c -- va "abAZ09-_"
if [ $? -ne 0 ]; then
	echo "The 'va' function fails with legal characters !"; exit 1
fi
dio87c -- va "var@" > /dev/null
if [ $? -eq 0 ]; then
	echo "The 'va' function accepts illegal characters !"; exit 1
fi
dio87c -- va "" > /dev/null
if [ $? -eq 0 ]; then
	echo "The 'va' function accepts an empty string !"; exit 1
fi
dio87c -- va "aaaaaaaaabbbbbbbbbbc"
if [ $? -ne 0 ]; then
	echo "The 'va' function fails with a long name !"; exit 1
fi
dio87c -- va "aaaaaaaaabbbbbbbbbbcE">/dev/null
if [ $? -eq 0 ]; then
	echo "The 'va' function accepts a too long name !"; exit 1
fi
if [ "`dio87c -- vc`" -ne 2 ]; then
	echo "There is not two variables !"; exit 1
fi
dio87c -- vk "abAZ09-_" || exit 1
dio87c -- vk "aaaaaaaaabbbbbbbbbbc" || exit 1

echo " check user commands "

#### ua
dio87c -- ua "abAZ09-_"
if [ $? -ne 0 ]; then
	echo "The 'ua' function fails with legal characters !"; exit 1
fi
dio87c -- ua "var@" > /dev/null
if [ $? -eq 0 ]; then
	echo "The 'ua' function accepts illegal characters !"; exit 1
fi
dio87c -- ua "" > /dev/null
if [ $? -eq 0 ]; then
	echo "The 'ua' function accepts an empty string !"; exit 1
fi
dio87c -- ua "aaaaaaaaabbbbbbbbbbcccccc"
if [ $? -ne 0 ]; then
	echo "The 'ua' function fails with a long name !"; exit 1
fi
dio87c -- ua "aaaaaaaaabbbbbbbbbbccccccE">/dev/null
if [ $? -eq 0 ]; then
	echo "The 'ua' function accepts a too long name !"; exit 1
fi
if [ "`dio87c -- uc`" -ne 4 ]; then
	echo "There is not four users !"; exit 1
fi
dio87c -- uk "abAZ09-_" || exit 1
dio87c -- uk "aaaaaaaaabbbbbbbbbbcccccc" || exit 1

stopDio87d || exit 1
