#!/bin/sh
#
# file tst53.sh 
# (test xtswad, xtsoec, xjswad, xjsoec, xjst)
#
#      Diogene87
#	Copyright (C) 2003,2004,2005 - Dominique Parisot
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this software; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
# Boston, MA 02111-1307 USA
#


if [ "$srcdir" = "" ]; then srcdir="."; fi
. $srcdir/functions.sh
checkNoDaemon

echo "Test commands xtswad, xtsoec, xjswad, xjsoec, xjst" 

startDio87d || exit 1

dio87c ra ref1 || exit 1
dio87c rta ref1 tsk1 || exit 1
dio87c rtoa ref1 tsk1 add always || exit 1
dio87c rja ref1 tsk1 job1 || exit 1
dio87c rp ref1 "$dayDate" d1 >/dev/null || exit 1

########## xtswad
echo " test xtswad command"

dio87c xtswad d1 tsk1 true || exit 1
if [ "`dio87c -- xti -S_ d1 tsk1 | grep \"Wait All Dependencies\"`" != "Wait All Dependencies_true" ]; then
	echo "Wait All Dependencies is not true !"; exit 1
fi

dio87c xtswad d1 tsk1 false || exit 1
if [ "`dio87c -- xti -S_ d1 tsk1 | grep \"Wait All Dependencies\"`" != "Wait All Dependencies_false" ]; then
	echo "Wait All Dependencies is not false !"; exit 1
fi

dio87c xtswad d1 tsk1 incorrect_value >/dev/null
if [ $? -eq 0 ] ; then
	echo "Boolean value is not checked !"; exit 1
fi

dio87c xtswad d1 tskxxx true >/dev/null
if [ $? -eq 0 ] ; then
	echo "Task name is not checked !"; exit 1
fi

dio87c xtswad dxxx tsk1 true >/dev/null
if [ $? -eq 0 ] ; then
	echo "day name is not checked !"; exit 1
fi

########## xtsoec
echo " test xtsoec command"

dio87c xtsoec d1 tsk1 true || exit 1
if [ "`dio87c -- xti -S_ d1 tsk1 | grep \"On Error Continue\"`" != "On Error Continue_true" ]; then
	echo "On Error Continue is not true !"; exit 1
fi

dio87c xtsoec d1 tsk1 false || exit 1
if [ "`dio87c -- xti -S_ d1 tsk1 | grep \"On Error Continue\"`" != "On Error Continue_false" ]; then
	echo "On Error Continue is not false !"; exit 1
fi

dio87c xtsoec d1 tsk1 incorrect_value >/dev/null
if [ $? -eq 0 ] ; then
	echo "Boolean value is not checked !"; exit 1
fi

dio87c xtsoec d1 tskxxx true >/dev/null
if [ $? -eq 0 ] ; then
	echo "Task name is not checked !"; exit 1
fi

dio87c xtsoec dxxx tsk1 true >/dev/null
if [ $? -eq 0 ] ; then
	echo "day name is not checked !"; exit 1
fi

########## xjswad
echo " test xjswad command"

dio87c xjswad d1 tsk1 job1 true || exit 1
if [ "`dio87c -- xji -S_ d1 tsk1 job1 | grep \"Wait All Dependencies\"`" != "Wait All Dependencies_true" ]; then
	echo "Wait All Dependencies is not true !"; exit 1
fi

dio87c xjswad d1 tsk1 job1 false || exit 1
if [ "`dio87c -- xji -S_ d1 tsk1 job1 | grep \"Wait All Dependencies\"`" != "Wait All Dependencies_false" ]; then
	echo "Wait All Dependencies is not false !"; exit 1
fi

dio87c xjswad d1 tsk1 job1 incorrect_value >/dev/null
if [ $? -eq 0 ] ; then
	echo "Boolean value is not checked !"; exit 1
fi

dio87c xjswad d1 tsk1 jobxxx true >/dev/null
if [ $? -eq 0 ] ; then
	echo "Job name is not checked !"; exit 1
fi

dio87c xjswad d1 tskxxx job1 true >/dev/null
if [ $? -eq 0 ] ; then
	echo "Task name is not checked !"; exit 1
fi

dio87c xjswad dxxx tsk1 job1 true >/dev/null
if [ $? -eq 0 ] ; then
	echo "day name is not checked !"; exit 1
fi

########## xjsoec
echo " test xjsoec command"

dio87c xjsoec d1 tsk1 job1 true || exit 1
if [ "`dio87c -- xji -S_ d1 tsk1 job1 | grep \"On Error Continue\"`" != "On Error Continue_true" ]; then
	echo "On Error Continue is not true !"; exit 1
fi

dio87c xjsoec d1 tsk1 job1 false || exit 1
if [ "`dio87c -- xji -S_ d1 tsk1 job1 | grep \"On Error Continue\"`" != "On Error Continue_false" ]; then
	echo "On Error Continue is not false !"; exit 1
fi

dio87c xjsoec d1 tsk1 job1 incorrect_value >/dev/null
if [ $? -eq 0 ] ; then
	echo "Boolean value is not checked !"; exit 1
fi

dio87c xjsoec d1 tsk1 jobxxx true >/dev/null
if [ $? -eq 0 ] ; then
	echo "Job name is not checked !"; exit 1
fi

dio87c xjsoec d1 tskxxx job1 true >/dev/null
if [ $? -eq 0 ] ; then
	echo "Task name is not checked !"; exit 1
fi

dio87c xjsoec dxxx tsk1 job1 true >/dev/null
if [ $? -eq 0 ] ; then
	echo "day name is not checked !"; exit 1
fi


stopDio87d || exit 1
