#!/bin/sh
#
# file tst55.sh 
# (test the options -T,-Q,-D of ejm and etm) 
#
#      Diogene87
#	Copyright (C) 2003,2004,2005 - Dominique Parisot
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this software; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
# Boston, MA 02111-1307 USA
#


if [ "$srcdir" = "" ]; then srcdir="."; fi
. $srcdir/functions.sh
checkNoDaemon

echo "Test the options -T,-Q,-D of ejm and etm" 

startDio87d || exit 1

echo " create referential"
dio87c ta target1 || exit 1
dio87c tsh target1 localhost || exit 1
dio87c qa target1 queue1 || exit 1
dio87c qa target1 queue2 || exit 1

dio87c ta target2 || exit 1
dio87c tsh target2 localhost || exit 1
dio87c qa target2 queue1 || exit 1
dio87c qa target2 queue2 || exit 1

dio87c ra r1 || exit 1

# first task
dio87c rta r1 t1 || exit 1
dio87c rtsd r1 t1 "first" || exit 1
dio87c rtoa r1 t1 add always || exit 1
dio87c rtst r1 t1 target1 queue1 || exit 1

dio87c rja r1 t1 j1 || exit 1
dio87c rjsd r1 t1 j1 first || exit 1
dio87c rjsp r1 t1 j1 "/bin/true" || exit 1

dio87c rja r1 t1 j2 || exit 1
dio87c rjsd r1 t1 j2 second || exit 1
dio87c rjsp r1 t1 j2 "/bin/true" || exit 1

# second task
dio87c rta r1 t2 || exit 1
dio87c rtsd r1 t2 "second" || exit 1
dio87c rtoa r1 t2 add always || exit 1
dio87c rtst r1 t2 target2 queue2 || exit 1

dio87c rja r1 t2 j1 || exit 1
dio87c rjsd r1 t2 j1 first || exit 1
dio87c rjsp r1 t2 j1 "/bin/true" || exit 1

dio87c rja r1 t2 j2 || exit 1
dio87c rjsd r1 t2 j2 second || exit 1
dio87c rjsp r1 t2 j2 "/bin/true" || exit 1

# create a new day
dio87c rp r1 "$dayDate" d1 >/dev/null || exit 1

echo " wait jobs termination"
waitretry 20 "dio87c -- ejm -S_ | grep Terminated" "Terminated_4"
if [ $? -ne 0 ]; then
	echo "Jobs are not terminated !"; exit 1
fi

echo " control ejm command"

# control d1_t1_j1
if [ "`dio87c -- ejm -t -S_ -E. | grep d1_t1_j1`" != "T_d1_t1_j1_terminated." ]; then
	echo "can't find d1_t1_j1"; exit 1
fi
if [ "`dio87c -- ejm -Dt -S_ -E. | grep d1_t1_j1`" != "T_d1_t1_j1_terminated_first." ]; then
	echo "can't find d1_t1_j1 with description"; exit 1
fi
if [ "`dio87c -- ejm -Tt -S_ -E. | grep d1_t1_j1`" != "T_d1_t1_j1_terminated_target1." ]; then
	echo "can't find d1_t1_j1 with target name"; exit 1
fi
if [ "`dio87c -- ejm -Qt -S_ -E. | grep d1_t1_j1`" != "T_d1_t1_j1_terminated_target1_queue1." ]; then
	echo "can't find d1_t1_j1 with queue name"; exit 1
fi

# control d1_t1_j2
if [ "`dio87c -- ejm -t -S_ -E. | grep d1_t1_j2`" != "T_d1_t1_j2_terminated." ]; then
	echo "can't find d1_t1_j2"; exit 1
fi
if [ "`dio87c -- ejm -Dt -S_ -E. | grep d1_t1_j2`" != "T_d1_t1_j2_terminated_second." ]; then
	echo "can't find d1_t1_j2 with description"; exit 1
fi
if [ "`dio87c -- ejm -Tt -S_ -E. | grep d1_t1_j2`" != "T_d1_t1_j2_terminated_target1." ]; then
	echo "can't find d1_t1_j2 with target name"; exit 1
fi
if [ "`dio87c -- ejm -Qt -S_ -E. | grep d1_t1_j2`" != "T_d1_t1_j2_terminated_target1_queue1." ]; then
	echo "can't find d1_t1_j2 with queue name"; exit 1
fi

# control d1_t2_j1
if [ "`dio87c -- ejm -t -S_ -E. | grep d1_t2_j1`" != "T_d1_t2_j1_terminated." ]; then
	echo "can't find d1_t2_j1"; exit 1
fi
if [ "`dio87c -- ejm -Dt -S_ -E. | grep d1_t2_j1`" != "T_d1_t2_j1_terminated_first." ]; then
	echo "can't find d1_t2_j1 with description"; exit 1
fi
if [ "`dio87c -- ejm -Tt -S_ -E. | grep d1_t2_j1`" != "T_d1_t2_j1_terminated_target2." ]; then
	echo "can't find d1_t2_j1 with target name"; exit 1
fi
if [ "`dio87c -- ejm -Qt -S_ -E. | grep d1_t2_j1`" != "T_d1_t2_j1_terminated_target2_queue2." ]; then
	echo "can't find d1_t1_j1 with queue name"; exit 1
fi

# control d1_t2_j2
if [ "`dio87c -- ejm -t -S_ -E. | grep d1_t2_j2`" != "T_d1_t2_j2_terminated." ]; then
	echo "can't find d1_t2_j2"; exit 1
fi
if [ "`dio87c -- ejm -Dt -S_ -E. | grep d1_t2_j2`" != "T_d1_t2_j2_terminated_second." ]; then
	echo "can't find d1_t2_j2 with description"; exit 1
fi
if [ "`dio87c -- ejm -Tt -S_ -E. | grep d1_t2_j2`" != "T_d1_t2_j2_terminated_target2." ]; then
	echo "can't find d1_t2_j2 with target name"; exit 1
fi
if [ "`dio87c -- ejm -Qt -S_ -E. | grep d1_t2_j2`" != "T_d1_t2_j2_terminated_target2_queue2." ]; then
	echo "can't find d1_t1_j2 with queue name"; exit 1
fi


echo " control etm command"

# control d1_t1
if [ "`dio87c -- etm -t -S_ -E. | grep d1_t1`" != "T_d1_t1_terminated." ]; then
	echo "can't find d1_t1"; exit 1
fi
if [ "`dio87c -- etm -Dt -S_ -E. | grep d1_t1`" != "T_d1_t1_terminated_first." ]; then
	echo "can't find d1_t1 with description"; exit 1
fi
if [ "`dio87c -- etm -Tt -S_ -E. | grep d1_t1`" != "T_d1_t1_terminated_target1." ]; then
	echo "can't find d1_t1 with target name"; exit 1
fi
if [ "`dio87c -- etm -Qt -S_ -E. | grep d1_t1`" != "T_d1_t1_terminated_target1_queue1." ]; then
	echo "can't find d1_t1 with queue name"; exit 1
fi

# control d1_t2
if [ "`dio87c -- etm -t -S_ -E. | grep d1_t2`" != "T_d1_t2_terminated." ]; then
	echo "can't find d1_t2"; exit 1
fi
if [ "`dio87c -- etm -Dt -S_ -E. | grep d1_t2`" != "T_d1_t2_terminated_second." ]; then
	echo "can't find d1_t2 with description"; exit 1
fi
if [ "`dio87c -- etm -Tt -S_ -E. | grep d1_t2`" != "T_d1_t2_terminated_target2." ]; then
	echo "can't find d1_t2 with target name"; exit 1
fi
if [ "`dio87c -- etm -Qt -S_ -E. | grep d1_t2`" != "T_d1_t2_terminated_target2_queue2." ]; then
	echo "can't find d1_t2 with queue name"; exit 1
fi


stopDio87d || exit 1

