#!/bin/sh


if [ "$#" -ne 1 ] ; then
	echo "usage : ./buildpackage [rpm|deb|clean]"; exit 1
fi

mode=$1
if [ $mode != "rpm" -a $mode != "deb" -a $mode != "clean" ] ; then
	echo "usage : ./buildpackage [rpm|deb|clean]"; exit 1
fi

if [ ! -f "./configure" ] ; then
	./autogen.sh
fi

if [ $mode == clean ] ; then
	if which fakeroot >/dev/null 2>&1 ; then
		fakeroot ./debian/rules clean
	fi
	cd rpm && ./buildrpm.sh clean
fi
if [ $mode == deb ] ; then
	echo "Build debian modes ..."
	dpkg-buildpackage -rfakeroot || exit 1 
	echo "debian packages are in parent directory !" 
fi
if [ $mode == rpm ] ; then
	echo "Build rpm modes ..."
	(cd rpm && ./buildrpm.sh build || exit 1)
	find ./rpm -name "*.rpm" -exec mv '{}' .. ';' || exit 1
	echo "rpm packages are in parent directory !"
fi
