/* file d_cmdoperation.h */
/*
 *      dio87d (Diogene87) - a powerful job scheduling system.
 *	Copyright (C) 2003,2004,2005 - Dominique Parisot
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this software; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307 USA
 *
 */

#ifndef __DG87_CMD_REF_OPERATION_H__
#define __DG87_CMD_REF_OPERATION_H__

#include "global.h"
#include <libdg87/element.h>
#include "d_rule.h"
#include <config.h>
#include <libdg87/connection.h>

/* 
 * cmd_operation_rsy
 * This function is called by cmd_rrsy and cmd_rtsy.
 */
int cmd_operation_rsy (dg87_connection * connection,
                       dg87_list * operation_list);

/* 
 * cmd_operation_rsr
 * This function is called by cmd_rrsr and cmd_rtsr.
 */
int cmd_operation_rsr (dg87_connection * connection,
                       dg87_list * operation_list);

/*
 * cmd_operation_ra
 * This function is called by cmd_rroa and cmd_rtoa
 */
dg87_ref_rule_operation *cmd_operation_ra (dg87_connection * connection,
                                           dg87_ref_model * ref);

/*
 * cmd_operation_ol
 * This function is called by rrol and rtol
 */
int cmd_operation_ol (dg87_connection * connection,
                      dg87_list * operation_list);

#endif /*__DG87_CMD_REF_OPERATION_H__*/

/* End of file */
