/* file d_cmdtask.h */
/*
 *      dio87d (Diogene87) - a powerful job scheduling system.
 *	Copyright (C) 2003,2004,2005 - Dominique Parisot
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this software; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307 USA
 *
 */

#ifndef __DG87_CMD_REF_TASK_H__
#define __DG87_CMD_REF_TASK_H__

#include "global.h"
#include <libdg87/element.h>
#include "d_task.h"
#include "d_ref.h"
#include <config.h>
#include "d_cmdoperation.h"
#include <libdg87/connection.h>

/* commands for TASK */
int cmd_rtk (dg87_connection * connection);
int cmd_rta (dg87_connection * connection);
int cmd_rtc (dg87_connection * connection);
int cmd_rtd (dg87_connection * connection);
int cmd_rtl (dg87_connection * connection);
int cmd_rti (dg87_connection * connection);
int cmd_rtsr (dg87_connection * connection);
int cmd_rtsy (dg87_connection * connection);


/* rts : command to search tasks */
int cmd_rts (dg87_connection * connection);
/* rtsl : change the lock-variable of a task */
int cmd_rtsl (dg87_connection * connection);
/* rtsn : change the name of a task */
int cmd_rtsn (dg87_connection * connection);
/* rtst : change the target and the queue of a task */
int cmd_rtst (dg87_connection * connection);
/* rtsc : change cyclical properties of a task */
int cmd_rtsc (dg87_connection * connection);
/* rtsd : change the description of a task */
int cmd_rtsd (dg87_connection * connection);
/* rtse : change the enabled property of a task */
int cmd_rtse (dg87_connection * connection);
/* rtswad : change _wait_all_dependencies property for a task */
int cmd_rtswad (dg87_connection * connection);
/* rtsoec : change on_error_continue property for a task */
int cmd_rtsoec (dg87_connection * connection);

/* commands for TASK dep */
int cmd_rtdl (dg87_connection * connection);
int cmd_rtdc (dg87_connection * connection);
int cmd_rtda (dg87_connection * connection);
int cmd_rtdk (dg87_connection * connection);

/* commands for TASK condition */
int cmd_rtcl (dg87_connection * connection);
int cmd_rtcc (dg87_connection * connection);
int cmd_rtca (dg87_connection * connection);
int cmd_rtck (dg87_connection * connection);

/* commands for operations */
int cmd_rtok (dg87_connection * connection);
int cmd_rtoa (dg87_connection * connection);
int cmd_rtoc (dg87_connection * connection);
int cmd_rtol (dg87_connection * connection);
int cmd_rtom (dg87_connection * connection);

#endif /*__DG87_CMD_REF_TASK_H__*/

/* End of file */
