/* file global.h */
/*
 *      dio87d (Diogene87) - a powerful job scheduling system.
 *	Copyright (C) 2003,2004,2005 - Dominique Parisot
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this software; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307 USA
 *
 */

#ifndef __DG87_LIBGLOBAL_H__
#define __DG87_LIBGLOBAL_H__

#include <libdg87/dgerr.h>

/* dg87d */
struct _dg87_ref_condition;
typedef struct _dg87_ref_condition dg87_ref_condition;

struct _dg87_queue;
typedef struct _dg87_queue dg87_queue;

struct _dg87_ref_model;
typedef struct _dg87_ref_model dg87_ref_model;

struct _dg87_ref_job;
typedef struct _dg87_ref_job dg87_ref_job;

struct _dg87_ref_jobdep;
typedef struct _dg87_ref_jobdep dg87_ref_jobdep;

struct _dg87_ref_task;
typedef struct _dg87_ref_task dg87_ref_task;

struct _dg87_ref_taskdep;
typedef struct _dg87_ref_taskdep dg87_ref_taskdep;

struct _dg87_target;
typedef struct _dg87_target dg87_target;

struct _dg87_ref_rule;
typedef struct _dg87_ref_rule dg87_ref_rule;

struct _dg87_variable;
typedef struct _dg87_variable dg87_variable;

/* dg87x */
struct _dg87_exp_condition;
typedef struct _dg87_exp_condition dg87_exp_condition;


struct _dg87_exp_day;
typedef struct _dg87_exp_day dg87_exp_day;


struct _dg87_exp_job;
typedef struct _dg87_exp_job dg87_exp_job;

struct _dg87_exp_jobdep;
typedef struct _dg87_exp_jobdep dg87_exp_jobdep;

struct _dg87_exp_task;
typedef struct _dg87_exp_task dg87_exp_task;

struct _dg87_exp_taskdep;
typedef struct _dg87_exp_taskdep dg87_exp_taskdep;

/* dg87l */
struct _dg87_log_day;
typedef struct _dg87_log_day dg87_log_day;

struct _dg87_log_job;
typedef struct _dg87_log_job dg87_log_job;

struct _dg87_log_task;
typedef struct _dg87_log_task dg87_log_task;

/* dg87s */
struct _dg87_sta_ref;
typedef struct _dg87_sta_ref dg87_sta_ref;

struct _dg87_sta_job;
typedef struct _dg87_sta_job dg87_sta_job;

struct _dg87_sta_task;
typedef struct _dg87_sta_task dg87_sta_task;

/* dg87r */

struct _dg87_r_file;
typedef struct _dg87_r_file dg87_r_file;

struct _dg87_r_job;
typedef struct _dg87_r_job dg87_r_job;

/* day names */
extern const char* day_name_array[];
extern const char* month_name[];


#endif /*__DG87_LIBGLOBAL_H__*/
/* End of file */
