/* file r_file.h */
/*
 *      dio87d (Diogene87) - a powerful job scheduling system.
 *	Copyright (C) 2003,2004,2005 - Dominique Parisot
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this software; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307 USA
 *
 */

#ifndef __DG87_FILE_r_H__
#define __DG87_FILE_r_H__

#include <unistd.h>
#include <sys/types.h>
#include <sys/wait.h>

#include <config.h>
#include <libdg87/global.h>
#include <libdg87/storage.h>
#include <libdg87/strbuf.h>
#include "global.h"

struct _dg87_r_file
{
  char task_name[DG87_TASK_NAME_LENGTH + 1];
  char day_name[DG87_DAY_NAME_LENGTH + 1];
  char *path;                   /* path for the script */
  char *hostname;
  int ip_port;
};

/*
 * dg87_r_file_new 
 * create a new file and initialize the name property
 */
dg87_r_file *dg87_r_file_new (char *day_name, char *task_name,
                              char *filename, char *hostname, int ip_port);

/*
 * dg87_r_file_delete
 */
BOOL dg87_r_file_delete (dg87_r_file * file);

/*
 * dg87_r_file_check_presence
 */
BOOL dg87_r_file_check_presence (dg87_r_file * file);

/*
 * dg87_r_file_load
 */
BOOL dg87_r_file_load (dg87_r_file * file, dg87_storage * storage);

/*
 * dg87_r_file_save
 */
BOOL dg87_r_file_save (dg87_r_file * file, dg87_storage * storage);


#ifdef DEBUG
/*
 * dg87_r_file_ckeck
 */
int dg87_r_file_check (dg87_r_file * file, int (*print) (char *));
#endif /*DEBUG*/
#endif /*__DG87_FILE_r_H__*/
/* End of file */
