/* file variable.h */
/*
 *      dio87d (Diogene87) - a powerful job scheduling system.
 *	Copyright (C) 2003,2004,2005 - Dominique Parisot
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this software; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307 USA
 *
 */

#ifndef __DG87_VARIABLE_H__
#define __DG87_VARIABLE_H__

#include "global.h"
#include "target.h"

struct _dg87_variable
{
  char name[DG87_VARIABLE_NAME_LENGTH + 1];
  char *value;                  /* can't be NULL */
  int linked_rules;             /* number of operation rules wich use this variable */
  int linked_ref_conditions;
  int linked_ref_tasks;
  int linked_exp_conditions;
  int linked_exp_tasks;
};

/*
 * dg87_variable_new 
 * create a new variable and initialize the name property
 */
dg87_variable *dg87_variable_new (char *name, char *value);

/*
 * dg87_variable_delete
 */
BOOL dg87_variable_delete (dg87_variable * variable);

/*
 * dg87_variable_load
 */
BOOL dg87_variable_load (dg87_variable * variable, dg87_storage * storage);

/*
 * dg87_variable_save
 */
BOOL dg87_variable_save (dg87_variable * variable, dg87_storage * storage);

/*
 * dg87_variable_set_value
 */
BOOL dg87_variable_set_value (dg87_variable * variable, char *value);


#ifdef DEBUG
/*
 * dg87_variable_ckeck
 */
int dg87_variable_check (dg87_variable * variable, int (*print) (char *));
#endif /*DEBUG*/
#endif /*__DG87_VARIABLE_H__*/
/* End of file */
