/* file x_caller.h */
/*
 *      dio87d (Diogene87) - a powerful job scheduling system.
 *	Copyright (C) 2003,2004,2005 - Dominique Parisot
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this software; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307 USA
 *
 */


#ifndef __DG87_CALLER_x_H__
#define __DG87_CALLER_x_H__

#include "context.h"

BOOL dg87_caller__submit_job (dg87_context * context, dg87_exp_job * job);

BOOL dg87_caller__send_task_state (dg87_exp_task * task);

BOOL dg87_caller__send_job_state (dg87_exp_job * job);
BOOL dg87_caller__send_condition_state (dg87_exp_condition * condition);

BOOL dg87_caller__send_day_command (dg87_exp_day * day, char *command);
BOOL dg87_caller__send_task_command (dg87_exp_task * task, char *command);
BOOL dg87_caller__send_job_command (dg87_exp_job * job, char *command);
BOOL dg87_caller__send_stat_command (dg87_exp_day * day, char *command);

BOOL dg87_caller__create_day_entry (dg87_exp_day * day);

BOOL dg87_caller__create_task_entry (dg87_exp_task * task);
BOOL dg87_caller__create_job_entry (dg87_exp_job * job);

BOOL dg87_caller__update_task_entry (dg87_exp_task * task);
BOOL dg87_caller__update_job_entry (dg87_exp_job * job);

BOOL dg87_caller__send_file_test (dg87_exp_condition * condition);

#endif /*__DG87_CALLER_x_H__*/
/* End of file */
