/* file interpret.h */
/*
 *      libdg87 (Diogene87)
 *	Copyright (C) 2003,2004,2005 - Dominique Parisot
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this software; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307 USA
 *
 */

#ifndef __DG87_INTERPRET_H__
#define __DG87_INTERPRET_H__

#include "global.h"
#include "user.h"
#include "connection.h"
#include "stdio.h"

#define RETVAL_OK 0
#define RETVAL_SHUTDOWN -1
#define RETVAL_NOT_TERMINATED 2

/* structure for a command */
typedef struct _dg87_interpret_cmd
{
  char *name;
  int (*function) (struct _dg87_connection *);
  char *help_message;
  char *option_string;
  dg87_command_family family;
  dg87_command_privilege privilege;
}
dg87_interpret_cmd;

/* dg87_interpret object */
struct _dg87_interpret
{
  dg87_server *server;
  /* array of functions */
  dg87_interpret_cmd *cmd_array;
};

/*
 * dg87_interpret_new
 */
dg87_interpret *dg87_interpret_new (dg87_server * server,
				    dg87_interpret_cmd * cmd_array);

/*
 * dg87_interpret_delete
 */
BOOL dg87_interpret_delete (dg87_interpret * interpret);


/*
 * dg87_interpret_execute
 * this function interprete the command given in parameter
 */
int dg87_interpret_execute (dg87_interpret * interpret,
			    dg87_connection * connection);

#endif /*__DG87_INTERPRET_H__*/
/* End of file */
