/* file item.c */
/*
 *      libdg87 (Diogene87)
 *	Copyright (C) 2003,2004,2005 - Dominique Parisot
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this software; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307 USA
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include "item.h"

/**************************************************************************/
dg87_item *
dg87_item_new (void *object)
{
  dg87_item *item;
  assert (object != NULL);
  if (object == NULL)
    {
      dg87_err_set_error (DG87_ERR_NULL_PARAMETER);
      return NULL;
    }
  if ((item = dg87_malloc (sizeof (dg87_item), DG87_ITEM)) == NULL)
    {
      dg87_err_set_error (DG87_ERR_OUT_OF_MEMORY);
      return NULL;
    }
  item->object = object;
  item->prev = NULL;
  item->next = NULL;
  return item;
}

/**************************************************************************/
BOOL
dg87_item_delete (dg87_item * item)
{
  assert (item != NULL);
  if (item == NULL)
    return FALSE;
  dg87_free (item, DG87_ITEM);
  return TRUE;
}

/**************************************************************************/
dg87_item *
dg87_item_get_next (dg87_item * item)
{
  assert (item != NULL);
  if (item == NULL)
    return FALSE;
  return item->next;
}

/**************************************************************************/
dg87_item *
dg87_item_get_prev (dg87_item * item)
{
  assert (item != NULL);
  if (item == NULL)
    return FALSE;
  return item->prev;
}

/**************************************************************************/

/* End of file */
