/* file item.h */
/*
 *      libdg87 (Diogene87)
 *	Copyright (C) 2003,2004,2005 - Dominique Parisot
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this software; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307 USA
 *
 */

#ifndef __DG87_ITEM_H__
#define __DG87_ITEM_H__
#include "global.h"

typedef struct _dg87_item
{
  void *object;
  struct _dg87_item *prev;
  struct _dg87_item *next;
}
dg87_item;


/*
 *  dg87_item_new : 
 *  create a new item and return a pointer on this object.
 *  return NULL if object is NULL or if it can't allocate memory.
 */
dg87_item *dg87_item_new (void *object);

/*
 * dg87_item_delete : delete an item
 */
BOOL dg87_item_delete (dg87_item * item);


/* 
 * get_next : return the next item
 */
dg87_item *dg87_item_get_next (dg87_item * item);

/*
 * get_prev : return the previous item
 */
dg87_item *dg87_item_get_prev (dg87_item * item);

#endif /*__DG87_ITEM_H__*/
/* End of file */
