#!/bin/sh
#
# file tst49.sh 
# (test the autoplan process )
#
#      Diogene87
#	Copyright (C) 2003,2004,2005 - Dominique Parisot
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this software; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
# Boston, MA 02111-1307 USA
#

if [ "$srcdir" = "" ]; then srcdir="."; fi
. $srcdir/functions.sh
checkNoDaemon

echo "Test the autoplan process" 

startDio87d || exit 1

memd1=`dio87c -- memory` || exit 1

###############
echo " check the rp command with no referential"
waitretry 2 "dio87c -- rc" "0"
if [ $? -ne 0 ]; then
	echo "Reference count is not zero !"; exit 1
fi
waitretry 2 "dio87c -- xdc" "0"
if [ $? -ne 0 ]; then
	echo "Day count is not zero (1) !"; exit 1
fi
dio87c -- rp >/dev/null
if [ $? -ne 0 ]; then
	echo "The day creation process return an error !"; exit 1
fi
waitretry 2 "dio87c -- xdc" "0"
if [ $? -ne 0 ]; then
	echo "Day count is not zero (2) !"; exit 1
fi


###############
echo " check the rp command with no referential to plan"
dio87c -- ra r1 || exit 1
dio87c -- ra r2 || exit 1
dio87c -- ra r3 || exit 1
dio87c -- ra r4 || exit 1
waitretry 2 "dio87c -- rc" "4"
if [ $? -ne 0 ]; then
	echo "Reference count is not 4 !"; exit 1
fi
waitretry 2 "dio87c -- xdc" "0"
if [ $? -ne 0 ]; then
	echo "Day count is not zero (1) !"; exit 1
fi
dio87c -- rp >/dev/null
if [ $? -ne 0 ]; then
	echo "The day creation process return an error !"; exit 1
fi
waitretry 2 "dio87c -- xdc" "0"
if [ $? -ne 0 ]; then
	echo "Day count is not zero (2) !"; exit 1
fi



###############
echo " check the rp command with three referential to plan"
dio87c -- rsa r1 true true || exit 1
dio87c -- rsa r2 true true || exit 1
dio87c -- rsa r3 true true || exit 1
dio87c -- rsa r4 false false || exit 1

dio87c -- rp >/dev/null
if [ $? -ne 0 ]; then
	echo "Error in the day creation process."; exit 1
fi

waitretry 6 "dio87c -- xdc" "3"
if [ $? -ne 0 ]; then
	echo "Can't find 3 exploitation days."; exit 1
fi

tomorrow="`date -d '1 day' +%Y%m%d`"
starttime="`date -d '1 day' +%Y-%m-%d` 00:00:00"
for ref in r1 r2 r3 ; do
	day_name="${ref}_$tomorrow"
	waitretry 2 "dio87c -- xdl | grep $ref" "$day_name"
	if [ $? -ne 0 ]; then
		echo "Can't find the day [$day_name]"; exit 1
	fi
	waitretry 2 "dio87c -- xdi -S_ $day_name | grep \"Start Time\"" "Start Time_$starttime"
	if [ $? -ne 0 ]; then
		echo "The start time of $day_name is not correct"; exit 1
	fi
done

for day in `dio87c -- xdl` 
do
	dio87c -- xdk $day || exit 1
	dio87c -- ldk $day || exit 1
done
for ref in `dio87c -- rl` ; do
	dio87c -- rk $ref || exit 1
done
for ref in `dio87c -- srl` ; do
	dio87c -- srk $ref || exit 1
done


###############
#echo " check plan process with a day already created"
#dio87c -- ra r1 || exit 1 
#dio87c -- rsa r1 true true || exit 1
#dio87c -- ra r2 || exit 1 
#dio87c -- rsa r2 true true || exit 1
#dio87c -- ra r3 || exit 1 
#dio87c -- rsa r3 true true || exit 1
#dio87c -- ra r4 || exit 1 
#dio87c -- rsa r4 true true || exit 1
#dio87c -- rp r2 >/dev/null || exit 1
#tomorrow="`date -d '1 day' +%Y%m%d`"
#day_name="r2_$tomorrow"
#waitretry 2 "dio87c -- xdl | grep $day_name" "$day_name"
#if [ $? -ne 0 ]; then
# echo "Can't find the day [$day_name]"; exit 1
#fi
#dio87c -- rp | more
#echo $?
#exit

waitMessageSending
memd2=`dio87c -- memory` || exit 1
if [ $memd1 != $memd2 ] ; then
	echo "dio87d : memory error $memd1 -> $memd2"
	exit 1
fi

stopDio87d || exit 1
