/* file d_cmdqueue.h */
/*
 *      dio87d (Diogene87) - a powerful job scheduling system.
 *	Copyright (C) 2003,2004,2005 - Dominique Parisot
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this software; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307 USA
 *
 */

#ifndef __DG87_CMD_QUEUE_d_H__
#define __DG87_CMD_QUEUE_d_H__

#include "global.h"
#include <libdg87/element.h>
#include "queue.h"
#include "context.h"
#include <config.h>
#include "d_cmdoperation.h"
#include <libdg87/connection.h>

/* queues commands */


/* queue list */
int cmd_ql (dg87_connection * connection);
/* queue count */
int cmd_qc (dg87_connection * connection);
/* queue add */
int cmd_qa (dg87_connection * connection);
/* queue kill */
int cmd_qk (dg87_connection * connection);
/* queue information */
int cmd_qi (dg87_connection * connection);
/* queue set description */
int cmd_qsd (dg87_connection * connection);
/* queue set max */
int cmd_qsm (dg87_connection * connection);
/* queue set name */
int cmd_qsn (dg87_connection * connection);
/* queue set open */
int cmd_qso (dg87_connection * connection);


/* commands for referential tasks */

/* queue referential task list */
int cmd_qrtl (dg87_connection * connection);
/* queue referential task count */
int cmd_qrtc (dg87_connection * connection);


/* commands for exploitation tasks */

/* queue exploitation task list */
int cmd_qxtl (dg87_connection * connection);
/* queue exploitation task count */
int cmd_qxtc (dg87_connection * connection);


/* commands for exploitation jobs */

/* queue exploitation job list */
int cmd_qxjl (dg87_connection * connection);
/* queue exploitation job count */
int cmd_qxjc (dg87_connection * connection);

#endif /*__DG87_CMD_QUEUE_d_H__*/

/* End of file */
